2026-02-24  Rutger van Beusekom  <rutger@dezyne.org>

	script: Add catch all with-exception-handler for any command.
	This is a follow-up to commit
	    script: Add catch all with-exception-handler for any command.
	    2fd73f6c2d0b5554edbeb649457959cb2396e15f

	* dzn/script.scm: Prefix error with "internal error"; use "unknown
	exception" for exceptions without message.

2026-02-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Add ANNOUNCE-2.20.0.
	* doc/announce/ANNOUNCE-2.20.0: New file.

2026-02-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Revert "build: Ignore doc/dezyne.info-{1,2} too."
	With --no-split, this is no longer necessary.

	This reverts commit 7001d352badc332c9a25c75aba36e81748b4c95e.

2026-02-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Do not split info file.
	* Makefile.am (MAKEINFOFLAGS): New variable.

2026-02-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: system_shared: Eradicate.
	* test/all/system_shared/trace: Remove stray file.

2026-02-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Post-release update.
	* Makefile.am (--previous-version): Bump to 2.19.3
	* NEWS (Changes in 2.19.3 since 2.19.2): Typo.

	guix: dezyne: Update to 2.20.0.rc0.
	* guix/pack/dezyne.scm (dezyne): Update to 2.20.0.rc0.

2026-01-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `NEWS'.
	* NEWS (Changes in 2.20.0 since 2.19.2): New section.
	(Changes in 2.19.3 since 2.19.3): Typo.

2025-11-26  Rutger van Beusekom  <rutger@dezyne.org>

	doc: Update `ROADMAP':
	* ROADMAP (Release 2.20): Move `shoaw defer skip, function call...' to...
	(Release 2.21): ...here.  Add wip-lookup.
	(Release 2.20): Remove.
	(Release 2.25): Add port parameters.  Deprecate injected.

2026-02-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Ignore doc/dezyne.info-{1,2} too.
	* .gitignore: Use /doc/dezyne.info*.

2026-01-16  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Revert "Deprecate injection."
	Injection is used for more than only a poor man's foreign function
	replacement, notably:

	  * stateful behavior

	Until there is a better solution for those, let's keep injected.

	This reverts commit d0a84c438d485924b6e4b1c341da194db0e2d401.

2025-12-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Deprecate injection.
	* dzn/ast/wfc.scm (wfc <port>): Add deprecation warning.
	* doc/dezyne.texi (Integrating C++ Code): Add note about deprecation.
	(Injection): Likewise.
	(Systems): Likewise.
	(Using Injection): Likewise.
	* test/all/parse_port_qualifier/baseline/verify.err,
	test/all/wf_bindingRequiredWildcard/baseline/verify.err,
	test/all/wf_injectionOutEvent/baseline/verify.err: Update baseline.
	* doc/parse/binding-two-wildcards.texi,
	doc/parse/binding-wildcard-requires.texi,
	doc/parse/injected-with-out-event.texi: Update accordingly.

2026-01-16  Rutger van Beusekom  <rutger@dezyne.org>

	wfc: Simplify and fix defined-function.
	* dzn/ast/wfc.scm (defined-function): Use ast:lookup via .function to
	determine if the call can be resolved.

2026-01-29  Rutger van Beusekom  <rutger@dezyne.org>

	doc: Document the foreign aspect of foreign functions.
	* doc/dezyne.texi (Functions): Describe the non-determinstic semantics
	of calling foreign functions.

2026-01-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add foreign_function_space_function.
	* test/all/foreign_function_space_function: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2026-01-12  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add foreign_function_shadow_event.
	* test/all/foreign_function_shadow_event: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2026-01-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add space.foreign_functions.
	* test/all/space.foreign_functions: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2025-12-22  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_foreign_function_bool_state.
	* test/all/hello_foreign_function_bool_state: New test.
	test/all/local.mk (FEATURE_TESTS): Register it.

2025-12-23  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Always pass bahavior state to foreign function.
	* dzn/code/scmackerel/makreel.scm: (makreel:process-formals): Add
	missing model parameters to global function process.

2026-01-05  Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_data_assign.
	* test/all/hello_data_argument/hello_data_assign.dzn:
	* test/all/local.mk (FEATURE_TESTS): Add it.
	* test/all/hello_data_assign/META: Add reply-data feature.

2026-01-26  Rutger van Beusekom  <rutger@dezyne.org>

	vm: Make a foreign call deterministic.
	* dzn/vm/run.scm (foreign-call?): New procedure ...
	(non-deterministic?): ... use here to ignore pcs with
	<postponed-match> status caused by a foreign call.

	vm: Remove redundant sut prefix from end-of-trail labels.
	* dzn/vm/util.scm (end-of-trail-labels): Do not redundantly add the
	"sut." prefix to end-of-trail labels when the instance is the sut.

2026-01-25  Rutger van Beusekom  <rutger@dezyne.org>

	normalize: Add support for foreign functions.
	* dzn/ast/normalize.scm (add-function-return): Handle foreign functions.

2025-11-25  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_foreign_function_data_space.
	* test/all/hello_foreign_function_data_space: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

2025-10-13  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_foreign_function_data.
	* test/all/hello_foreign_function_data: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

2025-12-10  Rutger van Beusekom  <rutger@dezyne.org>

	vm: Expand return "*" to all values.
	* dzn/vm/step.scm (step <return>): Return a list of pcs for each return
	value.

	vm: Refactor to avoid unnecessary eval.
	* dzn/vm/step.scm (step <call>): Use let value.

2025-12-07  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_foreign_function_enum_space.
	* test/all/hello_foreign_function_enum_space: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

2025-12-06  Rutger van Beusekom  <rutger@dezyne.org>

	peg: Add function and prototype to namespace.
	* dzn/parse/peg.scm (peg:parse): Cater for prototype.

2025-12-03  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Forward declare foreign functions.
	* dzn/code/scmackerel/c++.scm (c++:global-function->statements):
	Generate prototype for function without a compound statement.

2025-10-03  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_foreign_function_int.
	* test/all/hello_foreign_function_int: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

	test: Add hello_foreign_function_enum.
	* test/all/hello_foreign_function_enum: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

2025-09-30  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_foreign_function_bool.
	* test/all/hello_foreign_function_bool: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

2025-12-10  Janneke Nieuwenhuizen  <janneke@gnu.org>

	config: Add "foreign_function" feature.
	* dzn/config.scm.in (%feature-alist): Add "foreign_function".
	* test/dzn/dzn.scm (file-name->features): Check for it.

2025-12-06  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Implement return *;
	* dzn/code/scmackerel/makreel.scm: (makreel:return->value): Refactor
	arguments ...
	(ast->process): ... to match usage here; implement * as a
	non-determinstic sum.

2025-12-03  Rutger van Beusekom  <rutger@dezyne.org>

	wfc: Handle foreign functions, i.e., without statement.
	* dzn/ast/wfc.scm (wfc-function): Do not check the statement of an
	foreign function.
	(missing-return): Skip missing return check for foreign functions.

2025-12-02  Rutger van Beusekom  <rutger@dezyne.org>

	ast: Cater for prototype.
	* dzn/ast/parse.scm: (parse:tree->ast): Add the case for prototype and
	from it create a function with a return * statement.

2025-12-01  Rutger van Beusekom  <rutger@dezyne.org>

	peg: Allow the prototype of a function to be declared.
	* dzn/parse/peg.scm: (peg:parse): Add prototype production rule; add it
	to global definitions.
	* test/all/parse-flags/baseline/parse.err,
	test/all/parse_fall_back_import_path/baseline/verify.err,
	test/all/parse_fall_back_out_binding_argument/baseline/verify.err,
	test/all/parse_fall_back_preprocessed_foo/baseline/verify.err,
	test/all/parse_fall_back_preprocessed_imported_bar/baseline/verify.err,
	test/all/parse_fall_back_preprocessed_imported_baz/baseline/verify.err,
	test/all/parse_fall_back_syntax/baseline/verify.err,
	test/all/parse_import_end/baseline/verify.err,
	test/all/parse_import_path/baseline/verify.err,
	test/all/parse_preprocessed_foo/baseline/verify.err,
	test/all/parse_preprocessed_imported_bar/baseline/verify.err,
	test/all/parse_preprocessed_imported_baz/baseline/verify.err,
	test/all/parse_syntax/baseline/verify.err: Add prototype to parse
	error in baseline.

2025-11-25  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add LTS based testing.
	* test/dzn/dzn.scm (run-lts-test): New procedure to generate and run an
	i/o-lts on an executable.
	(run-code): Use it.

	test: New command.
	* dzn/commands/test.scm: New file.
	* dzn/commands/local.mk (dist_%C%_scm_DATA): Add it.
	* dzn/test.scm: New file.
	* dzn/local.mk (dist_%C%_scm_DATA): Add it.
	* doc/dezyne.texi (Invoking dzn test): Document it.

	lts: Extend lts command with input output LTS generation.
	* dzn/lts.scm (i/o-lts): New procedure that prefixes LTS labels with in
	and out.
	* dzn/commands/lts.scm (main): Add i/o-lts option.

	pipe: Remove draining stderr.
	* dzn/pipe.scm (pipeline*): Do not read from child stderr.

	verify: Make stderr line buffered.
	* dzn/commands/verify.scm (main): Set buffering on stderr to 'line.

	trace: Add illegal as expected output.
	* dzn/trace.scm (trace-parse): Parse <illegal>.
	(<illegal>): Add record.
	(step->communication): Instantiate record here.
	(illegal->string): New procedure.
	(step->code, step->event): Use it.
	(steps->trail): Include <illegal>.

	runtime: c++: Ready for lts testing.
	* runtime/c++/dzn/pump.hh (struct pump): Add member and corresponding
	ctor parameter with default initialization.
	* runtime/c++/pump.cc (pump::wait): Use it to enable waiting for
	pending timers.

2026-02-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	c: Add include guard for global functions.
	* dzn/code/scmackerel/c.scm (c:include-guard): Cater for global function.
	(c:global-function->header-statements): New procedure.
	(root->header-global-functions): Use it in new procedure.
	(root->header-statements): Use it.

	test: c++: Use -Wredundant-decls.
	* test/lib/build.c++.make (WARN_FLAGS): ADd -Wredundant-decls.

2026-01-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	c++: Add include guard for global functions.
	* dzn/code/scmackerel/c++.scm (c++:include-guard): Cater for function guard.
	(c++:global-function->statements): New procedure, factored-out from...
	(root->global-functions): ...here.
	(c++:global-function->header-statements function): New procedure.
	(root->header-global-functions): New method.
	(root->header-statements): Use it.
	(print-header-ast): Remove root->header-statements.

	ast: Fix ast:full-name for functions.
	* dzn/ast/accessor.scm (ast:full-name <function>): New specialization.

2026-02-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	c++: Have a global function generate a compilation unit.
	* dzn/code/language/c++.scm (c++:generate-source?): Also create a
	compilation unit for a global function.

2025-01-16  Rutger van Beusekom  <rutger@dezyne.org>

	doc: Document global functions.
	* doc/dezyne.texi (Dezyne Files): Add global function.
	(Functions): Document global functions.

	doc: Reword functions to functionality in patches.
	* doc/dezyne.texi (Introduction): Reword functions to functionality in
	patches.

2025-03-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Typo.
	* doc/dezyne.texi (Invoking dzn): Use `-t' as short option of `--transform'.

2026-01-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add space.function.
	* test/all/space.function: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-10-09  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add global_function_space.
	* test/all/hello_global_space_function: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2026-01-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	scheme: Support function call for component in nampsace.
	* dzn/templates/scheme/functions@function: Use x:model-full-name instead
	of x:model-name.

2025-11-09  Rutger van Beusekom  <rutger@dezyne.org>

	code: Prefix global function calls with namespace.
	* dzn/code/scmackerel/code.scm (ast->namespace): New procedure.
	(ast->code <call>): Use it.

	peg: Allow global function in namespace.
	* dzn/parse/peg.scm (peg:parse): Add function to namespace-root; guard
	enum-literal with !call to global function in namespace

2025-03-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add support for dzn-flags in META.
	* test/dzn/dzn.scm (dzn-flags): New procedure.
	(run-verify, run-code, run-traces, run-constrained-component,
	run-constrained-no-compliance, run-simulate-trace, run-lts): Use it.

	command-line: Cater for multi-options on dzn.
	* dzn/command-line.scm (dzn:command-line:get): Consider multi-options.

2026-01-19  Rutger van Beusekom  <rutger@dezyne.org>

	test: Refactor and add missing cases to unreachable_function.
	* test/all/unreachable_function/unreachable_function.dzn: Add bool
	functions and call in combination with and/or expressions.

2025-01-22  Paul Hoogendijk  <paul@dezyne.org>

	test: Add global_function_shadow.
	* test/all/global_function_shadow: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	test: Add global_function_chain.
	* test/all/global_function_chain: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2024-11-03  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_global_function.
	* test/all/hello_global_function: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

2026-01-06  Rutger van Beusekom  <rutger@dezyne.org>

	config: Add "global_function" feature.
	* dzn/config.scm.in (%feature-alist): Add global function.
	* test/dzn/dzn.scm (file-name->features): Check for it.

2025-12-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	c: Support global function.
	* dzn/code/scmackerel/c.scm (ast->code <call>): Cater for global function.
	(function->function): New procedure.
	(root->global-functions): Use it in new method.
	(print-header-ast): Use it.
	(print-code-ast): Likewise.

	javascript: Support global-function.
	* dzn/templates/javascript/expression@call,
	dzn/templates/javascript/source@root: Cater for global function.
	* dzn/templates/javascript/global-function@function,
	dzn/templates/javascript/this@model,
	dzn/templates/javascript/this@root: New files.

	scheme: Support global-function.
	* dzn/code/language/scheme.scm (scheme:exported-names): Cater for global function.
	* dzn/code/legacy/code.scm (code:global-functions): New method.
	(code:this <call>): New specialization.
	* dzn/templates/code.scm (function-name, this): New templates.
	* dzn/templates/scheme/expression@call:
	dzn/templates/scheme/global-function@function: Cater for global function.
	* dzn/templates/scheme/this@model,
	dzn/templates/scheme/this@root: New files.

2025-12-12  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	c++: Support global function.
	* dzn/code/scmackerel/c++.scm (c++:->formal): Cater for out-parameters.
	(ast->code <action>): Cater for global function.
	(root->global-functions): New method.
	(root->statements, print-header-ast): Use it.
	* dzn/code/scmackerel/code.scm (ast->code <call>): Cater for global function.

2025-01-21  Paul Hoogendijk  <paul@dezyne.org>

	makreel: Fix crash for local variables in global functions.
	* dzn/code/language/makreel.scm (makreel:member*): Cater for global
	function.

2025-11-09  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Generate processes for called global functions.
	* dzn/code/language/makreel.scm (calls:direct->direct+indirect): New
	procedure.
	(makreel:call-continuation*-unmemoized): Use it.
	* dzn/code/scmackerel/makreel.scm (%return-type): Add global functions.
	(model->scmackerel): Update accordingly.
	* (interface->scmackerel-unmemoized): Update accordingly.  Generate
	makreel infrastructure consistently for functions and returns,
	(return-processes): Make sure there is always a return process.
	(%return-type): Make sure there is always a void return type.
	* dzn/ast.scm (ast:recursive?): Use eq? instead of ast:name-equal?.
	* dzn/ast/recursive.scm (set-called?): Compare the function's locations
	instead of using ast:name-equal?

2026-01-19  Rutger van Beusekom  <rutger@dezyne.org>

	accessor: Add ast:function* specialization for <interface>.
	* dzn/ast/accessor.scm (ast:function* <interface>): Add missing
	specialization.

2025-11-07  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Refactor model parameter for global function support.
	* dzn/code/language/makreel.scm (%model-name): Rename to %model and
	store actual as opposed to just the name of the model.
	(makreel:get-model, makreel:init): Refactor using %model.
	(makreel:call-continuation*): Derive behavior from %model for global functions.
	* dzn/code/scmackerel/makreel.scm (%model-name): Implement as procedure
	using %model.
	(statement->process-name, ast->process, function->processes): Make model
	explicit using %model.
	(model->scmackerel, port-processes): Set %model.

2025-01-27  Paul Hoogendijk  <paul@dezyne.org>

	makreel: Add function name to first process of function.
	* dzn/code/scmackerel/makreel.scm (statement->process-name <ast>): Add
	function name.
	(statement->process-name <model>): Likewise.

2025-11-24  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	makreel: Add global functions.
	* dzn/ast/lookup.scm (.function): Remove overload with <model>;
	generalize lookup to find function by name anywhere.
	* dzn/ast/normalize.scm (add-temporary): Support global functions in
	add-temporary.
	* dzn/code/language/makreel.scm (dzn): Remove makreel:called-function*.
	(reachable, reachable-calls-unmemoized, reachable-calls, is-called?,
	markeel:called-function*): Remove.
	(makreel:call-continuation*-unmemoized): Update Accordingly.
	(makreel:process-identifier): Use provided model parameter for global
	functions.
	* dzn/code/scmackerel/makreel.scm (statement->process-name <model>):
	New specialization.
	(ast->process <call>): Use it.
	(%return-type): Ignore expression functions.
	(interface->scmackerel-unmemoized, model->scmackerel): Use
	ast:function* and ast:function** instead of makreel:called-function*.
	* test/all/parse-flags/baseline/parse.err,
	test/all/parse_fall_back_import_path/baseline/verify.err,
	test/all/parse_fall_back_out_binding_argument/baseline/verify.err,
	test/all/parse_fall_back_preprocessed_foo/baseline/verify.err,
	test/all/parse_fall_back_preprocessed_imported_bar/baseline/verify.err,
	test/all/parse_fall_back_preprocessed_imported_baz/baseline/verify.err,
	test/all/parse_fall_back_syntax/baseline/verify.err,
	test/all/parse_import_end/baseline/verify.err,
	test/all/parse_import_path/baseline/verify.err,
	test/all/parse_preprocessed_foo/baseline/verify.err,
	test/all/parse_preprocessed_imported_bar/baseline/verify.err,
	test/all/parse_preprocessed_imported_baz/baseline/verify.err,
	test/all/parse_syntax/baseline/verify.err: Update error with function
	at root level.

2026-01-26  Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Rutger van Beusekom  <rutger@dezyne.org>

	peg: Allow functions in root, aka global functions.
	* dzn/parse/peg.scm (peg:parse): Allow functions at root level.

2025-11-07  Rutger van Beusekom  <rutger@dezyne.org>

	lookup: Remove redundant code.
	* dzn/ast/lookup.scm (search-unmemoized): Remove unused statement.

2025-11-24  Rutger van Beusekom  <rutger@dezyne.org>

	wfc: Add global functions.
	* dzn/ast/wfc.scm (defined-function): Add support for global functions.
	(call-context): Do not handle a call to an unknown function as valued.
	* test/all/wf_undefined_function/baseline/verify.err: Update baseline.
	* dzn/ast/wfc.scm (wfc <root>): Also check global functions.

2025-11-07  Rutger van Beusekom  <rutger@dezyne.org>

	ast: Move ast:function* overload for <function>.
	* dzn/ast.scm: (ast:recursive?): Here and rename to
	function->called-functions; add comment.

2025-09-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	accessor: Add function**.
	* dzn/ast/accessor.scm (ast:function**): New method.
	* dzn/ast.scm: Re-export it.

2025-12-10  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Refactor.
	* dzn/code/scmackerel/c++.scm (ast->code): Remove unused let values.

2025-01-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	peg: Use compound-name for <call>.
	This prepares for a call to a global function defined in a namespace.

	* dzn/parse/peg.scm (peg:parse): Use compound-name for <call>.
	* dzn/parse/tree.scm (.name): Update accordingly.
	* dzn/ast/wfc.scm (defined-function): Refactor, use ast:name-equal? and
	ast:name.
	* dzn/code/language/makreel.scm (is-called?): Use ast:name-equal?.
	(tick-names-): Tick function's <scope.name>.
	* test/dzn/language.scm ("component-incomplete-port after behavior",
	"component-incomplete-port behavior end"): Remove expected failure
	marking.
	* dzn/code/scmackerel/code.scm (ast->code <call>): Use ast:name.
	* dzn/code/scmackerel/cs.scm (ast->code <call>): Likewise.
	* dzn/code/language/dzn.scm (print-ast <function>, print-ast <call>):
	* dzn/code/scmackerel/c.scm (ast->code): Use ast:name.
	* dzn/templates/javascript/expression@call,
	dzn/templates/scheme/expression@call: Update accordingly.
	* test/all/code-json/baseline/parse.out,
	test/all/parse_function_shadow_event/baseline/verify.err: Update
	baseline.

2025-09-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Have ast:equal? cater for scope.name.
	* dzn/ast/equal.scm (ast:name-equal? <named> <scope.name>): New
	specialization.
	(ast:name-equal? <scope <named>.name>): Use it in new specialization.

	ast: Extend ast:empty-namespace?.
	* dzn/ast/equal.scm (ast:empty-namespace? <scope.name>): New specialization.

2025-02-17  Paul Hoogendijk  <paul@dezyne.org>

	wfc: Report undefined port correctly.
	* dzn/ast.scm (ast:wildcard? <ast>): New specialization.

2025-12-31  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Throw on unset %context.
	* dzn/ast/context.scm (ast:memoize-context): Assert %context.
	(ast:context): Likewise.

2025-01-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Avoid language-specific wfc errors.
	* dzn/commands/parse.scm (main): Set %language to "dzn".

2023-07-25  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Refactor tree-collect-filter using ast:keyword+child*.
	* dzn/ast/util.scm (tree-collect-filter <ast>): Change to...
	(tree-collect-filter <object): ...this, and refactor.
	(tree-collect-filter <ast-list>): Remove.

2024-02-10  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Refactor tree-find using ast:keyword+child*.
	* dzn/ast/util.scm (tree-find <ast>): Change to...
	(tree-find <object): ...this, and refactor.
	(tree-find <pair>): Change to...
	(tree-find <top>: ...this, and refactor.

2023-07-25  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Refactor tree-map using ast:keyword+child*.
	* dzn/ast/util.scm (tree-map <ast>): Change to...
	(tree-map <object): ...this, and refactor.
	(tree-map <ast-list>, tree-map <namespace>, tree-map <root>): Remove.

	ast: Refactor deep-clone using ast:keyword+child*.
	* dzn/ast/util.scm (deep-clone <ast>): Change to...
	(deep-clone <object): ...this, and refactor.
	(deep-clone <pair>): Remove.

	ast: Refactor keyword-values+mutate using ast:keyword+child*.
	* dzn/ast/util.scm (ast:keyword+child*, ast:child*): Local imports.
	(keyword-values+mutate?): Use them to refactor.

	ast: Add ast:keyword+child*.
	* dzn/ast/context.scm (ast:keyword+child*): New method, factored-out
	from...
	(ast:child*): ...here.

2023-07-24  Janneke Nieuwenhuizen  <janneke@gnu.org>

	goops: Remove ast:inevitable, ast:optional.
	* dzn/ast/goops.scm (ast:inevitable, ast:optional): Remove.

2025-09-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Revert "Use perfect-funcq instead of ast:perfect-funcq."
	This reverts commit 4a44280f6eda99e942db045fc2c00be994d11ccd.

2023-07-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Use perfect-funcq instead of ast:perfect-funcq.
	* dzn/ast/lookup.scm (ast:funcq, ast:pure-funcq, ast:perfect-funcq):
	Move to...
	* dzn/misc.scm (funcq, pure-funcq, perfect-funcq): ...here.  Update
	callers throughout.

	ast: Eradicate ast:eq?.
	* dzn/ast/equal.scm (ast:eq?): Remove.
	* dzn/ast.scm
	dzn/ast/lookup.scm,
	dzn/ast/normalize.scm,
	dzn/ast/wfc.scm,
	dzn/code.scm,
	dzn/code/language/c.scm,
	dzn/code/language/dzn.scm,
	dzn/code/language/makreel.scm (makreel,
	dzn/code/scmackerel/c++.scm (system->sm,
	dzn/code/scmackerel/c.scm,
	dzn/code/scmackerel/cs.scm,
	dzn/code/scmackerel/makreel.scm (makreel,
	dzn/explore.scm,
	dzn/simulate.scm,
	dzn/transform.scm ,
	dzn/verify/pipeline.scm (mcrl2,
	dzn/vm/compliance.scm,
	dzn/vm/evaluate.scm,
	dzn/vm/report.scm,
	dzn/vm/run.scm,
	dzn/vm/runtime.scm,
	dzn/vm/step.scm,
	dzn/vm/util.scm ,
	test/dzn/ast.scm: Remove callers.

	ast: Eradicate ast:node-eq?.
	* dzn/ast/equal.scm (ast:node-eq?): Remove.
	(ast:eq?): Remove caller.
	(ast:equal?): Likewise.
	* dzn/vm/evaluate.scm (expr:equal?): Likewise.

2023-07-24  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add ast unit test.
	* test/dzn/ast.scm: New file.
	* test/dzn/local.mk (UNIT_TESTS): Add it.

2023-08-04  Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Rutger van Beusekom  <rutger@dezyne.org>

	ast: Use %context instead of <ast-node> and <ast> wrapping.
	Use parameterized hash-table from pointer to context: (ast ancestor-0
	...  ancestor-n root) for parent lookups, in new %context parameter.

	Throughout, replace (clone ... #:parent) with (graft ...).

	* dzn/ast/goops.scm (define-ast): Create <ast>s, instead of <ast-node>s.
	Export <ast> and accessors.
	(<ast>)[node, parent]: Remove fields.
	[comment]: Move field from...
	(<ast-node>): ...here.  Remove type.
	(.elements <ast-list>): Remove specialization.
	(initialize <root-node>): Change to...
	(initialize <root>): ...this.
	(.id <ast>): Remove specialization.
	(construct): Remove procedure.
	(node-class, ast:unwrap, make-wrapper, get-parent, make-instance):
	Remove methods.  Update class definitions accordingly.

	* dzn/ast/parse.scm (parse:tree->ast): Create <ast>s, instead of
	<ast-node>s.
	* dzn/ast/context.scm: New file.
	* dzn/ast/local.mk (dist_%C%_scm_DATA): Add it.
	* dzn/parse.scm (parse:annotate-ast): Set first %contexts using
	ast:memoize-context.  Use with-root with silence annotation.

	* dzn/simulate.scm (simulate*): Likewise.
	* dzn/vm/normalize.scm (vm:normalize): Likewise.
	* dzn/code.scm (code:normalize-, code:normalize+determinism): Likewise.
	* dzn/code/language/cs.scm (cs:normalize): Likewise.
	* dzn/code/language/makreel.scm (makreel:normalize): Likewise.
	* dzn/code/language/scheme.scm (scheme:normalize): Likewise.
	* dzn/commands/parse.scm (parse): Likewise.
	* dzn/code/language/json.scm (system-diagram): Likewise.
	(json:get-fields <ast-node>): Change to...
	(json:get-fields <ast>): ...this.
	(json:elements <ast-list-node>): Change to...
	(json:elements <ast-list>): ...this.

	* dzn/ast/util.scm (clone-base): Rename to...
	(keyword-values+mutate?): ...this.
	(clone-top, clone): Rewrite to use it; always create new object to avoid
	creating joins in the AST.
	(clone-base-unwrap, clone-base-node, clone-base-ast, clone <ast-node>):
	Remove methods.
	(deep-clone): Rename to...
	(deep-copy): ...this.
	(deep-copy*, graft, graft*): New methods.
	* dzn/ast/display.scm (ast-name <ast-node>):
	(sdisplay <ast-node>): Change to...
	(sdisplay <ast>): ...this.
	(sdisplay <location-node>): Change to...
	(sdisplay <location>): ...this.
	(write <ast-node>): Remove specialization.
	* dzn/ast/equal.scm (ast:node-eq?): Refactor without .node.

	* dzn/ast.scm (trigger-in-component): Remove.
	(port+event->trigger): Refactor accordingly.
	(ast:event->trigger): New method, factored-out from...
	(ast:in-triggers): ...here.
	(ast:argument->formal): Update for removal of .node.

	* dzn/commands/code.scm (main): Parameterize %context.
	* dzn/commands/graph.scm (main): Likewise.
	* dzn/commands/simulate.scm (main): Likewise.
	* dzn/commands/traces.scm (main): Likewise.
	* dzn/commands/verify.scm (main): Likewise
	* dzn/code.scm (code:shared-lts-unmemoized, code:shared-lts): Likewise.

	* dzn/templates/json/source@root-node: Rename to...
	* dzn/templates/json/source@root: ...this.  Update to use value@ast.
	* dzn/templates/json/value@ast-node: Rename to...
	* dzn/templates/json/value@ast: ..this.

	* dzn/code/language/json.scm (json:ast-name): Remove code that blindly
	attempts to drop the now non-existent `-node' suffix.

2023-07-19  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add function_if.
	Test for add-tag normalization.

	* test/all/function_if/function_if.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2023-07-17  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add hello_function_arguments.
	* test/all/hello_function_arguments/hello_function_arguments.dzn: New file.
	* test/all/local.mk (HELLO_TESTS): Add it.

2023-07-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Hide node/wrapper details in. display.
	This makes <ast-node> vs <ast> wrapper debugging *much* harder,
	but it makes comparison with wip-parent output much easier.

	* dzn/ast/util.scm (ast-name <ast-node>): New specialization.
	* dzn/ast/serialize.scm (serialize <object>): Update accordingly.
	* dzn/code/language/json.scm (json:ast-name): Update accordingly.
	* dzn/ast/display.scm (write <ast>): Drop second `*'.
	* dzn/ast/serialize.scm (serialize <object>): Do not call...
	(serialize-name): ...this procedure;  Remove.
	* test/all/parse_locations/baseline/parse.out,
	test/all/parse-flags/baseline/parse.out: Update baseline.

2023-07-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Respect parse tree skip in ast.
	* dzn/ast/parse.scm (parse:tree->ast): For 'skip in tree, create <skip-node>,
	instead of <compound-node>.
	* dzn/ast.scm (ast:add-statement): Cater for <skip>.
	* doc/parse/mixing-declarative.texi: Update accordingly.

2023-07-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	normalize: Use canonical-ons->on for normalize:event, drop <triple>.
	* dzn/ast/normalize.scm (<triple>): Remove type.
	(write-triple, canonical-on->triple): Remove procedures.
	(triples:->on-guard*): Replace with...
	(sort-canonical-ons): ...this new procedure, and...
	(canonical-ons->on): ...this new method.

	normalize: Use canonical-on->guard for normalize:state.
	* dzn/ast/normalize.scm (triples:->compound-guard-on): Replace with...
	(statement->canonical-on): ...this new method.
	(normalize:state, normalize:state+illegals, simplify-guard-expressions):
	Update accordingly.

	normalize: Use group-expressions on <canonical-on>.
	* dzn/ast/normalize.scm (triples:group-expressions): Remove.
	(group-expressions): Cater for canonical-on.
	(normalize:state, normalize:state+illegals, normalize:event,
	normalize:event+illegals, simplify-guard-expressions): Use
	group-expressions on <canonical-on>.

2023-07-07  Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Rutger van Beusekom  <rutger@dezyne.org>

	normalize: Use simplify-guard on <canonical-on>.
	* dzn/ast/normalize.scm (triples:simplify-guard): Replace with...
	(simplify-guard <canonical-on>): ...this new specialization.
	(normalize:state, normalize:state+illegals, normalize:event,
	normalize:event+illegals): Update accordingly.

	normalize: Rewrite alpha-rename with <canonical-on>.
	* dzn/ast/normalize.scm (rewrite-formals-and-locals): Replace with...
	(alpha-rename): ...this new method.
	(normalize:event, normalize:event+illegals): Update accordingly.

2023-08-01  Rutger van Beusekom  <rutger@dezyne.org>

	code: Eradicate use of code:on -- partly.
	* dzn/code/scmackerel/c++.scm (component-model->sm:statements-unmemoized),
	* dzn/code/scmackerel/cs.scm (component-model->statements):
	Use ast:parent now that ast:in-triggers returns behavior triggers.
	* dzn/code.scm (code:on): Add TODO.

	ast: Implement ast:in-triggers for <component> with tree-collect.
	* dzn/ast.scm (ast:in-triggers <component>): New specialization
	implement with tree-collect instead of synthesized triggers.
	* dzn/ast/normalize.scm (implicit-illegals->explicit-illegals): Remove
	dependency on old ast:in-triggers implementation.

2023-07-06  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	normalize: Rewrite implicit->illegals->explicit-illegals with <canonical-on>.
	* dzn/ast.scm (ast:in-triggers): Set parent to behavior.
	* dzn/ast/normalize.scm (trigger-equal?): Remove.
	(make-declarative-illegal/illegal): New procedure.
	(add-illegals): Replace with...
	(implicit-illegal->explicit-illegal): ...this new method.
	(triples:add-illegals): Replace with...
	(implicit-illegals->explicit-illegals): ...this new method.
	(normalize:state+illegals, normalize:event+illegals): Update
	accordingly.

	normalize: Rewrite add-void-reply, add-the-end with <canonical-on>.
	* dzn/ast/normalize.scm (triples:mark-the-end): Replace with...
	(add-the-end): ...this, and...
	(add-void-reply): ...this.
	(normalize:state+illegals): Update accordingly.

2023-07-06  Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Rutger van Beusekom  <rutger@dezyne.org>

	normalize: Rewrite illegal->declarative-illegal with <canonical-on>.
	* dzn/ast/normalize.scm (triples:declarative-illegals model): Replace with...
	(illegal->declarative-illegal): ...this new method.
	(normalize:state+illegals): Update accordingly.

	normalize: Use <canonical-on> to create triples.
	* dzn/ast/normalize.scm (triples:->triples, triples:split-multiple-on):
	Replace with...
	* dzn/ast/normalize.scm (statement->canonical-on, canonical-on->triple):
	...these new methods.
	(normalize:state, normalize:state+illegals, normalize:event,
	normalize:event+illegals, simplify-guard-expressions): Update
	accordingly.

2023-07-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	goops: Add <canonical-on>.
	* dzn/ast/goops.scm (<canonical-on>): New type.
	* dzn/code/language/dzn.scm (print-ast <canonical-on>): New method.
	* dzn/ast/accessor.scm (ast:trigger* <canonical-on>): New
	specialization.
	* dzn/ast/lookup.scm (ast:lookup-variable): Cater for <canonical-on>.

2026-02-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Update to 2.19.3.
	* guix/pack/dezyne.scm (dezyne): Update to 2.19.3.

2025-09-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `NEWS'.
	* NEWS (Changes in 2.19.3 since 2.19.2): New section.

2025-11-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `ROADMAP'.
	* ROADMAP (Release 2.20): Use Foreign Functions.  Introduce
	wip-lts-test.
	(Release 2.24): Update accordingly.

2026-02-19  Rutger van Beusekom  <rutger@dezyne.org>

	script: Add catch all with-exception-handler for any command.
	* dzn/script.scm (main): Prevent exceptions to escape causing a
	backtrace unless --debug or exit/quit.

2026-02-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Fixes for out-of-source build.
	* Makefile.am (bin/%): Depend on bin-dir.
	(bin-dir): New target.
	(dzn/%): Depend on dzn-dir.
	(dzn-dir): New target.
	GUILEC_FLAGS: Also add --load-path to build dir.
	(do_subst): Also substitute @abs_top_srcdir@, @abs_top_builddir@,
	@srcdir@, @builddir@.
	* build-aux/pre-inst-env.in (PATH): Add $abs_top_builddir/test/bin.
	* runtime/local.mk (%C%_libdzn_la_CPPFLAGS): Also include builddir.
	(%C%_libdzn_c___la_CPPFLAGS): Likewise.
	* dzn/config.scm.in (%builddir): New variable.
	(%bindir): Use it.
	(%srcdir): New variable.
	* test/dzn/dzn.scm (run-build): Use it.

2026-02-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	runtime: c++: Whitespace nitpicks.
	* runtime/c++/dzn/context.hh: Use && debug, instead of &&debug.
	* runtime/c++/pump.cc: Likewise.

2026-02-09  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Remove warnings.
	* runtime/c++/dzn/container.hh (container): Rename lookup parameter to l
	to avoid shadowing member variable.
	* runtime/c++/dzn/runtime.hh (=): Rename event to event_wrapper to avoid
	shadowing struct name and constructor(s); rename port_update to
	port_update_wrapper to avoid shadowing port_update member function; add
	parentheses around &&.

2026-02-04  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Remove unnecessary shadowing pointer variable.
	* runtime/c++/dzn/runtime.hh (=): Remove local variable.

2026-01-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Fix updating of test/bin scripts.
	* Makefile.am (noinst_SCRIPTS): New variable.

2026-01-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add list-models.
	* test/all/list-models: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2026-01-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Have list-models work on incorrect Dezyne files.
	This is a follow-up to commit
	    0f42b4f1d226ea1c17e23e7c27f1e8ce8c9f3ff6
	    parse: Split-off list-models.

	* dzn/parse/util.scm (list-models-name+type): Use
	parse:call-with-handle-exceptions, as in 2.18.

2026-01-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	dzn: Also print behavior <invariant> (after normalize).
	* dzn/code/language/dzn.scm (print-ast <behavior>): Print <invariant>,
	if set.

2026-01-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	dzn: Cater for expression functions.
	* dzn/code/language/dzn.scm (dzn:statement?): Do not identify a call
	in a guard-expression to be a statement.

2026-01-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	dzn: When -d,--debug, set stack-trace depth to 40.
	* dzn/script.scm (main): When 'debug set, debug-set! depth to 40.

2026-01-17  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: dzn: Fix printing of scoped types.
	* dzn/code/language/dzn.scm (dzn:full-name): Add model parameter.
	(dzn:dotted-name): Likewise.
	(print-ast, print-type): Update callers.

	code: dzn: Add catch-all for print-type.
	* dzn/code/language/dzn.scm (print-type <top>): New specialization.

2026-01-17  Janneke Nieuwenhuizen  <janneke@gnu.org>

	tree: Use negation instead of not.
	This is a follow-up to commit
	    1c8c50a062a9830e8f152291ae18be494530a1fb
	    peg: Replace not with negation to prevent collision.

	* dzn/parse/tree.scm (tree:record): Replace 'not by 'negation.

2026-01-16  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Allow multiple pump waiters.
	* runtime/c++/pump.cc (pump::operator ()): Use notify_all to wake up
	all waiters.

2026-01-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add parse_function_shadow_port.
	* test/all/parse_function_shadow_port: New test.
	* test/all/local.mk (PARSER_TESTS): Add it.

2026-01-15  Rutger van Beusekom  <rutger@dezyne.org>

	lookup: Add .type specialization for <function>.
	Fixes function_shadow_port.

	* dzn/ast/lookup.scm (.type <function>): Here.

2026-01-12  Rutger van Beusekom  <rutger@dezyne.org>

	peg: Fix leakage of "symbol table" names.
	Move "symbol table" name reset to end of productions.

	* dzn/parse/peg.scm (peg:parse)[interface]: Remove initial
	reset-event-names, reset-port-name.  Add reset-event-names at the end.
	[component]: Remove initial
	reset-event-names, reset-port-name.  Add reset-port-names at the end.

2026-01-15  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add interface_action_missing_reply.
	* test/all/interface_action_missing_reply/interface_action_missing_reply.dzn,
	test/all/interface_action_missing_reply/trace,
	test/all/interface_action_missing_reply/baseline/simulate.err,
	test/all/interface_action_missing_reply/baseline/simulate.out,
	test/all/interface_action_missing_reply/baseline/verify.err,
	test/all/interface_action_missing_reply/baseline/verify.out: Add it.
	test/all/local.mk: Register it.

	makreel: Fix deadlock when missing_reply after action.
	* dzn/code/scmackerel/makreel.scm (interface-reorder-processes): Move
	missing_reply action to reorder_reply and remove state communication
	from reorder process altogether.

	runtime: c++: Add executing state to pump.
	* runtime/c++/dzn/pump.hh (struct pump)[executing]: New member.
	* runtime/c++/pump.cc (pump::pump): Initialize it.
	(pump::wait): Include executing in the wait condition.
	(pump::operator ()): Add an execute abstraction to worker.

2026-01-12  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	pipe: Display pipeline process failure.
	* dzn/pipe.scm (pipeline->string): Inspect all exit stati and print
	error message upon failure of a process.

2026-01-12  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	pipeline: Respect pipeline failure.
	This implements "fail early" instead of "stumbling on" after an
	unrecoverable error was detected and presenting incomprehensible,
	collateral errors.

	* dzn/verify/pipeline.scm (mcrl2:verify-interface): Call error upon
	pipeline failure.
	(mcrl2:verify-component): Likewise.

2026-01-12  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	lts: Exit gracefully on empty input.
	This implements "fail early" instead of "stumbling on" after an
	unrecoverable error was detected and presenting incomprehensible,
	collateral errors.

	* dzn/commands/lts.scm: Do not continue after receiving null input.

2026-01-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: defer_data: Cater for gcc-14's strictness.
	* test/all/defer_data/main.c (main): Add cast.

2026-01-08  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Respect %no-constraint?.
	* dzn/code/scmackerel/c++.scm (interface->sm:statements-unmemoized):
	Avoid running code:shared-state when %no-constraint?
	* dzn/code/scmackerel/c++.scm (interface->sm:statements-unmemoized):
	Remove dead code.

2025-11-29  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Fix MSVC compiler warnings.
	* runtime/c++/dzn/runtime.hh (to_string): Remove unused parameter t.
	(data): Give parameter a distinct name from the member.

2026-01-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: Generate code for most interesting non-imported model.
	* dzn/code/scmackerel/makreel.scm (root->scmackerel): Filter-out
	imported models before selecting interesting model.

2026-01-20  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Remove unused and erroneous get-model procedure.
	* dzn/code/language/makreel.scm (makreel:get-model (o <root>): Remove.

2025-11-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	dzn: Add explanatory message.
	* dzn/script.scm (parse-opts): Explain what script does.

2025-11-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Move COPYING.AGPL to COPYING.
	* COPYING: Move to...
	* COPYING.GPL: ...this new file.
	* COPYING.AGPL: Move to...
	* COPYING: ...this.
	* Makefile.am (EXTRA_DIST): Update accordingly.

2025-05-17  Janneke Nieuwenhuizen  <janneke@gnu.org>

	anonymize: New command.
	* dzn/parse.scm: Export parse:file->string.
	* dzn/commands/anonymize.scm: Use it in new file.
	* dzn/commands/local.mk (dist_%C%_scm_DATA): Register it.
	* doc/dezyne.texi (Invoking dzn anonymize): New section.

2025-11-25  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Typo.
	* doc/dezyne.texi (Invoking dzn hello): Use "dzn" instead of "ide".

2025-11-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Update to 2.19.2.
	* guix/pack/dezyne.scm (dezyne): Update to 2.19.2.

	doc: Update `NEWS'.
	* NEWS (Changes in 2.19.2 since 2.19.1): New section.

2025-11-10  Rutger van Beusekom  <rutger@dezyne.org>

	doc: Update `NEWS'.
	* NEWS (Changes in 2.19.2 since 2.19.1): New section.

	doc: `NEWS': Fix typos.
	* NEWS: Fix typos throughout.

2025-11-08  Rutger van Beusekom  <rutger@dezyne.org>

	build: Add erpprocess: Extract file-names from pre-processed stream.
	* build-aux/erpprocess.scm: New file.

2025-11-10  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Avoid adding whitespace with each pre-process.
	* dzn/parse.scm (parse:file->stream)[import+content->stream-lines,
	file+content->stream-lines): Make sure that content ends with one and
	only one newline.
	* test/all/parse-flags/baseline/parse.out,
	test/all/parse_locations/baseline/parse.out: Update baseline.

2025-11-07  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add blocking_if_action_in_function.
	* test/all/blocking_if_action_in_function: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-11-06  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Remove makreel:add-action-reply duplication.
	* dzn/code/language/makreel.scm (makreel:add-action-reply): Delegate
	the <compound> case to the inner procedure add-action-reply.

2025-11-05  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Fix add-action-reply normalization.
	* dzn/code/language/makreel.scm: (makreel:add-action-reply): Recurse
	action-reply into statement.

2025-11-11  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Avoid stack trace.
	* dzn/code/scmackerel/makreel.scm (makreel:process-formals): Remove
	<stack> since it will never match (.variable.name o).

	runtime: c++: Add thread_id support for thread based coroutines.
	* runtime/c++/pump.cc (pump::operator ()): Save pump thread_id,
	(pump::create_context): Pass pump thread_id to coroutine.
	* runtime/c++/dzn/coroutine.hh (coroutine): Add thread_id parameter.
	* runtime/c++/coroutine.cc (set_thread_id, get_thread_id): New
	procedures to set and get coroutine thread pump thread_id thread_local
	storage.
	* runtime/c++/dzn/context.hh (set_thread_id, get_thread_id): Forward
	declare new procedures,
	(context): Pass pump thread_id and refactor this->work initialization,
	(call): rename lock2 to c_lock.
	* test/all/shell_injected_foreign/Logger.hh (class Logger): Demonstrate
	dzn::get_thread_id ().

2025-11-10  Rutger van Beusekom  <rutger@dezyne.org>

	test: helloworld_external: Add traces.
	* test/all/helloworld_external/trace0: Add the incomplete trace that
	reports deadlock if queued external events are not eligible.
	* test/all/helloworld_external/trace1: Add the complete trace.

2025-11-18  Rutger van Beusekom  <rutger@dezyne.org>

	simulate: Avoid reporting deadlock when external q not empty.
	Fixes simulate helloworld_external.dzn with trace h.hello.

	* dzn/simulate.scm (event-traces-alist): Add queued external events to
	eligible.

2025-11-08  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add shared_indirect_type.
	* test/all/shared_indirect_type/shared_indirect_type.dzn: Add it.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	lookup: Refactor and fix .type lookup for shared enum-literal.
	* dzn/ast/lookup.scm (.type <enum-literal>): Allow for lookup fallback.

2025-10-30  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add compliance_second_out_action.
	* test/all/compliance_second_out_action: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	compliance: Fix compliance_second_out_action.
	* dzn/vm/compliance.scm (check-provides-compliance): Retain run to
	completion trace.

2025-10-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Also print eligible for immutable invariant.
	* dzn/vm/report.scm (report): Add default '() value for #:eligible.
	* dzn/simulate.scm (end-report, run-trail): Update accordingly to
	suppress undesirable labels and eligble reporting due to report eligible
	keyword parameter default value.
	* test/all/variant_immediately/baseline/simulate.out: Update simulate
	baseline to add missing labels and eligible.

	trace: Cater for missing (eligible).
	* dzn/trace.scm (trace:steps->json): Use '() if eligible is missing.

2025-11-10  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Post-release update.
	* Makefile.am (--previous-version): Bump to 2.19.1.

2025-10-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Update to 2.19.1.
	* guix/pack/dezyne.scm (dezyne): Update to 2.19.1.

2025-10-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `NEWS'.
	* NEWS (Changes in 2.19.1 since 2.19.0): New section.

2025-10-09  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add reachable_expression_function.
	* test/all/reachable_expression_function: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-10-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Fix typo.
	Reported by logocp via IRC.

	* doc/dezyne.texi (Functions): Add missing identifier in
	expression-function definition.

2025-10-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	normalize: Have temporaries skip <expression-function> and <invariant>.
	* dzn/ast/normalize.scm (split-complex-expressions): Skip
	<expression-function> and <invariant>.
	(add-explicit-temporaries): Likewise.

2025-10-07  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add invariant_functions_expression.
	* test/all/invariant_functions_expression: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	simulate: Support expressions of expression functions.
	* dzn/code/language/makreel.scm (makreel:normalize): Inline expression
	functions before introducing explicit temporaries to prevent
	eval-expression from failing.

	verify: Support expressions of expression functions.
	* dzn/code/language/makreel.scm (makreel:normalize): Inline expression
	functions before introducing explicit temporaries to prevent makreel
	code from not expanding expressions to mcrl2.

2025-10-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Also instal interface files for hello, cruise-control.
	* test/all/local.mk (nodist_dzn_example_DATA): Add
	cruise-control-interfaces.dzn, ihello.dzn.

2025-10-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Post-release update.
	* doc/announce/ANNOUNCE-2.19.0: Update checksums, number of commits, fix typos.
	* Makefile.am (--previous-version): Bump to 2.19.0.

	guix: dezyne: Update to 2.19.0.
	* guix/pack/dezyne.scm (dezyne): Update to 2.19.0.

2025-09-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `ROADMAP'.
	* ROADMAP (Release 2.22..2.28): Bump to 2.23..2.29.
	(Release 2.21): Split simulator off to
	(Release 2.22): ...this release.

2025-10-01  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_data_reply.
	* test/all/hello_data_reply/hello_data_reply.dzn,
	* test/all/local.mk (FEATURE_TESTS): Add it.

2025-09-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	makreel: Remove debugging.
	* dzn/code/scmackerel/makreel.scm (makreel:return-variable <ast>,
	makreel:return->value <return>): Fail early: remove catch-all with pke.

2025-09-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	reply_data_full: Remove obsolete META.
	Now that test/dzn/dzn.scm recognizes "reply_data", we no longer need
	this META.

	* test/all/reply_data_full/META: Remove.

2025-09-30  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add reply_data_call_action.
	* test/all/reply_data_call_action: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	test: Add reply_data_action_call.
	* test/all/reply_data_action_call: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	test: Add reply-data as feature.
	* test/dzn/dzn.scm (file-name->features): Cater for "relpy_data" or
	"data_reply" => "reply-data".

	normalize: Reply data support: run add-explicit-temporaries first.
	* dzn/code/language/makreel.scm (makreel:normalize): Move
	add-explicit-temporaries to initial position.
	* dzn/code.scm (code:normalize-): Likewise.
	* dzn/vm/normalize.scm (vm:normalize): Likewise.

2025-09-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	wfc: Fix argument count check for call in action / action in call.
	* dzn/ast/wfc.scm (wfc <arguments>): Use .parent to check immediate
	parent of <arguments>, i.e., <action> or <call>, instead of possibly
	skipping over one of those.

2025-09-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add parameter_shadow_function.
	* test/all/parameter_shadow_function: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	test: parameter_shadow_port: Rename from param_shadow.
	* test/all/param_shadow: Rename to...
	* test/all/parameter_shadow_port: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

2025-09-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Update to 2.19.0.rc1.
	* guix/pack/dezyne.scm (dezyne): Update to 2.19.0.rc1.

2025-09-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `NEWS'.
	* NEWS (2.19.0): Add note about false positive verification deadlocks.

2025-09-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Add ANNOUNCE-2.19.0.
	* doc/announce/ANNOUNCE-2.19.0: New file.

2025-09-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: mcrl2-next: Update to 202507.0.
	* guix/pack/mcrl2.scm (mcrl2-next): Update to 202507.0:

2025-09-23  Rutger van Beusekom  <rutger@dezyne.org>

	misc: Add ppke.
	* dzn/misc.scm (ppke): New procedure.

2025-09-19  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add shared_multiple_provides.
	* test/all/local.mk (REGRESSION_TESTS),
	* test/all/shared_multiple_provides/shared_multiple_provides.dzn: Add it.

2025-09-20  Rutger van Beusekom  <rutger@dezyne.org>

	test: Refactor multiple_provides.
	* test/all/multiple_provides/multiple_provides.dzn: To allow
	shared_multiple_provides to correspond more closely.

2025-09-20  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Replace state communication sequence with choice.
	This fixes a deadlock in shared_multiple_provides.

	* dzn/code/scmackerel/makreel.scm (semantics-async): Rename
	shared-provides to provides-shared; avoid deadlock by offering a choice
	between multiple provides state communications.
	(ast->process <the-end>): Likewise.  Add component behavior queue-empty
	transition without state communication for ports without shared state.

2025-09-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add implicit_temporary5.
	* test/all/implicit_temporary5: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-09-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	transform: Resurrect add-explicit-temporaries.
	This is a follow-up to commit
	    1baf729fd58ad093d703c406fc9a849ae5ab2b25
	    normalize: Eradicate noisy and refactor.

	and re-enables invoking using dzn --transform=add-explicit-temporaries ...

	* dzn/transform.scm (add-explicit-temporaries): New wrapper.

2025-09-19  Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Rutger van Beusekom  <rutger@dezyne.org>

	normalize: Fix purge-data for variable and assign.
	This is a follow-up to commit
	    1baf729fd58ad093d703c406fc9a849ae5ab2b25
	    normalize: Eradicate noisy and refactor.

	* dzn/ast/normalize.scm (purge-data): Refactor and fix naive <variable> and
	<assign> purging for implicit temporaries.

2025-09-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add implicit_temporary4.
	* test/all/implicit_temporary4: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-09-19  Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Rutger van Beusekom  <rutger@dezyne.org>

	normalize: Fix purge-data for reply and return.
	This is a follow-up to commit
	    1baf729fd58ad093d703c406fc9a849ae5ab2b25
	    normalize: Eradicate noisy and refactor.

	* dzn/ast/normalize.scm (purge-data): Refactor and fix naive <reply> and
	<return> purging for implicit temporaries.

2025-09-18  Rutger van Beusekom  <rutger@dezyne.org>

	lookup: Extend search-unmemoized to use dotted prefix as scope.
	* dzn/ast/lookup.scm (search-unmemoized): Check for empty scope and
	dotted-ness and use dotted prefix as scope.

2025-09-18  Janneke Nieuwenhuizen  <janneke@gnu.org>

	wfc: Remove stray import.
	* dzn/ast/wfc.scm: Do no use (dzn ast accessor).

2025-09-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Revert "test: data_full: Add tests for <extern> data as return and reply."
	Extending the overly complicated data_full test is highly undesirable;
	the ROADMAP has listed the intend to split it for many years now.  Also,
	it's not canonicalized.

	Because C# does not support reply-data, adding that feature to data_full
	would mean that the data path was no longer under test for C#.

	This reverts commit b136b6ab0164cbf2d012348ecbf45be0134011f3.

2025-09-09  Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Paul Hoogendijk  <paul@dezyne.org>

	test: Add reply_data_full.
	* test/all/reply_data_full: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-09-18  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Update to 2.19.0.rc0.
	* guix/pack/dezyne.scm (dezyne): Update to 2.19.0.rc0.

2024-04-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `NEWS'.
	* NEWS (Changes in 2.19.0 since 2.18.2): New section.

2025-09-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `ROADMAP'.
	* ROADMAP (Release 2.19): Remove.

	build: Bump previous release to 2.18.4.
	* Makefile.am (--previous-version): Bump to 2.18.4.

	test: cruise-control: Bump timeout to 600.
	* test/all/cruise-control/META (timeout): New field.

	doc: Typos.
	* doc/dezyne.texi (Functions): Fix typos.

2025-09-03  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add choice_invariant.
	* test/all/choice_invariant/choice_invariant.dzn,
	* test/all/choice_invariant/ihello.dzn,
	* test/all/local.mk: Add it.

2025-09-03  Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Rutger van Beusekom  <rutger@dezyne.org>

	vm: Only check invariant at run to completion.
	* dzn/vm/invariant.scm (check-invariants): Make conditional on run to
	completion.

2025-01-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	pipeline: Refactor babooshka-esque verify assert code.
	* dzn/verify/pipeline.scm (mcrl2:verify-compliance): Rename to ...
	(mcrl2:compliance-output->trace): ...this.  Move trace generation upward to...
	(mcrl2:verify-interface-asserts): Split into...
	(verify:interface-asserts, verify:interface-nondet-assert): ...these new
	procedures.  Move running of pipeline upward to...
	(mcrl2:verify-interface): ...here.
	(mcrl2:verify-component-asserts): Split into...
	(verify:component-asserts, verify:compliance-assert): These new
	procedures.  Move running of pipeline upward to...
	(mcrl2:verify-component): ...here.

	pipeline: Use #:skip? parameter in report.
	* dzn/verify/pipeline.scm (report): Change order of parameters to
	"model", "assert", "trace", and change "skip" to keyword #:skip
	parameter.
	(mcrl2:verify-interface-asserts): Update caller.
	(mcrl2:verify-component-asserts): Likewise.

2024-12-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	pipeline: Remove static "abstraction".
	* dzn/verify/pipeline.scm (component-stage): Remove constant procedure.
	(in-out:dzn->aut+provides-aut, mcrl2:verify-component-asserts): Update
	callers.

2025-03-03  Janneke Nieuwenhuizen  <janneke@gnu.org>

	verify: Allow verifying imported interface with -m,--model.
	* dzn/commands/verify.scm (file->verify): Restrict import error to
	components.

2025-01-15  Paul Hoogendijk  <paul@dezyne.org>

	doc: Add data-type return.
	* doc/dezyne.texi (Types and Expressions): Add data-type return.

2025-06-20  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add system_reply_data.
	* test/all/system_reply_data: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-01-10  Paul Hoogendijk  <paul@dezyne.org>

	test: wf_functionReturnValue: Add reply ($..$) inside a function.
	* test/all/wf_functionReturnValue/wf_functionReturnValue.dzn (i)[cruel]:
	New event.
	(wf_functionReturnValue)[f]: Change to void function, use reply.

2024-11-21  Paul Hoogendijk  <paul@dezyne.org>

	wfc: Disallow reply ($..$) inside a function.
	* dzn/ast/wfc.scm (wfc <trigger>):
	* test/all/wf_functionReturnValue/baseline/verify.err: Update
	accordingly.

2025-06-17  Paul Hoogendijk  <paul@dezyne.org>

	test: Add reply_extern.
	* test/all/reply_extern: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-01-10  Paul Hoogendijk  <paul@dezyne.org>

	test: data_full: Add tests for <extern> data as return and reply.
	* test/all/data_full/data_full.dzn (Idata_full)[ei_ret]: New event.
	(Idata): New interface.
	(data_full_): Implement them.
	* test/all/data_full/main.c (main): Likewise.
	* test/all/data_full/main.cc (main): Likewise.
	* test/all/data_full/main.cs (Main): Likewise.
	* test/all/data_full/main.js (dzn): Likewise.
	* test/all/data_full/main.scm (main): Likewise.
	* test/all/data_full/trace: Update accordingly.
	* test/all/data_full/META: New file, mention "reply-data" feature.

2025-01-10  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: data_full: Whitespace fixes.
	* test/all/data_full/data_full.dzn: Fix whitespace.

2025-08-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add hello_int_guard.
	* test/all/hello_int_guard: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

	test: Add hello_data_argument.
	* test/all/hello_data_argument: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

2025-08-22  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_data_function.
	* test/all/hello_data_function: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

2025-07-23  Paul Hoogendijk  <paul@dezyne.org>

	cs: Partial support replying <extern> data.
	* dzn/code/scmackerel/cs.scm: (ast->code <reply>): Use type of
	trigger for reply ($..$).

2025-09-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	runtime: c: Handle data reply for int.
	* dzn/templates/c/main.c (log_typed): Add check for "return".

2025-07-23  Paul Hoogendijk  <paul@dezyne.org>

	c: Support replying <extern> data.
	* dzn/code/scmackerel/c.scm (ast->code <reply>): Use type of
	trigger for reply ($..$).
	(provides-trigger->method): Also display "return" for <extern>.
	* dzn/config.scm.in (%feature-alist): Add "c" to "reply-data".

2025-01-17  Paul Hoogendijk  <paul@dezyne.org>

	javascript: Support replying <extern> data.
	* runtime/javascript/dzn/runtime.js (runtime.call_in): Unwrap `.value` from object
	replies.
	* dzn/codegen/javascript.scm: (javascript:wrap-value-prefix, javascript:wrap-value-suffix):
	New methods for wrapping and unwrapping <extern> types.
	* dzn/templates/javascript.scm (wrap-value-prefix, wrap-value-suffix):
	New templates.
	* dzn/templates/javascript/assign-reply@reply: Use new templates to wrap
	reply expressions.
	* dzn/templates/javascript/wrap-value-prefix@reply,
	dzn/templates/javascript/wrap-value-suffix@reply: New files.
	* dzn/config.scm.in (%feature-alist): Add "javascript" to "reply-data".

2025-01-16  Paul Hoogendijk  <paul@dezyne.org>

	scheme: Support replying <extern> data.
	* dzn/code/language/scheme.scm (scheme:reply-name <extern>): New method.
	* dzn/templates/scheme/reply-member-initializer@extern: New file.
	* dzn/templates/scheme/reply@extern: New file.
	* runtime/scheme/dzn/runtime.scm (call-in): Unwrap second element from
	reply list when returning <extern> values.
	* dzn/config.scm.in (%feature-alist): Add "scheme" to "reply-data".

2025-08-24  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Handle data reply for int.
	* runtime/c++/dzn/runtime.hh (to_int): Add check for "return".

2024-11-21  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Support replying <extern> data.
	* dzn/code/scmackerel/c++.scm (interface->sm:statements-unmemoized,
	component-model->sm:statements-unmemoized): Wrap <extern> with data
	template.
	* runtime/c++/dzn/runtime.hh (data, to_string): New template to overload
	to_string to return "return" for <extern> data.
	* runtime/c++/dzn/pump.hh (shell): Adjust to unwrap `dzn::data<T>` in
	returned values.
	* dzn/config.scm.in (%feature-alist): Add "c++" to "reply-data".

2024-11-21  Paul Hoogendijk  <paul@dezyne.org>

	makreel Allow <extern> data as return type for events and functions.
	* dzn/code.scm (code:type->string <extern>): New specialization.
	* dzn/code/scmackerel/makreel.scm (makreel:process-formals): Allow data.

2025-09-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	wfc: Add reply-data feature.
	* dzn/config.scm.in (%feature-alist): Add reply-data.
	* dzn/ast/wfc.scm (wfc <signature>): Check for it to allow <extern> as
	return type.

2024-11-21  Paul Hoogendijk  <paul@dezyne.org>

	normalize: Add temporaries for data expression.
	* dzn/ast/normalize.scm (temporaries): Allow data.
	(temporaries*): Likewise.
	(replace-expression): Avoid creating a #f argument.
	(add-temporary): Avoid temporaries for data expressions.

	normalize: Purge data from signature too.
	(purge-data): Remove data from signature, maintain expression
	side-effects.

2025-03-07  Paul Hoogendijk  <paul@dezyne.org>

	test: Add invariant_group_expressions
	* test/all/invariant_group_expressions: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-03-03  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add invariant_guarded.
	* test/all/invariant_guarded: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-01-15  Paul Hoogendijk  <paul@dezyne.org>

	doc: Add invariant.
	* doc/dezyne.texi (Keywords): Add invariant.
	(Invariant): Document it.

2025-01-06  Rutger van Beusekom  <rutger@dezyne.org>

	test: cruise-control: Add invariants.
	* test/all/cruise-control/cruise-control-interfaces.dzn: Split-off from...
	* test/all/cruise-control/cruise-control.dzn: ...here.
	(cruise-control): Add invariants.

2025-01-08  Paul Hoogendijk  <paul@dezyne.org>

	test: Add variant_blocking_out.
	* test/all/variant_blocking_out: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-01-09  Paul Hoogendijk  <paul@dezyne.org>

	test: Add variant_out.
	* test/all/variant_out: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-01-08  Paul Hoogendijk  <paul@dezyne.org>

	test: Add invariant_two_out.
	* test/all/invariant_two_out: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	test: Add invariant_out_forward.
	* test/all/invariant_out_forward: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	test: Add invariant_blocking_two_out.
	* test/all/invariant_blocking_two_out: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-01-06  Paul Hoogendijk  <paul@dezyne.org>

	test: Add invariant_sync_out.
	* test/all/invariant_sync_out: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	test: Add variant_immediately.
	* test/all/variant_immediately: New test.
	* test/all/local.mk (PARSER_TESTS): Register it.

	test: Add variant_interface.
	* test/all/variant_interface: New test.
	* test/all/local.mk (PARSER_TESTS): Register it.

	test: Add variant_defer.
	* test/all/variant_defer: New test.
	* test/all/local.mk (PARSER_TESTS): Register it.

	test: Add variant_component.
	* test/all/variant_component: New test.
	* test/all/local.mk (PARSER_TESTS): Register it.

	test: Add hello_invariant.
	* test/all/hello_invariant: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

2024-12-16  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add hello_variant.
	* test/all/invariant_fail: New test.
	* test/all/local.mk (HELLO_TESTS): Add it.

2025-01-06  Paul Hoogendijk  <paul@dezyne.org>

	test: Add unreachable_predicates.
	* test/all/unreachable_predicates: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	test: Add parse_predicate.
	* test/all/parse_predicate: New test.
	* test/all/local.mk (PARSER_TESTS): Register it.

	test: Add guard_predicates.
	* test/all/guard_predicates: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-01-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	graph: Support <invariant>.
	* dzn/explore.scm (pc->rtc-lts): Check invariants.

2025-07-31  Janneke Nieuwenhuizen  <janneke@gnu.org>

	simulate: Support <invariant>.
	* dzn/vm/goops.scm (<invariant-error>): New class.
	* dzn/vm/step.scm (step <invariant>): New specialization.
	(step <guard>): Cater for <guard> without <on> and expression
	functions.
	* dzn/vm/invariant.scm: New file.
	* dzn/vm/local.mk (dist_%C%_scm_DATA): Register it.
	* dzn/simulate.scm (run-sut, run-trail): Use it to check invariant.
	* dzn/vm/report.scm (report): Cater for <invariant-error>.
	* dzn/vm/normalize.scm (lift-invariants): New function.
	(vm:normalize): Use it. And add inline-expression-functions.

2025-01-08  Paul Hoogendijk  <paul@dezyne.org>

	traces: Add prioritization of invariant event.
	* dzn/lts.scm (prioritize-invariant-edges): New procedure to remove
	other edges when <invariant> edge is present.
	(prioritize-invariant): Use it in new procedure to do it for all nodes.
	(generate-traces): Use it.
	* dzn/commands/traces.scm (model->traces): Add call to prioritize-invariant.

2025-07-31  Paul Hoogendijk  <paul@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Rutger van Beusekom  <rutger@dezyne.org>

	verify: Support <invariant>.
	* dzn/code/language/makreel.scm: (reachable-calls-unmemoized,
	makreel:call-continuation*-unmemoized): Exclude declarative calls.
	* dzn/code/scmackerel/makreel.scm (%invariant-action): New variable.
	(ast->process <declarative-compound> <ast>,
	ast->process <declarative-compound> <list>,): Add %invariant-action
	guarded by the negation of its predicate to indicate the invariant
	violation when the action occurs.
	(interface-reorder-processes, provides-processes,
	component-defer-processes, semantics-blocked,
	component-assembly-processes, constraint-processes): Allow it.
	(semantics-main, semantics-blocked, component-semantics-processes):
	Synchronize on %invariant-action to disallow behavior to continue.
	* dzn/lts.scm (parse-label): Cater for <invariant>.
	(report-fail): Report invariant violation.

2025-09-02  Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Paul Hoogendijk  <paul@dezyne.org>

	normalize: Add make-behavior-invariant.
	* dzn/ast/normalize.scm (make-a=>b-expression): New normalization.
	(normalize:state, normalize:state+illegals): Use it.

	normalize: Add invariant:include-guard-expressions.
	* dzn/ast/normalize.scm  (make-a=>b-expression): New procedure to rewrite implies.
	(invariant:include-guard-expressions): Use it in new procedure to
	collect all guards and add to expression of invariant.
	* dzn/transform.scm: Re-export it.

	normalize: Add remove-invariant.
	* dzn/ast/normalize.scm (remove-invariant): New normalization.
	(normalize:state, normalize:state+illegals): Use it.
	* dzn/transform.scm: Re-export it.

2024-12-20  Paul Hoogendijk  <paul@dezyne.org>

	wfc: Support <invariant>.
	* dzn/ast/wfc.scm (wfc <invariant>): New specialization.
	(wfc <guard>): Cater for invariant.

2025-09-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Add expression functions.
	* doc/dezyne.texi (Expression functions): New subsection.

2025-09-02  Janneke Nieuwenhuizen  <janneke@gnu.org>

	normalize: Add inline-expression-functions.
	* dzn/ast/normalize.scm (inline-expression-functions): New normalization.
	* dzn/code/language/makreel.scm (makreel:normalize): Use it.
	* dzn/transform.scm: Re-export it.

2025-08-23  Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Paul Hoogendijk  <paul@dezyne.org>

	wfc: Support <expression-function>.
	* dzn/ast/wfc.scm (wfc-error->info): New procedure.
	(wfc-predicate): New method.
	(wfc <function>): Rename to...
	(wfc-function): ...this.
	(wfc <function>, wfc <expression-functions>): Use it in new
	specializations.
	(wfc <guard>): Use it to check that all calls of expression of guards
	are predicates.

2025-08-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Annotate function call and recursion.
	* dzn/ast/equal.scm: (ast:name-equal? <named> <named>): New
	specialization.
	* dzn/ast/ast.scm (<function>)[called?]: New field.
	* dzn/ast/recursive.scm (set-called?): Use them in new method.
	(annotate-recursion): Rename to...
	(recursive:annotate): ...this, and use it.
	* dzn/parse.scm (parse:annotate-ast): Use it to annotate functions.
	* test/all/code-json: Update baseline.

	Co-authored: Paul Hoogendijk <paul@dezyne.org>

2025-08-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Add <root> specialization for ast:imported?
	* dzn/ast.scm (ast:iported? <root>): Add specialisation.

	Co-authored: Paul Hoogendijk <paul@dezyne.org>

2025-08-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Add <call> specialization for ast:imperative?.
	* dzn/ast.scm (ast:imperative? <call>): Add specialisation.

	Co-authored: Paul Hoogendijk <paul@dezyne.org>

2025-08-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Add <call> specialization for ast:declarative?.
	* dzn/ast.scm (ast:declarative? <call>): Add specialisation.

	Co-authored: Paul Hoogendijk <paul@dezyne.org>

2025-01-17  Paul Hoogendijk  <paul@dezyne.org>

	peg: Add invariant.
	* dzn/ast/ast.scm (<invariant>): New AST.
	* dzn/parse/tree.scm (tree:record): Add 'invariant.
	* dzn/parse/peg.scm (peg:parse): Parse invariant.
	* dzn/ast/parse.scm (parse:tree->ast): Cater for it.
	* dzn/code/language/dzn.scm (print-ast <invariant>): New specialization.

	Co-authored: Paul Hoogendijk <paul@dezyne.org>

2025-08-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	peg: Add expression-function.
	* dzn/ast/ast.scm (<expression-function>): New AST.
	* dzn/ast/lookup.scm (ast:lookup-variable): Cater for <expression-function>.
	* dzn/parse/tree.scm (tree:record): Add 'expression-function.
	* dzn/parse/peg.scm (peg:parse): Parse expression-function.
	* dzn/ast/parse.scm (parse:tree->ast): Cater for it.
	* test/all/parse_fall_back_out_binding_argument/baseline/verify.err:
	Update baseline.

	Co-authored: Paul Hoogendijk <paul@dezyne.org>

2025-08-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	peg: Remove optional name from behavior.
	* dzn/parse/peg.scm (peg:parse): Remove optional name after behavior.
	* dzn/ast/parse.scm (parse:tree->ast): Remove behavior-with-name case
	and reformat.
	* test/all/hello_parse/hello_parse.dzn (iworld): Remove name from
	behavior

	Co-authored: Paul Hoogendijk <paul@dezyne.org>

2025-08-22  Rutger van Beusekom  <rutger@dezyne.org>

	ast: Add predicate to ast:parent.
	* dzn/ast/accessor.scm (ast:parent): New specialization.

2025-01-16  Paul Hoogendijk  <paul@dezyne.org>

	doc: Add implies (=>) operator.
	* doc/dezyne.texi (Operators): Add =>.
	(Expressions): Likewise.
	(Bool): Document it.

2025-01-14  Paul Hoogendijk  <paul@dezyne.org>

	doc: Some improvements and fixing typos.
	* doc/dezyne.texi: Throughout: fix typos.
	(On): Move imperative-statement example to...
	(Imperative Statements): ...here.

2025-01-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add implies_expressions.
	* test/all/implies_expressions: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2023-08-15  Rutger van Beusekom  <rutger@dezyne.org>

	peg: Add implication "=>".
	* dzn/parse/peg.scm (peg:parse): Add implication.
	* dzn/ast/parse.scm (parse:tree->ast): Handle it.

2024-12-12  Paul Hoogendijk  <paul@dezyne.org>

	ast: Remove <unary> from ast define of <variable>.
	* dzn/ast/ast.scm (<variable>): Do not inherit from <unary>
	* dzn/templates/scheme/code-arguments@variable,
	dzn/templates/scheme/expression-expand@variable: New template files.
	* dzn/templates/javascript/code-arguments@variable,
	dzn/templates/javascript/expression-expand@variable: New template files.

	wfc: Do not report next statement for typed recursion call.
	* dzn/ast/wfc.scm (tail-recursion): Remove "statement after call" info.
	* test/all/wf_functionTailRecursion/baseline/verify.err: Update
	accordingly.

2025-02-17  Paul Hoogendijk  <paul@dezyne.org>

	test: wf_undefined: Add undefined port and undefined instance.
	* test/all/wf_undefined/wf_undefined.dzn (C2): New component.
	(wf_undefined): Use it.
	* test/all/parse_fall_back_out_binding_argument/baseline/verify.err:
	Update baseline.

2025-02-18  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add parse_function_shadow_event.
	* test/all/parse_function_shadow_event: New test.
	* test/all/local.mk (PARSER_TESTS): Register it.

2025-08-22  Rutger van Beusekom  <rutger@dezyne.org>

	parse: Disallow function shadowing action: duplicate identifier.
	* dzn/ast/ast.scm (<undefined>): Replace <unary> with <var>.
	(<duplicate>): Add.
	* dzn/ast/parse.scm: (parse:tree->ast): Create.
	* dzn/ast/wfc.scm (duplicate): Report.
	* dzn/parse/peg.scm: (peg:parse): Add duplicate-identifier and use it to
	record a function shadowing an event.
	* test/all/parse_interface_parens/baseline/verify.err,
	test/all/undefined/interface/call_in_function/baseline/verify.err,
	test/all/wf_undefined_function/baseline/verify.err: Update baseline.

2025-02-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Remove function_shadow_event.
	* test/all/function_shadow_event: Remove.
	* test/all/local.mk (REGRESSION_TESTS): Unregister.

2025-01-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Revert "language: Drop lazy importing and just-in-time parsing."
	This reverts commit 398b9675ed9b6490764df85e839f461132d5a1c7.

2024-11-28  Rutger van Beusekom  <rutger@dezyne.org>

	verify: Add fall-back command line option.
	* dzn/commands/verify.scm (parse-opts): Add fall-back to option-spec.

2024-12-03  Rutger van Beusekom  <rutger@dezyne.org>

	peg: Break the mutual import cycle.
	* dzn/peg/util.scm (peg:imported-from->message): Maintain a list of
	visited elements and avoid revisiting elements.

2024-11-28  Rutger van Beusekom  <rutger@dezyne.org>

	parse: Enable forwarding fall-back option.
	* dzn/commands/parse.scm (parse): Parameterize the fall-back parse
	option.

2025-01-10  Rutger van Beusekom  <rutger@dezyne.org>

	peg: Replace not with negation to prevent collision.
	* dzn/parse/peg.scm (peg:parse)[not]: Rename to...
	[negation]: ...this.
	* dzn/ast/parse.scm (parse:tree->ast): Update accordingly.

	peg: Replace interface-action with action.
	* dzn/parse/peg.scm (peg:parse): Remove interface-action and add
	is-event to action.
	* dzn/ast/parse.scm (parse:tree->ast): Replace interface-action with
	action.
	* test/all/parse-flags/baseline/parse.out,
	test/all/parse_interface_parens/baseline/verify.err,
	test/all/undefined/interface/call_in_function/baseline/verify.err,
	test/all/wf_undefined_function/baseline/verify.err,
	test/all/parse_peg_locations/baseline/parse.out: Update accordingly.
	test/all/parse_peg_locations/baseline/verify.out: Remove.

2025-01-09  Rutger van Beusekom  <rutger@dezyne.org>

	test: Define before use.
	The upcoming PEG symbol table rewrite disallows use before define for
	toplevel types.  Update the test framework accordingly.

	* test/all/Camera/Optics.dzn,
	test/all/blocking_multiple_provides0/blocking_multiple_provides0.dzn,
	test/all/blocking_multiple_provides2/blocking_multiple_provides2.dzn,
	test/all/blocking_multiple_provides3/blocking_multiple_provides3.dzn,
	test/all/bool_expressions/bool_expressions.dzn,
	test/all/calling_context/calling_context.dzn,
	test/all/collateral_cancel_guarantee/collateral_cancel_guarantee.dzn,
	test/all/compliance_blocking_double_release2/compliance_blocking_double_release2.dzn,
	test/all/compliance_blocking_out/compliance_blocking_out.dzn,
	test/all/compliance_external/compliance_external.dzn,
	test/all/compliance_failures_inevitable_optional/compliance_failures_inevitable_optional.dzn,
	test/all/compliance_optional/compliance_optional.dzn,
	test/all/deadlock_blocking_inevitable/deadlock_blocking_inevitable.dzn,
	test/all/deadlock_blocking_replies/deadlock_blocking_replies.dzn,
	test/all/enum_expressions/enum_expressions.dzn,
	test/all/enum_only/enum_only.dzn,
	test/all/extern_in_interface/extern_in_interface.dzn,
	test/all/foreign_handwritten/foreign_handwritten.dzn,
	test/all/foreign_import_system/hello_foreign.dzn,
	test/all/foreign_injected/foreign_injected.dzn,
	test/all/foreign_multiple_provides/foreign_multiple_provides.dzn,
	test/all/foreign_optional/foreign_optional.dzn,
	test/all/foreign_reply/foreign_reply.dzn,
	test/all/foreign_requires/foreign_requires.dzn,
	test/all/formal_binding/formal_binding.dzn,
	test/all/guard_expressions/guard_expressions.dzn,
	test/all/hello_bool/hello_bool.dzn,
	test/all/hello_data/hello_data.dzn,
	test/all/hello_else/hello_else.dzn,
	test/all/hello_enum/hello_enum.dzn,
	test/all/hello_enum_function/hello_enum_function.dzn,
	test/all/hello_expression/hello_expression.dzn,
	test/all/hello_external/hello_external.dzn,
	test/all/hello_foreign/hello_foreign.dzn,
	test/all/hello_foreign_path/hello_foreign_path.dzn,
	test/all/hello_functions/hello_functions.dzn,
	test/all/hello_guard/hello_guard.dzn,
	test/all/hello_guard_two/hello_guard_two.dzn,
	test/all/hello_if/hello_if.dzn,
	test/all/hello_ifelse/hello_ifelse.dzn,
	test/all/hello_ifif/hello_ifif.dzn,
	test/all/hello_import_component/components.dzn,
	test/all/hello_imported/hello_imported.dzn,
	test/all/hello_int/hello_int.dzn,
	test/all/hello_local/hello_local.dzn,
	test/all/hello_local_assign/hello_local_assign.dzn,
	test/all/hello_namespace_foreign/hello.dzn,
	test/all/hello_namespace_shadow/hello_namespace_shadow.dzn,
	test/all/hello_otherwise/hello_otherwise.dzn,
	test/all/hello_out_data/hello_out_data.dzn,
	test/all/hello_out_state/hello_out_state.dzn,
	test/all/hello_recursive/hello_recursive.dzn,
	test/all/hello_reply/hello_reply.dzn,
	test/all/hello_tick/hello_tick.dzn,
	test/all/hello_two/hello_two.dzn,
	test/all/hellofundata/hellofundata.dzn,
	test/all/hellointbug/hellointbug.dzn,
	test/all/hellooutevent/hellooutevent.dzn,
	test/all/helloparam/helloparam.dzn,
	test/all/helloparams/helloparams.dzn,
	test/all/inevitable_multiple_requires/inevitable_multiple_requires.dzn,
	test/all/injected_foreign/injected_foreign.dzn,
	test/all/inline-functions/baseline/default.dzn,
	test/all/inline-functions/baseline/inline-f.dzn,
	test/all/inline-functions/baseline/inline-g.dzn,
	test/all/inline-functions/baseline/inline-null.dzn,
	test/all/inner.space/inner.space.dzn,
	test/all/interface_enum/interface_enum.dzn,
	test/all/interface_int/interface_int.dzn,
	test/all/iteration/iteration.dzn,
	test/all/parse_missing_event/parse_missing_event.dzn,
	test/all/parse_parameter_mismatch/parse_parameter_mismatch.dzn,
	test/all/pump_twice/pump_twice.dzn,
	test/all/step_state/step_state.dzn,
	test/all/stress_comment/stress_comment.dzn,
	test/all/system_bool_enum/system_bool_enum.dzn,
	test/all/system_double_inevitable/system_double_inevitable.dzn,
	test/all/system_double_out/system_double_out.dzn,
	test/all/system_flush_double/system_flush_double.dzn,
	test/all/system_foreign_only/system_foreign_only.dzn,
	test/all/system_foreign_only_flush/system_foreign_only_flush.dzn,
	test/all/system_helloworld/system_helloworld.dzn,
	test/all/system_import_foreign/hello0.dzn,
	test/all/system_import_foreign/system_import_foreign.dzn,
	test/all/system_out/system_out.dzn,
	test/all/system_out_internal/system_out_internal.dzn,
	test/all/system_out_two/system_out_two.dzn,
	test/all/unused_function/unused_function.dzn,
	test/all/wf_missing_bindings/wf_missing_bindings.dzn: Order interfaces,
	components, instances and bindings accordingly.

2023-09-13  Rutger van Beusekom  <rutger@dezyne.org>

	ast: Add <event> specialization of ast:direction.
	* dzn/ast.scm (ast:direction <event>): New specialization.

2023-06-23  Rutger van Beusekom  <rutger@dezyne.org>

	peg: Allow '=' in nonterminal identifiers.
	* dzn/peg/string-peg.scm (peg-as-peg, peg-nonterminal): Add '=' to
	character range.

2025-01-13  Rutger van Beusekom  <rutger@dezyne.org>

	peg: Formatting.
	* dzn/peg/codegen.scm (fall-back-skip): Replace begin with let and
	format.

2025-01-08  Rutger van Beusekom  <rutger@dezyne.org>

	test: LegoBallSorter: Refactor imports and define before use.
	* test/all/LegoBallSorter/BallSorter.dzn: Remove redundant import.
	* test/all/LegoBallSorter/Brick2.dzn,
	test/all/LegoBallSorter/Brick3.dzn: REMOVEME XXX?
	* test/all/LegoBallSorter/Conveyor.dzn,      XXX?
	component file.                              xxx?
	* test/all/LegoBallSorter/EndConstrainedAxis.dzn: Use interface instead
	of component file.
	* test/all/LegoBallSorter/FeedPort.dzn: Reorder component before
	encapsulating system.
	* test/all/LegoBallSorter/Feeder.dzn,
	test/all/LegoBallSorter/Inspector.dzn,
	test/all/LegoBallSorter/LightSensor.dzn,
	test/all/LegoBallSorter/MaterialHandler.dzn,
	test/all/LegoBallSorter/Motor.dzn,
	test/all/LegoBallSorter/Robot.dzn,
	test/all/LegoBallSorter/Stage.dzn,
	test/all/LegoBallSorter/TouchSensor.dzn: Remove redundant import and
	reorder component before encapsulating system.
	* test/all/LegoBallSorter/foreign_timer.dzn (itimer): Move to...
	* test/all/LegoBallSorter/lego.dzn (itimer): ...here.

2025-01-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Cleanup parse:tree-alist->ast.
	* dzn/parse.scm (parse:tree-alist->ast)[expand-imports]: Use match
	instead of car/cdr.
	[file+content->file]: Use unquote instead of cons.

2025-04-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	peg: Memoize peg:imports.
	* dzn/peg/util.scm (peg:imported-file-names-unmemoized): Add content parameter.
	(peg:imported-file-names-helper): Use it in new memoized procedure.
	(peg:imported-file-names): Use it.

2024-12-02  Rutger van Beusekom  <rutger@dezyne.org>

	parse: Refactor file->content-alist to prepare for PEG symbol table.
	This changes the ordering of the imports parse *-alists to be
	topologically sorted, i.e.,

	    ((MAIN-FILE . content)
	     (least-dependent-import . content)
	     ..
	     (most-dependent-import . content))

	to prepare for the PEG symbol table parser.

	* dzn/parse.scm (file->string-unmemozized): New memoizable procedure.
	(parse:file->content-alist): Use them to simplify and correct, i.e.,
	define before use ordering.  This changes the ordering of the resulting
	alist.
	* test/all/parse-flags: Update baseline.

2024-12-02  Rutger van Beusekom  <rutger@dezyne.org>

	parse: Factor-out canonicalize-file-name.
	* dzn/shell-util.scm (canonicalize-file-unmemoized, canonicalize-file):
	New prodedures, factored-out from...
	* dzn/parse.scm (parse:file->content-alist): ...here.  Also factor-out...
	(file->string-unmemozized): ...this new procedure.

	parse: Unnest unnecessarily nested procedure.
	* dzn/parse.scm (parse:file->stream)[file+content->stream-line]: Move
	out of outer let.

2025-04-09  Rutger van Beusekom  <rutger@dezyne.org>

	peg: Restrict imports to top of dezyne file.
	This improves performance considerably, about an order of magnitude, on
	parsing large projects.

2024-09-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	scheme: Do not crash when top (copyright) comment is missing.
	* dzn/code/language/scheme.scm (scheme:comment <ast>): Cater for ast
	without comment.

2025-01-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Support running non-compiled template framework from anywhere.
	* Makefile.am (DZN_UNINSTALLED, DZN_PREFIX): New exported variables.
	* dzn/templates.scm (compile-template): Use %template-dir instead of
	relative "dzn/templates".
	(define-templates-base): Likewise.

2025-01-17  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add port type-name lookup for missing interface.
	* test/dzn/parse.scm ("string-tree"): New test.

	tree: Support type-name for port.
	* dzn/parse/tree.scm (.type-name): Cater for port's
	type-name (compound-name) wrapped in provides/requires.

	tree: Support normalization without locations.
	* dzn/parse/tree.scm (tree:scoped-name->compound-name): Make location
	optional.

	tree: Fix programming-warning.
	* dzn/parse/tree.scm (tree?): Use write semantics.

	tree: Cleanup context:collect.
	* dzn/parse/tree.scm (context:collect): Remove duplicate definition.
	(context:collect): Change order of parameters.
	(tree:list-model*): Update accordingly.

	dzn: Add true tree:collect.
	* dzn/parse/tree.scm (tree:collect): Rename to...
	(tree:filter): ...this.
	* dzn/parse/complete.scm (complete:context): Update accordingly.

	parse: Remove redundant annotation.
	* dzn/parse.scm (parse:content-alist->tree-alist): Remove *.

	test: Add parse unit test.
	* test/dzn/parse.scm: New file.
	* test/dzn/local.mk (UNIT_TESTS): Register it.

	peg: Keep comments when %peg:locations? is unset.
	* dzn/peg/codegen.scm (wrap-parser-for-users): Only remove locations
	when %peg:locations? is unset, not comments.

	peg: Refactor nested if.
	* dzn/peg/codegen.scm (wrap-parser-for-users): Rewrite to use COND.

2025-02-13  Rutger van Beusekom  <rutger@dezyne.org>

	peg: Cater for comments in between imports.
	* dzn/peg/util.scm: (peg:imported-file-names): After import ignore
	trailing parse tree nodes, like comments.

2025-01-17  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Expose content-alist on convenience interface.
	* dzn/parse.scm (parse:file->tree-alist+content-alist,
	parse:file->tree-alist): Add #:content-alist parameter.

2025-01-13  Rutger van Beusekom  <rutger@dezyne.org>

	language: Remove testing for multiple port qualifiers.
	* dzn/parse/complete.scm (complete:root): Simplify to ony cater for one qualifier.
	* test/language/component-requires.dzn (hello): Remove multiple port
	qualifier ports.
	* test/dzn/language.scm ("component-requires external injected",
	"component-requires injected external"): Remove tests.

2025-01-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	language: Drop lazy importing and just-in-time parsing.
	* dzn/commands/language.scm (main): Use parse:file->tree-alist instead
	of parse:string->tree*.
	* test/dzn/language.scm (test-context): Likewise.

	language: Merge gratuitous inner let.
	* dzn/commands/language.scm (main): Collapse inner context let.

2025-01-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Support for using parse:file->content-alist with import failures.
	* dzn/parse.scm (parse:file->tree-alist): Add #:ignore-import-error?
	Pass it to...
	(parse:file->content-alist): ...here.  Add #:ignore-import-error?
	parameter.  Do not throw 'import-error when set.

	test: language: Remove duplicate definition.
	* test/language/import-double.space.dzn (bar.int, bar.double.i): Make
	unique names.

	test: language: Cater for define before use.
	* test/language/lookup.dzn (ihello_nondet): Move before its use in
	compontent.
	* test/dzn/language.scm ("port->interface"):
	("variable-expression->variable", "trigger->port", "action->port",
	"action->event"): Update accordingly.

2025-01-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: language: Cater for define before use.
	* test/language/enum.dzn: Move enum definition before its use in interface.
	* test/dzn/language.scm ("field-test field", "enum-literal with
	comment", "field-test->reference", "field-test->enum-field",
	"enum-literal->field with comment"): Update locations accordingly.

2025-01-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: language: Fix lookup locations.
	* test/dzn/language.scm ("system binding instance provides", "system
	binding instance requires"): Avoid attempting lookup at <=> symbol.

	language: Add misc.
	* dzn/parse/lookup.scm: Use (dzn misc) for debugging.
	* dzn/commands/language.scm: Likewise.
	* test/dzn/language.scm: Likewise.

	language: Use write mode for tree debug printing.
	* dzn/commands/language.scm (main): Use "~s" instead of "~a" for
	"tree:...".

2024-12-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add cruel_project.
	* test/all/cruel_project: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.
	:

2025-01-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: hello_project: Also run verify.
	* test/all/hello_project/run: Run verify on the directory.

2024-12-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	verify: Support mulitple files, and directory as FILE-NAME.
	* dzn/verify/pipeline.scm (verification:verify): Add #:multiple?
	parameter.  Pass it to...
	(verification:models): ...here.  Add #:multiple? parameter.  Use it to
	disable verification of interfaces when verifying multiple files.
	* dzn/commands/verify.scm (file->verify): New procedure, factored-out
	from...
	(main): ...here.  Use it to support building a directory.
	* doc/dezyne.texi (Invoking dzn verify): Document it.

2024-11-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	hello: Add `--runtime' option.
	* dzn/config.scm.in (%runtime-dir): New variable.
	* dzn/commands/hello.scm (parse-opts): Add `--runtime' option.
	(main): When used, print %runtime-dir.
	* doc/dezyne.texi (Invoking dzn hello): Document it.

2024-11-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	dzn: Add --version-number option.
	This simplifies getting the version number of Dezyne in environments
	where Dezyne is the only program in use that conforms to the GNU coding
	standards.

	* dzn/script.scm (parse-opts): Add `--version-number' option.  When
	used, print a terse version number using...
	* dzn/command-line.scm (show-version-number-and-exit): ..this new
	procedure.

2025-01-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: hello_project: Add checks for dzn hash.
	* test/all/hello_project/run: Check various sha1sum's.

2024-11-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	hash: New command.
	* dzn/hash.scm (dzn): New file.
	* dzn/local.mk (dist_%C%_scm_DATA): Register it.
	* dzn/commands/hash.scm: Use it in new file.
	* dzn/commands/local.mk (dist_%C%_scm_DATA): Register it.
	* doc/dezyne.texi (Invoking dzn hash): Document it.

	build: Check for guile-gcyrpt.
	* configure.ac: Add check.

	guix: dezyne: Add guile-gcrypt dependency.
	* guix/pack/dezyne.scm (dezyne)[inputs]: Add guile-gcrypt.

2024-11-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Add -D,--no-directives option.
	Using `| grep -v ^#' is reportedly too cumbersome or even unknown (dying?) art.

	* dzn/commands/parse.scm (parse-opts): Add -E,--no-directives option.
	(main): When used, imply --preprocess.
	(preprocess): Forward it to...
	* dzn/parse.scm (parse:file->stream): ...here.  Add #:file-directives?
	parameter.  Use it to omit #file and #import directives.
	* doc/dezyne.texi (Invoking dzn parse): Document it.

2024-11-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add hello_project.
	* test/all/hello_project: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

	test: Add run-build, run-execute.
	* test/bin/run-build,in,
	test/bin/run-execute.sh: New files.
	* configure.ac: Generate executable versions.
	* .gitignore: Ignore them.

2024-11-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	c++: Add -t,--touch-empty-files.
	Touching empty files creates consistency that removes an irregularity
	from the build system.

	* dzn/commands/code.scm (parse-opts): Add -t,--touch-empty-files.
	(main): Pass it...
	(file->code): ...here, into new #:empty-files? parameter.
	* dzn/code.scm (code): Add parameter #:empty-files?.  Pass it...
	* dzn/code/language/c++.scm (ast->): ...here into new #:empty-files?
	parameter.  When set, touch otherwise empty .cc file using...
	* dzn/code/util.scm (code:touch): ...this new procedure.
	* dzn/code/language/c.scm (ast->): Add #:empty-files? parameter.
	* dzn/code/language/cs.scm (ast->): Likewise.
	* dzn/code/language/dot.scm (ast->): Likewise.
	* dzn/code/language/dzn.scm (ast->): Likewise.
	* dzn/code/language/javascript.scm (ast->): Likewise.
	* dzn/code/language/json.scm (ast->): Likewise.
	* dzn/code/language/makreel.scm (ast->): Likewise.
	* dzn/code/language/scheme.scm (ast->): Likewise.
	* doc/dezyne.texi (Invoking dzn code): Document it.

2024-11-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: Support mulitple files, and directory as FILE-NAME.
	* dzn/shell-util.scm (dzn-file?, file-name->dzn-files): New prodedures.
	* dzn/code/util.scm (code:dump): Add #:verbose? parameter.
	* dzn/code.scm (code): Add #:verbose? parameter.
	* dzn/code/language/c++.scm (ast->): Add #:verbose? parameter.
	* dzn/commands/code.scm (file->code): New procedure, factored-out
	from...
	(main): ...here.  Use them to support building a directory.
	* dzn/code/language/c.scm (ast->): Add #:verbose? parameter.
	* dzn/code/language/cs.scm (ast->): Likewise.
	* dzn/code/language/dot.scm (ast->): Likewise.
	* dzn/code/language/dzn.scm (ast->): Likewise.
	* dzn/code/language/javascript.scm (ast->): Likewise.
	* dzn/code/language/json.scm (ast->): Likewise.
	* dzn/code/language/makreel.scm (ast->): Likewise.
	* dzn/code/language/scheme.scm (ast->): Likewise.
	* doc/dezyne.texi (Invoking dzn code): Document it.

2024-11-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: c++: Use dezyne dependencies.
	* test/lib/build.c++.make ($(OUT)/%.hh, $(OUT)/%.cc): Dummy rules to
	convince make that their being out-of-date is important by telling it
	that these files can actually be rebuilt.

	c++: Generate make dependencies.
	* dzn/code/util.scm (code:depend-dir, code:depend-file-name,
	code:relative-file-name, code:depend-imports): New procedures.
	* dzn/code/util.scm (): New procedure.
	* dzn/code/language/c++.scm (ast->): Use them to generate make dependencies.
	* doc/dezyne.texi (Invoking dzn code): Document it.

2024-09-17  Janneke Nieuwenhuizen  <janneke@gnu.org>

	misc: common-prefix: Support #:eq?.
	* dzn/misc.scm (common-prefix): Add optional #:eq? parameter.

2024-03-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	misc: Add common-prefix.
	* dzn/misc.scm (common-prefix): New procedure.

2025-01-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Do not prematurely cut model from AST.
	* dzn/commands/parse.scm (parse): Do not cut model from AST.
	* dzn/commands/code.scm (main): Remove workaround for that.
	* dzn/commands/graph.scm (main): Likewise.
	* dzn/commands/simulate.scm (main): Likewise.
	* dzn/verify/pipeline.scm (verification:models): New procedure,
	refactored to respect --model selection for interfaces too.
	Factored-out from...
	(verification:verify): Here.

2025-01-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	verify: Verify non-imported interfaces even with --no-interfaces.
	* dzn/verify/pipeline.scm (verification:verify): Refactor, keep
	non-imported interfaces with --no-interfaces.
	* doc/dezyne.texi (Invoking dzn verify):

	parse: Resurrect parsing from stdin.
	* dzn/parse.scm (parse:file->content-alist)[canonicalize-path-memoized]:
	Cater for file-name "-".

2024-11-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	shell-util: Replace file-is-directory?.
	* dzn/shell-util.scm (file-is-directory?): Use #:replace to silence
	warning.

2024-11-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	exec: New command.
	* dzn/commands/exec.scm: New file.
	* dzn/commands/local.mk (dist_%C%_scm_DATA): Register it.
	* doc/dezyne.texi (Invoking dzn exec): Document it

2024-09-16  Janneke Nieuwenhuizen  <janneke@gnu.org>

	misc: Add write-line, write-line-error.
	* dzn/misc.scm (write-line-error): New procedure.

2024-04-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Friendlier debugging.
	* dzn/parse.scm (parse:string->tree): Use debug instead of format.
	(parse:annotate-ast): Add canary.

	misc: Add debug.
	* dzn/vm/util.scm (%debug?): Move to...
	* dzn/misc.scm (%debug?): ...here.
	(debug): New procedure.

2024-08-01  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	dzn: Add --threads option.
	* dzn/script.scm (parse-opts): Add --threads.
	* dzn/verify/pipeline.scm (in-out:lps->aut): Use it on lps2lts as
	--threads=NUMBER.
	* doc/dezyne.texi (Invoking dzn): Document it.
	* configure.ac: Check for LPS2LTS with --threads=N.

2024-07-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Use FALSE,TRUE instead of False,True.
	This prepares to cater for Python.

	* test/all/bool_expressions/bool_expressions.dzn
	test/all/hello_implicit_enum/hello_implicit_enum.dzn,
	test/all/import_cycle/ihello.dzn,
	test/all/import_cycle/import_cycle.dzn,
	test/all/import_cycle/iworld.dzn,
	test/all/sync_out_reply_enum/sync_out_reply_enum.dzn,
	test/all/unused_interface_type/icruel.dzn,
	test/all/unused_interface_type/interfaces.dzn,
	test/all/unused_interface_type/unused_interface_type.dzn: Use FALSE,TRUE.

2024-04-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	misc: Add atom?.
	* dzn/misc.scm (atom?): New prodedure.

	misc: Add display-join*.
	* dzn/misc.scm (display-join*): New procedure.
	(display-join): Use it.

2024-03-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: Exit gracefully when --shell does not specify a system.
	* dzn/parse.scm (parse:handle-exceptions): Handle `quit'.
	* dzn/commands/code.scm (main)[shell-error]: New inner define.  Enclose
	body in `call-with-handle-exceptions' and use it to throw errors

2024-04-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add space.shell.
	* test/all/space.shell: New test.
	(REGRESSION_TESTS): Add it.

	test: Add hello_shell.
	* test/all/hello_shell: New test.
	* test/all/local.mk (HELLO_TESTS): Add it.

2024-03-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add usage/code/shell.
	* test/all/usage/code/shell: New test.
	* test/all/local.mk (USAGE_TESTS): Add it to new variable.
	(FULL_TESTS): Add $(USAGE_TESTS).

2024-04-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: Rename <state> to <share-state>.
	* dzn/code/shared.scm (<state>): Rename to...
	(<share-state>): ...this.
	* dzn/code/language/makreel.scm (makreel:add-state-placeholder): Update user.
	* dzn/code/scmackerel/makreel.scm (ast->process): Update user.

	code: Split (dzn code goops) into (dzn code ast) and (dzn code shared).
	* dzn/code/goops.scm: Split into...
	* dzn/code/shared.scm: ...this, and, ...
	* dzn/code/ast.scm: ...this.
	* dzn: Update module includes accordingly.

2024-04-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Refactor location-prefix.
	* dzn/vm/report.scm (location-prefix): Refactor into...
	(location-prefix <boolean>, location-prefix <statement>, location-prefix
	<model>): ...method with these specializations to compensate for having
	a model as #:statement.

2024-04-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Make <on> observable instead of <initial-compound>.
	* dzn/vm/util.scm (make-implicit-illegal): Rewrite to make an <on> with
	a <declarative-illegal> statement.
	* dzn/vm/step.scm (step <initial-compound>): Update accordingly.
	(step <program-counter> <declarative-illegal>): Handle it in new
	specialization.
	* dzn/vm/compliance.scm (zip, check-provides-compliance,
	check-provides-compliance+, update-shared-state): Use <on>
	instead of <initial-compound>.
	* dzn/vm/report.scm (pc-event? <initial-compound>): Change to...
	(pc-event? <on>): ...this.
	(pc->event <initial-compound>): Change to...
	(pc-event <on>): ...this.
	(pc-component? <initial-compound>): Change to...
	(pc-component? <on>): ...this.
	(pc->component <initial-compound>): Change to...
	(pc-component <on>): ...this.
	(pc-arrow? <initial-compound>): Change to...
	(pc-arrow? <on>): ...this.
	(pc->arrow <initial-compound>): Change to...
	(pc-arrow <on>): ...this.
	(complete-split-arrows-pcs): : Use <on> instead of <initial-compound>.

	code: Remove stray debugging pke's.
	* dzn/code/scmackerel/code.scm (declarative-compound->code): Remove pke's.

2024-03-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: compliance_blocking_double_release: Skip verify.
	* test/all/compliance_blocking_double_release/META: Add skip verify.

2022-02-10  Paul Hoogendijk  <paul@dezyne.org>

	test: compliance_blocking_double_release2: Rename from blocking_double_release.
	* test/all/blocking_double_release2: Rename to...
	* test/all/compliance_blocking_double_release: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

2024-03-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: blocking_multiple_provides0: Skip verify.
	* test/all/blocking_multiple_provides0/META: Add skip verify.

2024-03-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	runtime: Cleanup interface.
	* dzn/vm/runtime.scm (runtime:instance->path): Refactor.
	(runtime:kind): Use ast:requires? instead of runtime:requires-instance?
	(runtime:other-port-unmemoized): Use is-a? instead of
	runtime:component-instance?, runtime:foreign-instance? runtime:system-instance?.
	runtime:component-instance?,
	runtime:foreign-instance?,
	runtime:foreign-instance?,
	runtime:port-instance?,
	runtime:provides-instance?,
	runtime:runtime-provides-port*,
	runtime:runtime-requires-port*,
	runtime:system-instance?,
	runtime:system-port?): Remove.

	 and an empty message aborts the commit.

2024-03-16  Janneke Nieuwenhuizen  <janneke@gnu.org>

	graph: Show sut and instances when debugging.
	* dzn/explore.scm (lts): When %debug?, show sut and instances.

	simulate: Show sut and instances when debugging.
	* dzn/simulate.scm (simulate**): When %debug?, show sut and instances.

2024-03-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add hello_header.
	* test/all/hello_header: New test.
	* test/all/local.mk (HELLO_TESTS): Add it.

2024-03-18  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: runtime: Remove runtime:%sut-port?.
	* dzn/vm/runtime.scm (runtime:%sut-port?): Remove.

2024-03-17  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Cleanup run-requires-flush.
	* dzn/vm/run.scm (run-requires-flush): Use trigger->component-trigger.

	vm: Cleanup run-external-modeling.
	* dzn/vm/run.scm (run-external-modeling): Use
	trigger->component-trigger.

	vm: Cleanup run-silent.
	* dzn/vm/run.scm (run-silent): Use trigger->component-trigger.

	vm: Cleanup run-requires.
	* dzn/vm/run.scm (run-requires): Use trigger->component-trigger.

2024-03-16  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Nitpick run-requires.
	* dzn/vm/run.scm (run-requires): Use r:port instead of port-instance.

	vm: Cleanup assign.

	vm: Refactor variables-prefixed-with-name.
	* dzn/vm/util.scm (merge-port-state): Use let, drop cons.

2023-08-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: normalize: Nitpick.
	* test/dzn/normalize.scm: Move (test-end) into same scope as test-begin
	"simplify".

	test: Add implicit_temporary3.
	* test/all/implicit_temporary3/implicit_temporary3.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	test: Add implicit_temporary2.
	* test/all/implicit_temporary2/implicit_temporary2.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	test: Add implicit_temporary1.
	* test/all/implicit_temporary1/implicit_temporary1.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2023-08-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add implicit_temporary0.
	* test/all/implicit_temporary0/implicit_temporary0.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2025-08-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	dzn: Rename (dzn ast goops) to (dzn ast ast).
	* dzn/ast/goops.scm: Rename to...
	* dzn/ast/ast.scm: ...this.
	* dzn/ast/local.mk (dist_%C%_scm_DATA): Update accessor.

2023-07-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: Cater for <skip>.
	* dzn/code/scmackerel/code.scm (ast->code <object>, ast->code <skip>):
	New specializations.

2023-07-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Add ast:add-statement*.
	* dzn/ast.scm (ast:add-statement*): New method, factored-out from...
	* dzn/ast/normalize.scm (add-defer-end): ...here.

2023-08-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: Move blocking-into-binding until after triplets.
	* dzn/ast/normalize.scm (binding-into-blocking): Cater for
	<declarative-illegal>.
	* dzn/code.scm (code:normalize-): Move blocking-into-binding up.

2023-07-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Add ast:add-statement.
	* dzn/ast.scm (ast:add-statement): New method.

2024-10-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	peg: Whitespace.
	* dzn/peg/codegen.scm (wrap-parser-for-users): Wrap lines.

2024-03-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: Throw error when event not found in constraining LTS.
	* dzn/code.scm (code:shared): Change debugging hack into programming error.

2024-03-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	verify: Deprecate -a,--all for new -k,--keep-going.
	Also refactor implementation.

	* dzn/commands/verify.scm (parse-opts): Add -k,--keep-going.  Mention
	deprecation of -a,--all.
	(main): Issue a deprecation warning when using -a,--all.  Pass
	new #:keep-going parameter to...
	* dzn/verify/pipeline.scm (verification:verify): ...here.  Add
	new #:keep-going? parameter.  Refactor to use that instead of
	command-line:get.  Pass it to...
	(mcrl2:verify): ...here.  Likewise.  Pass it to...
	(mcrl2:verify-component): ...here, and...
	(mcrl2:verify-interface): ...here, and...
	(mcrl2:verify-component-asserts): ...here, and...
	(mcrl2:verify-interface-asserts): ...here, and...
	(reduce-or): ...here.
	* test/dzn/dzn.scm (run-verify): Use --keep-going.
	* test/bin/update.sh: Likewise.
	* doc/dezyne.texi (Invoking dzn verify): Document it.

2024-03-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	graph: Consider foreign stubs at boundary.
	This fixes LTS for foreign_import.

	* dzn/vm/util.scm (labels): Also return labels for foreign stubs at
	boundary.

2023-09-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	traces: Cleanups.
	* dzn/commands/traces.scm (model->lts): Remove unused file-name
	parameter.  Fix constant error message.
	(main): Update caller.

2023-08-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	simulate: Avoid `possibly wrong number of arguments' warning.
	* dzn/simulate.scm (end-report): Use cute instead of cut with keyword
	arguments.

	parse: Respect COLUMNS when pretty-printing parse-tree or ast.
	* dzn/commands/parse.scm (main): Set width from COLUMNS environment
	variable.

	ast: Add #:width parameter to ast:pretty-print.
	* dzn/ast/display.scm (ast:pretty-print): Add new #:width parameter.

	test: parse_locations: Use COLUMNS=79.
	* test/all/parse_locations/run: Set COLUMNS to 79.

	build: Avoid direnv errors in pre-inst-env.
	* build-aux/pre-inst-env.in: Redirect grep LC errors to /dev/null.
	Only exec when when arguments given to exec.

2023-08-01  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Remove usused value from let.
	* dzn/code/scmackerel/c++.scm (component-model->sm:statements-unmemoized):
	Remove this-out-binding.

2023-07-25  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Split-off list-models.
	* dzn/commands/parse.scm: Remove (dzn parse tree) dependency leading to
	.parent conflict.
	(list-models): Rename to...
	(display-models): ...this, ...
	(main): ...update caller, and factor-out creation of ((name . type) ...)
	alist to...
	* dzn/parse/util.scm: ...this new file.
	* dzn/parse/local.mk (dist_%C%_scm_DATA): Add it.

2023-08-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	tree: Move (dzn parse util) to (dzn parse location).
	* dzn/parse/util.scm: Rename to...
	* dzn/parse/location.scm: ...this.
	* dzn/parse/local.mk (dist_%C%_scm_DATA): Update accordingly.
	* dzn/commands/language.scm,
	dzn/parse/lookup.scm,
	dzn/trace.scm,
	test/dzn/language.scm: Update module uses.

2023-07-31  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: Remove dead code.
	This is a follow-up to commit
	    5aa518003a150f843a643ed0f5ed8244b5c2e582
	    verify: Fix non-determinstic constraint deadlock.

	* dzn/code.scm: (code:shared)[trigger?]: Restore check for string?.

2023-07-27  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Remove useless code.
	This is a follow-up to commit
	    270c9d9255e3ded24de65c08bee2ac3fe5f287a8
	    makreel: Strict state synchronization at port run to completion.

	* dzn/code/scmackerel/makreel.scm (ast->process <component>
	<action-reply>): Refactor remove redundant string-append.

2023-08-02  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: parse-flags: Remove PWD hack.
	* test/all/parse-flags/parse.sh: Remove SED'ing away working-directory.

2023-07-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse; Remove working-directory.
	This effectively reverts commit
	    5d81a1335b1494a5978a4d564e6e6635cd076f5b
	    parse: Add working-directory to preprocess output and ast.

	Before 2.19, the working-directory--an exclusive requirement for
	Verum-Dezyne's graphical views--was passed through the DZN client code,
	including the processor stream, the AST, system, state, and trace
	output.  In 2.19, Verum-Dezyne handles working-directory administration
	locally.

	* dzn/parse.scm (parse:file->content-alist): Remove working-directory
	return value.
	(parse:content-alist->tree-alist): Likewewise, update caller.
	(parse:file->tree-alist+content-alist): Likewise.
	(parse:annotate-ast): Likewise.
	(parse:file->stream): Do not prepend #dir to stream.
	(parse:file-match): New procedure, factored-out from...
	(parse:stream->content-alist): ...here.  Remove "#dir" stripping.
	* test/all/hello_imported/hello_imported.dzn: Update accordingly.

2023-07-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	graph: Remove working-directory.
	This effectively reverts commit
	    2e3b001522b6b74b402b6220a07594d74f00cd2c
	    explore: Add working-directory to json output.

	* dzn/ast/goops.scm (<root>)[working-directory]: Remove field.
	* dzn/ast/parse.scm (parse:tree->ast): Remove #:working-directory parameter.
	* dzn/parse.scm (parse:tree-alist->ast): Update caller.
	* dzn/explore.scm (state-diagram->json): Remove working-directory
	parameter.
	(state-diagram): Update caller.
	* test/all/parse-flags/baseline/parse.out,
	test/all/parse_locations/baseline/parse.out: Update baseline.

2023-07-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Refactor preprocessor.
	* dzn/parse.scm (parse:string->content-alist): Rename to...
	(parse:stream->content-alist): ...this.  Do not cater for any string,
	expect preprocessed stream, and refactor.
	(parse:preprocessed?): New procedure.
	(parse:file->content-alist): Use it to dispatch to...
	(parse:stream->content-alist): ...this.  Remove special handling for stdin.
	(parse:string->tree-alist+content-alist): Remove.
	(parse:file->tree-alist+content-alist): Remove special handling for
	stdin.
	(parse:file->tree-alist): Likewise.
	(parse:string->ast): Remove dependency on pacse:string->content-alist.

2023-07-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Allow parsing without locations.
	This is a follow-up to commit
	    977ec01b18375cf62f9f1a11106096596cc8882c
	    ast: Cleanup parse-tree->ast, preserve some comments.

	* dzn/parse.scm (parse:string->tree): Add #:locations? parameter.
	* dzn/ast/parse.scm (strip): Cater for empty arguments,
	types-and-events, formals.

2023-07-25  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Refactor and cleanup exception handling.
	This is a second follow-up to commit
	    4e019304f5c10a8b182a4dcbc5304639d9d6851d
	    parse: Add and evaluate fall-back parse return code.

	This removes the all-over-the-place exception handling and
	multiple-values parse-failed? return and #:debug? parameter handling,
	using exeption handling at toplevel exclusively.

	* dzn/parse.scm (parse:call-with-handle-exceptions): Return #f instead
	of multiple values (unless #:exit?).
	(parse:string->fall-back-tree): Remove wrapper only setting
	paramaterize--which belongs in client code, while also lying about it in
	its docstring.
	(parse:string->tree): Remove #:fall-back? parameter and factor
	gratuitous `parse without fall-back when in fall-back mode' out to...
	(parse:string->tree*): ..this new procedure.
	(parse:file->tree parse:content-alist->tree-alist,
	parse:file->tree-alist+content-alist, parse:file->tree-alist,
	parse:string->ast, parse:file->ast): Remove #:debug? parameter,
	parse-failed? return value, and move exception handling out to...
	* dzn/commands/parse.scm (parse-tree): ...here, and...
	(parse): ...here.  Update accordingly and refactor to use only one
	toplevel exception handler.
	(main): Update accordingly.  Also respect -o,--output for parse tree.

2023-07-16  Janneke Nieuwenhuizen  <janneke@gnu.org>

	parse: Refactor to use consistent naming and separate stages.
	Use consistent naming: parse:<from>-><to>, categorize into sections:
	content-alist, parse tree and tree-alist, and ast.

	* dzn/parse.scm (peg:line-number, peg:column-number, peg:line,
	peg:message, peg:imported-from->message, peg:error-message,
	peg:syntax-error->message, peg:handle-syntax-error, peg:flatten-tree,
	format-capture-syntax-error, format-display-syntax-error): Move to...
	* dzn/peg/util.scm: ...this new file.
	* dzn/peg/local.mk (dist_%C%_scm_DATA): Add it.

	* dzn/parse.scm (file->string): Factor-out from...
	(file->stream): ...here.  Rename to...
	(parse:file->stream): ...this.
	(call-with-handle-exceptions): Rename to...
	(parse:call-with-handle-exceptions): ...this.  Add #:exit parameter.

	(file+import-content-alist): Rename to...
	(parse:file->content-alist): ...this
	(string->file+import-content-alist): Rename to...
	(parse:string->content-alist): ...this.

	(string->parse-tree): Rename to...
	(parse:string->tree): ...this.
	(parse:file->tree): New procedure.
	(string->fall-back-parse-tree): Rename to...
	(parse:string->fall-back-tree): ...this.  Add comment about lying
	docstring.
	(parse:string->tree-alist+content-alist): New procedure.
	(parse-file+import-content-alist): Rename to...
	(parse:content-alist->tree-alist): ...this.

	* dzn/parse.scm (string->transformation): Move to...
	* dzn/commands/parse.scm (string->transformation): ...here.
	(parse:file->tree-alist+content-alist, parse:file->tree-alist,
	parse:annotate-ast): New procedures.  Factored-out from...
	(file->ast): ...this, renamed to...
	(parse:file->ast): ..this, and out from...
	(string->ast): ...this, renamed to...
	(parse:string->ast): ...this.  Also, move well-formedness checking,
	and transformations to...

	* dzn/commands/parse.scm (parse): ...here.  Update callers.  Move
	parse-tree and fall-back cases to...
	(parse-tree): this new procedure.
	(preprocess): Update callers.  Move handling aof exit to...
	(main): ...here.  Omit useless '[no ]errors found' in fall-back parsing.

	* dzn/commands/graph.scm,
	dzn/commands/language.scm,
	dzn/commands/verify.scm,
	dzn/parse/stress.scm,
	dzn/simulate.scm,
	dzn/trace.scm: Update callers.

	* dzn/script.scm (%time %measure): Update for new parse names.

	* test/all/parse_fall_back_import_path/baseline/verify.out,
	test/all/parse_fall_back_import_self/baseline/verify.out,
	test/all/parse_fall_back_non_existent_import/baseline/verify.out,
	test/all/parse_fall_back_out_binding_argument/baseline/verify.out,
	test/all/parse_fall_back_preprocessed_foo/baseline/verify.out,
	test/all/parse_fall_back_preprocessed_imported_bar/baseline/verify.out,
	test/all/parse_fall_back_preprocessed_imported_baz/baseline/verify.out,
	test/all/parse_fall_back_syntax/baseline/verify.out: Remove.
	* test/all/parse_fall_back_import_path/baseline/verify.err,
	test/all/parse_fall_back_out_binding_argument/baseline/verify.err:
	Update accordingly.
	* test/all/parse_peg_locations/baseline/verify.out: New file.

2023-07-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: Change code:add-calling-context into a regular normalization.
	* dzn/code.scm (code:formal*, code:argument*): Remove.
	(code:add-calling-context-formal <formals>,
	code:add-calling-context-argument <arguments>,
	code:add-calling-context <root>): Merge methods into...
	(code:add-calling-context):  ...this new procedure.
	* dzn/transform.scm: Re-export it.
	* dzn/code/legacy/code.scm,
	dzn/code/scmackerel/c++.scm,
	dzn/code/scmackerel/c.scm,
	dzn/code/scmackerel/code.scm,
	dzn/code/scmackerel/cs.scm,
	dzn/templates/code.scm: Update callers.

	code: Change code:annotate-shells into regular normalization.
	* dzn/code.scm (code:annotate-shells): Refactor into full normalization.
	(code:normalize-): Use it.
	(code:model*): Remove on-the-fly normalization.
	* dzn/code/language/cs.scm (cs:normalize): Use it.

2023-09-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Keep <defer> event on input/output trail for c++.
	* test/dzn/dzn.scm (run-execute): Only remove <defer> for languages
	other than c++.

	c++: Log <defer> meta-event.
	* runtime/c++/dzn/runtime.hh (defer): Print <defer> before executing
	deferred event.

2025-06-10  Rutger van Beusekom  <rutger@dezyne.org>

	lts: Reformat label parsing.
	* dzn/lts.scm (parse-label): Introduce event-argument, modeling and EOF;
	reorder and format.

2024-11-05  Rutger van Beusekom  <rutger@dezyne.org>

	normalize: Eradicate noisy and refactor.
	* dzn/ast/goops.scm (.arguments, <function>): Remove noisy.
	* dzn/ast/local.mk (dist_%C%_scm_DATA): Replace silence.scm with recursive.scm
	* dzn/ast/normalize.scm (dzn): Remove add-determinism-temporaries,
	%noisy-ordering?: Remove parameter.
	(temporaries): Document, rename internal add-temporary? to temporary?.
	(temporaries*): Rename from noisy-temporaries.
	(add-temporary?): Split into add-temporary? and add-temporary*?.
	(split-complex?, split-complex-expressions, add-temporary,
	split+add-temporaries, add-explicit-temporaries): Refactor: curry to
	reduce size of add-explicit-temporaries and allow unit-testing of former
	inner functions.
	* dzn/ast/recursive.scm: Extract determining and setting function #:recursive? from silence.
	* dzn/code.scm (dzn): Remove code:normalize+determinism and replace with add-explicit-temporaries.
	* dzn/code/language/c++.scm (ast->),
	* dzn/code/language/c.scm (ast->): Replace code:normalize+determinism with code:normalize.
	* dzn/code/language/makreel.scm: Update add-explicit-temporaries accordingly.
	* dzn/parse.scm (dzn): Replace silence with recursive,
	(file->ast): Replace silence:annotate-functions with annotate-recursion.
	* dzn/script.scm (%time): Remove code:normalize+determinism.
	* dzn/transform.scm (dzn): Remove add-determinism-temporaries,
	code:normalize+determinism, split-complex-expressions.
	* dzn/vm/normalize.scm (vm:normalize): Update add-explicit-temporaries accordingly.
	* test/all/code-json/baseline/parse.out: Update baseline without noisy.
	* test/dzn/local.mk (UNIT_TESTS): Remove silence.scm.
	* dzn/ast/silence.scm: Delete

2025-01-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `ROADMAP'.
	* ROADMAP (Release 2.20.2.22): Bump to 2.21..2.23.
	(Release 2.19): Add data return, invariants, global functions, dzn
	hash/build.  Move everything except node/parent, serialization to...
	(Release 2.20): ...this new section.  Add parallel operator task for
	scmackerel.
	(Release 2.21..Release 2.15): New sections.
	(Release 2.21, Release 2.22, Release 2.23): Bump to...
	(Release 2.26, Release 2.27, Release 2.28): ...this.

2025-09-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Whitespace.
	* doc/dezyne.texi: Use two spaces at end of sentence.

2025-09-02  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add parse_defer_expression.
	* test/all/parse_defer_expression: New test.
	* test/all/local.mk (PARSER_TESTS): Register it.

2025-09-03  Janneke Nieuwenhuizen  <janneke@gnu.org>

	peg: Add defer-argument that is a reference.
	* dzn/parse/peg.scm: (peg:parse)[defer-arguments, defer-argument]: New
	nonterminals.
	[defer]: Use them.
	* dzn/ast/parse.scm (parse-tree->ast): Cater for them.

	wfc: Remove defer argument check for <expression>.
	* dzn/ast/wfc.scm (wfc-defer-argument <expression>): Remove.

	Revert "test: parse_defer: Add expression as defer parameter."
	This reverts commit 807866dd8dc7aedb8e376fa2801551584e9c8c78.

2025-09-02  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: parse_defer: Add expression as defer parameter.
	* test/all/parse_defer/ihello_world.dzn: New symlink.
	* test/all/parse_defer/parse_defer.dzn: Import it.
	(ihello):: Remove.
	(parse_defer): Use it.  Add defer (true);
	* test/all/parse_defer/baseline/verify.err: Update baseline.

	wfc: Check defer arguments for bare expressions.
	* dzn/ast/wfc.scm (wfc-defer-argument): Split procedure into...
	(wfc-defer-argument <var>,
	wfc-defer-argument <shared-var>,
	wfc-defer-argument <undefined>>): These new methods.
	(wfc-defer-argument <expression>): New specialization.

2025-09-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add circular_import_directory.
	* test/all/circular_import_directory: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	test: Add hello_circular_import.
	* test/all/hello_cirular_import: New test.
	* test/all/local.mk (FEATURE_TESTS): Register it.

2025-09-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Update copyright headers.
	Run build-aux/copyright-header.scm.

	build-aux/copyright-header.scm: Cater for ranges.
	* build-aux/copyright-header.scm (file-authors): Cater ranges.
	(range-expand): New procedure.
	(file-author-copyright-years): Use it, and cater for ranges.
	(year/range->string): New procedure.
	(create-ranges): Use it in new procedure.
	(flatten-years): New procedure.
	(author-copyright-line): Use it, and cater for ranges.

	doc: `README': Mention the use of ranges in copyright notices.
	* README (Copyright Notices): New section.
	* runtime/c++/dzn/coroutine.hh,
	runtime/c++/dzn/runtime.hh: Typo.

2025-09-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	c: Cater for gcc-14's strictness.
	* dzn/code/language/c.scm (c:formal-type-name): New method.
	* dzn/code/scmackerel/c.scm (c:log-event-type-cast): Use it.

2025-08-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Update to 2.18.4.
	* guix/pack/dezyne.scm (dezyne): Update to 2.18.4.

2024-11-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update NEWS.
	* NEWS (Changes in 2.18.4 since 2.18.3): New section.

2025-08-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Fix some email addresses.
	* test/all/blocking_defer/blocking_defer.dzn,
	test/all/shadow_shared_enum/shadow_shared_enum.dzn,
	test/all/shared_enum/shared_enum.dzn: Fix email address.

2025-08-26  Rutger van Beusekom  <rutger@dezyne.org>

	test: Fix starving_philosophers cs compilation.
	* test/all/starving_philosophers/starving_philosophers.dzn (Test): Add
	test muxer.
	(starving_philosophers): Use it.
	* test/all/starving_philosophers/main.cc (main): Update to use Test
	muxer.
	* test/all/starving_philosophers/main.cs: Replace symlink with new file.

	test: Fix dining_philosophers cs compilation.
	* test/all/dining_philosophers/Timer.cs (t_deferred, t_set): Rename
	output to out_port.
	* test/all/dining_philosophers/main.cs (Main): Add missing name
	argument, update for Test muxer component.

2025-08-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: Remove mono.
	* guix/mono-mdoc-timestamping.patch,
	guix/pack/mono.scm: Remove.

2025-07-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Eradicate behaviour, again.
	* test/all/defer_after_call/defer_after_call.dzn,
	test/all/hello_constraint/hello_constraint.dzn,
	test/all/hello_hello_block/hello_hello_block.dzn,
	test/all/no_unreachable/no_unreachable.dzn,
	test/all/simplify_guards/simplify_guards.dzn,
	test/all/unreachable_defer/unreachable_defer.dzn,
	test/all/unreachable_determinism/unreachable_determinism.dzn,
	test/all/unreachable_function/unreachable_function.dzn,
	test/all/unreachable_if/unreachable_if.dzn,
	test/all/unreachable_return/unreachable_return.dzn: Use behavior.

2025-08-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: Bump to a440ce45676eb96b3cfbcc01a498345e3905b769.
	This provides a bootstrapped mono-6.12 from upstream.

	* guix.scm: Update to a440ce45676eb96b3cfbcc01a498345e3905b769.

2025-08-08  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Synchronize queue-empty between component and semantics.
	* dzn/code/scmackerel/makreel.scm (ast->process <the-end>)
	(ast->process <if>): Add queue_empty choice here.
	(component-defer-processes): Allow queue_empty here.
	(component-semantics-processes): Comm queue_emtpy here.

2025-08-06  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Synchronize provides flush with semantics.
	* dzn/code/scmackerel/makreel.scm (component-semantics-processes): Add
	flush to mCRL2 comm, do not hide flush and state.
	* dzn/verify/pipeline.scm (compliance-taus): Add flush to --tau.

	makreel: Move state communication after behavior'end.
	* dzn/code/scmackerel/makreel.scm (ast->process <behavior>): Move state
	communication.
	(ast->variable-process <the-end>, ast->process <the-end>,
	semantics-async): Here.

2025-08-09  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Remove redundant state communication: semantics_main.
	* dzn/code/scmackerel/makreel.scm (semantics-main): Remove state
	communication for silent modeling event.

2025-08-08  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Refactor sum-state-action.
	* dzn/code/scmackerel/makreel.scm (sum-state-action continuation):
	Remove by inlining the addition of sm:sequence*
	* dzn/code/scmackerel/makreel.scm (ast->process, %blocked-formals)
	(semantics-async): Here.

2025-08-06  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Refactor shared state variables.
	* dzn/code/scmackerel/makreel.scm (ast->process): Avoid filtering shared
	variables for specific port by mapping over shared variables and using
	their ports.

2025-08-10  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Refactor remove code duplication.
	* dzn/code/scmackerel/makreel.scm (ast->variable-process): Rename from
	ast->process.
	(ast->process <assign>): Implement in terms of ast->variable-process.
	(ast->process <variable>): Implement in terms of ast->variable-process.

2025-08-12  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_choice_defer.
	* test/all/hello_choice_defer: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-08-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Avoid changing instance on error PCs, fixes choice labels.
	* dzn/vm/run.scm (run-flush <program-counter> <runtime:component>): Do
	not flush an PC with status set.

2025-08-12  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_choice_async.
	* test/all/hello_choice_async: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2025-08-06  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add shared_no_function.

	test: Add shared_function.

2025-08-07  Rutger van Beusekom  <rutger@dezyne.org>

	test: shared_choice2: Complete redundant shared state.
	* test/all/shared_choice2/shared_choice2.dzn (shared_choice2): Complete
	redundant shared state.

2025-08-06  Rutger van Beusekom  <rutger@dezyne.org>

	test: shared_requires_guard: Add provides port shared state.
	* test/all/shared_requires_guard/shared_requires_guard.dzn
	(shared_requires_guard): Add provides port shared state.

2025-08-08  Rutger van Beusekom  <rutger@dezyne.org>

	test: hello_blocking_asynchronous_sync_out: Remove trailing assign.
	* test/all/hello_blocking_asynchronous_sync_out/hello_blocking_asynchronous_sync_out.dzn:
	(iworlda): Remove trailing assign.
	(hello_blocking_asynchronous_sync_out): Update accordingly.

	test: shared_choice2: Remove trailing assign.
	* test/all/shared_choice2/shared_choice2.dzn: Remove trailing assign.

2025-07-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: blocking_shell: Cater for gcc-14 / c++20.
	In c++20, the default for gcc-14, "requires" has become a keyword.

	* test/all/blocking_shell/c++/main.cc (main): Use provide/require
	instead of provides/requires.

2025-07-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	dzn: Indentation fixes.
	Run:

	    build-aux/indent.scm $(find . -name '*.scm')

2025-07-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build-auix/indent.scm: Fixes for Emacs 30.

2025-06-17  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Fix deadlock for state change in if-statement in interface.
	Add if statement state communication normalization.

	* dzn/code/language/makreel.scm: (makreel:add-state-placeholder): Handle
	if statement.
	* test/all/hello_guard_if/hello_guard_if.dzn: Add if statements with and
	without compound to the interface.
	* test/all/determinism_interface/baseline/verify.out: Update baseline.

2025-05-27  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Selectively block state communication.
	* dzn/code/scmackerel/makreel.scm: Define %shared parameter,
	(root->scmackerel): Initialize here,
	(makreel:shared-process-arguments, ast->process, assign->sum,
	ast->process, semantics-unblocked, semantics-blocking,
	semantics-skip-blocking, semantics-blocked, semantics-reply,
	semantics-blocked-main, semantics-async, component-semantics-processes):
	Replace ast:shared* with %shared parameter,
	(provides-processes, component-no-q-processes): Block %state-action.

	makreel: synchronize queue_empty in component_compliant constraint.
	* dzn/code/scmackerel/makreel.scm (component-assembly-processes): Add
	%queue-empty-action and %defer-qout-action communication.

2025-06-10  Rutger van Beusekom  <rutger@dezyne.org>

	lts: Use vanilla PEG
	* dzn/lts.scm (dzn): Replace (dzn peg) with (ice-9 peg)
	(parse-label): Remove parameterize %peg:debug?

2025-05-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	dzn: Fix printing of <shared-field-test>.
	* dzn/code/language/dzn.scm (print-ast <shared-field-test>): Print
	PORT.NAME.FIELD instead of ast:full-name.

	dzn: Fix printing of <shared-var>.
	* dzn/code/language/dzn.scm (print-ast <shared-var>): Print PORT.NAME
	instead of ast:full-name.

	dzn: Fix printing of void <return>.
	* dzn/code/language/dzn.scm (print-ast <return>): Omit <void>.

	test: Add nested.space.interface_function.
	* test/all/nested.space.interface_function: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	test: Add space.interface_function.
	* test/all/space.interface_function: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	dzn: Fix printing of nested namespace.
	* dzn/code/language/dzn.scm (print-ast <namespace>): Use ast:name
	instead of ast:dotted-name.

2025-05-12  Rutger van Beusekom  <rutger@dezyne.org>

	c: Add '\n' to dollar statements.
	* dzn/code/scmackerel/c.scm (root->header-statements): Here.

2025-05-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: mcrl2-next, mcrl2-next-minimal: Update to 202407.1
	* guix/pack/mcrl2.scm (mcrl2-next): Update to 202407.1.

2023-08-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: mcrl2-next, mcrl2-next-minimal: Update to 202307.1.
	* guix/pack/mcrl2.scm (mcrl2-next): Update to 202307.1.

2023-08-16  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Use mcrl2-next-minimal.
	* guix/pack/dezyne.scm (dezyne)[inputs]: Replace mcrl2-minimal with
	mcrl2-next-minimal.

2020-05-14  Jan (janneke) Nieuwenhuizen  <janneke@gnu.org>

	guix: Add mcrl2-next, mcrl2-next-minimal.
	* guix/pack/mcrl2.scm: New file.

2025-05-08  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Initialize dzn_state explicitly to the first node number.
	* dzn/code.scm (code:shared-state): Return multiple values, the second
	being the initial state number.
	* dzn/code/scmackerel/c++.scm (interface->sm:statements-unmemoized):
	Initialize dzn_state witht the first state number instead of 0.

2025-04-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add Camera.
	* test/all/local.mk (REGRESSION_TESTS): Add Camera.
	* test/all/Camera/META: Skip all languages except for c++.

2025-05-08  Rutger van Beusekom  <rutger@dezyne.org>

	test: Camera: Update foreign for new enum usage.
	* test/all/Camera/c++/Contrast.hh (struct Contrast): Remove old style
	::type.

2025-03-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add nested.space.system_hello.
	* test/all/nested.space.system_hello: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	javascript: Support nested namespaces.
	* dzn/code/language/javascript.scm: (javascript:module-name): Recurse to
	use deepest namespace's full name.

	scheme: Support nested namespaces.
	* dzn/code/language/scheme.scm: (scheme:module-name): Recurse to use
	deepest namespace's full name.
	* test/all/compound.space/compound.space.dzn,
	test/all/inner.space/inner.space.dzn: Make sure the module target's
	namespace is declared as the first namespace.

2025-03-25  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add shared_nested.

2025-03-26  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: compliance: Fix shared_nested.
	* dzn/vm/compliance.scm (internal-check-compliance): Use the initial pc
	to prevent check-provides-compliance from executing an update on a pc
	with updated state.

2024-09-20  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_cruelworld.

2021-11-16  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add starving_philosophers.
	XXX splits?

	test: Add dining_philosophers.
	XXX splits?

2022-03-17  Paul Hoogendijk  <paul@dezyne.org>

	test: Add collateral_blocking_backdoor_bypass.
	* test/all/collateral_blocking_backdoor_bypass: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2022-03-18  Paul Hoogendijk  <paul@dezyne.org>

	test: Add collateral_blocking_out2.
	* test/all/collateral_blocking_out2: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2024-03-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add empty_system.
	* test/all/empty_system: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-08-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add blocking_local_state.
	* test/all/blocking_local_state: New test, copied from...
	* test/all/blocking-local-state-diagram/blocking-local-state-diagram.dzn:
	...here.  Change to symlink.
	* test/all/blocking-local-state-diagram/baseline/default.dot: Update
	accordingly.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-08-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Also read features from META.
	* test/dzn/dzn.scm (file-name->features): Factor-out from...
	(features): ...here.  Include features from META.

2024-07-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Revert "hello_injected: Remove handwritten c++ main."
	hello_injected runs check_bindings and dump_tree.

	This reverts commit 0d78e20f3356f32dfb3ec78b4e8f69dea5b4d421.

2024-03-18  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: hello_injected: Canonicalize.
	* test/all/hello_injected/hello_injected.dzn: Canonicalize.
	* test/all/hello_injected/main.c,
	test/all/hello_injected/main.cs,
	test/all/hello_injected/main.js,
	test/all/hello_injected/main.scm,
	* test/all/hello_injected/trace: Update accordingly.

2024-06-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: system_shared_choice2: Rename from system_shared.
	* test/all/system_shared: Rename to...
	* test/all/system_shared_choice2: ...this.
	* test/all/shared_choice2/shared.dzn: New symlink.
	* test/all/system_shared_choice2/baseline: Update accordingly.

	test: Add shared_choice2.
	* test/all/shared_choice2: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	test: Add system_hellocruelworld.
	* test/all/system_hellocruelworld: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add hellocruelworld_requires.
	* test/all/hellocruelworld_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add hellocruelworld.
	* test/all/hellocruelworld: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: queuefull_component1: Use ihello, ihellocruelworld.
	* test/all/queuefull_component1/ihello.dzn,
	test/all/queuefull_component1/ihellocruelworld.dzn: New symlinks.
	* test/all/queuefull_component1/queuefull_component1.dzn: Import them.
	(ihello, iworld): Remove.
	(queuefull_component1): Update accordingly.
	* test/all/queuefull_component1/baseline/simulate.err,
	test/all/queuefull_component1/baseline/simulate.out,
	test/all/queuefull_component1/baseline/verify.err,
	test/all/queuefull_component1/baseline/verify.out: Update baseline.

	test: Add ihellocruelworld.
	* test/all/ihellocruelworld: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-06-18  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: compliance_return_implicit: Rename from compliance_implicit_illegal.
	* test/all/compliance_implicit_illegal: Rename to...
	* test/all/compliance_return_implicit: ...this.
	(REGRESSION_TESTS): Remove compliance_implicit_illegal.
	* test/all/local.mk (SEMANTIC_ERROR_TESTS): Add compliance_return_implicit.

	test: compliance_return: Rename from compliance0.
	* test/all/compliance0: Rename to...
	* test/all/compliance_return: ..this; Canonicalize.
	* test/all/local.mk (FEATURE_TESTS): Remove compliance0.
	(SEMANTIC_ERROR_TESTS): Add compliance_return.

2024-05-29  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add if_return_arrow.
	The return arrow was missing when using a single if-statement.

	* test/all/if_return_arrow: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-05-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add hello_nonstrict.
	* test/all/hello_nonstrict: New test.
	* test/all/local.mk (FEATURE_TESTS): Add it.

	test: Add ihello_nonstrict.
	* test/all/ihello_nonstrict: New test.
	* test/all/local.mk (FEATURE_TESTS): Add it.

2024-06-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: deadlock_defer_calls: Rename from defer_calls.
	* test/all/defer_calls: Rename to...
	* test/all/deadlock_defer_calls: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: queuefull_defer: Rename from defer_queuefull.
	* test/all/defer_queuefull: Rename to...
	* test/all/queuefull_defer: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: queuefull_collateral_reply: Rename from collateral_queuefull_reply.
	* test/all/collateral_queuefull_reply: Rename to...
	* test/all/queuefull_collateral_reply: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: queuefull_collateral: Rename from collateral_queuefull.
	* test/all/collateral_queuefull: Rename to...
	* test/all/queuefull_collateral: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

2024-05-31  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: end_of_trail_int: Use ihello_reply_int.
	* test/all/ihello_reply_int/ihello_reply_int.dzn: New symlink.
	* test/all/end_of_trail_int/end_of_trail_int.dzn: Use it.
	(ihello_reply_int): Remove.

	test: Add ihello_reply_int.
	* test/all/ihello_reply_int: New test.  Extracted from end_of_trail_int.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-04-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add blocking_external2.

2024-04-04  Rutger van Beusekom  <rutger@dezyne.org>

	test: collateral_blocking_shell2: Adapt external behavior.
	This avoids the meaningless requires external blocking.

	* test/all/collateral_blocking_shell2/collateral_blocking_shell2.dzn
	(Adapter): New component ...
	* test/all/collateral_blocking_shell2/collateral_blocking_shell2.dzn
	(collateral_blocking_shell2): ... use here.

2024-04-04  Rutger van Beusekom  <rutger@dezyne.org>

	test: collateral_blocking_backdoor: Adapt external behavior.
	This avoids the meaningless requires external blocking.

	* test/all/collateral_blocking_backdoor/collateral_blocking_backdoor.dzn
	(adapter): New component ...
	* test/all/collateral_blocking_backdoor/collateral_blocking_backdoor.dzn
	(collateral_blocking_backdoor): .. use here.

2024-04-03  Rutger van Beusekom  <rutger@dezyne.org>

	test: Refactor collateral_blocking_shell.
	*
	test/all/collateral_blocking_shell/collateral_blocking_shell.dzn (Blocked):
	Remove redundant states and conditionals.

2024-05-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add ihello_int_1_1_reply_0.
	* test/all/ihello_int_1_1_reply_0: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-05-29  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_inevitable_choice.
	* test/all/hello_inevitable_choice: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-05-29  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add compliance_livelock_refusal.
	This is another variation on compliance_livelock; a tau loop hiding a
	compliance error.

	* test/all/compliance_refusal4: New test.
	* test/all/local.mk (SEMANTIC_ERROR_TESTS): Add it.
	(XFAIL_VERIFY): Add it.

2024-05-29  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add compliance_refusal_cruel__world.
	* test/all/compliance_refusal_cruel__world: New test.
	* test/all/local.mk (SEMANTIC_ERROR_TESTS): Add it.

	test: Add compliance_refusal_cruel_world.
	* test/all/compliance_refusal_cruel_world: New test.
	* test/all/local.mk (SEMANTIC_ERROR_TESTS): Add it.

	test: Add ihello_cruel_world.
	* test/all/ihello_cruel_world: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add compliance_refusal_world.
	* test/all/compliance_refusal_world: New test.
	* test/all/local.mk (SEMANTIC_ERROR_TESTS): Add it.

	test: Add ihello__world.
	* test/all/ihello__world: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-05-16  Rutger van Beusekom  <rutger@dezyne.org>

	test: update.sh: Ignore trailing /.

2024-05-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: hello_inevitable_illegal: Canonicalize.
	* test/all/hello_inevitable_illegal: Canonicalize.

2024-05-25  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: collateral_queuefull_reply: Rename from blocking_queuefull_reply; Canonicalize.
	* test/all/blocking_queuefull_reply: Rename to...
	* test/all/collateral_queuefull_reply: ...this; Canonicalize.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: collateral_queuefull: Rename from blocking_queuefull; Canonicalize.
	* test/all/blocking_queuefull: Rename to...
	* test/all/collateral_queuefull: ...this; Canonicalize.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: shell_injected_foreign: Rename from shell_injected.
	* test/all/shell_injected: Rename to...
	* test/all/shell_injected_foreign: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: compliance_single_to_multiple: Use i_world.
	* test/all/i_world/i_world.dzn: New symlink.
	* test/all/compliance_single_to_multiple/compliance_single_to_multiple.dzn:
	Import it.
	(ihello): Remove.
	(compliance_single_to_multiple): Update accordingly.
	* test/all/compliance_single_to_multiple/baseline/simulate.err,
	test/all/compliance_single_to_multiple/baseline/simulate.out,
	test/all/compliance_single_to_multiple/baseline/verify.err: Update baseline.

2024-05-24  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Also use quotes when string contains "<".
	* test/dzn/dzn.scm (observe): Also quote string with #\<.

	test: compliance_fork_blocking_bypass: Canonicalize.
	* test/all/compliance_fork_blocking_bypass/ihello.dzn,
	test/all/compliance_fork_blocking_bypass/ihello_i_world.dzn,
	test/all/compliance_fork_blocking_bypass/ihello_world.dzn: New symlinks.
	* test/all/compliance_fork_blocking_bypass/compliance_fork_blocking_bypass.dzn:
	Use them.
	(ihello, iworld, ibypass): Remove.
	* test/all/compliance_fork_blocking_bypass/trace: Update accordingly.

2024-05-25  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add ihello_i_world.
	* test/all/ihello_i_world: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-05-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Use numerical sort for traces.
	* test/dzn/dzn.scm (trace->base+number, trace<): New procedures.
	(run-code, run-simulate): Use them.

2024-05-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: hello_flush: Use i_world.
	* test/all/hello_flush/i_world.dzn: New symlink.
	* test/all/hello_flush/hello_flush.dzn: Use it.

2024-05-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: call_before_variable: Rename from parse_call_before_var.
	* test/all/parse_call_before_var: Rename to...
	* test/all/call_before_variable: ..this.
	* test/all/local.mk (PARSER_TESTS): Move from here...
	(REGRESSION_TESTS): ...to here, and update accordingly.

	test: queuefull_external: Canonicalize.
	* test/all/queuefull_external/i_world.dzn: Split off.
	* test/all/queuefull_external/queuefull_external.dzn: Import it,
	(queuefull_external): and use it.

2024-04-25  Janneke Nieuwenhuizen  <janneke@gnu.org>

	lts: Resurrect --illegals actually including <illegal>.
	This is a follow-up to commit
	    8616fcc622e781fe777c90eb4c4e09941e276b9c
	    lts: Remove duplicate <lts> data structure.

	* dzn/lts.scm (lts->traces)[illegal-node?, illegal-node->deadlock,
	illegal-livelock->deadlock]: New inner defines.
	Use them in order to enable...
	* dzn/lts.scm (generate-traces): ...this to output <illegal>s.  Adapt
	to cater for non-existing deadlock node.

2024-05-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: deadlock_state: Rename from state_deadlock.

	test: deadlock_inner_guard_shared_state: Rename from inner_guard_shared_state_deadlock.
	* test/all/inner_guard_shared_state_deadlock: Rename to...
	* test/all/deadlock_inner_guard_shared_state: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

2024-05-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: range_action: Canonicalize.

	test: Add ihello_reply_0.
	* test/all/ihello_reply_0: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: defer_empty_selection: Use ihello_world.
	* test/all/defer_empty_selection/defer_empty_selection.dzn: Use
	ihello_world.dzn and format.

	test: Add illegal_garbage.

	test: implicit_illegal_garbage: Rename from illegal_garbage.
	* test/all/illegal_garbage: Rename to...
	* test/all/implicit_illegal_garbage: ...this.

	test: second_reply_blocking: Canonicalize.
	* test/all/second_reply_blocking: Canonicalize.

2024-03-11  Paul Hoogendijk  <paul@dezyne.org>

	test: Add collateral_blocking.
	* test/all/collateral_blocking/collateral_blocking.dzn,
	* test/all/collateral_blocking/META: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-05-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: blocking_system4: Canonicalize.
	* test/all/blocking_system4/hello_block_reply_bool_requires.dzn,
	test/all/blocking_system4/hello_block_reply_bool_requires2.dzn,
	test/all/blocking_system4/ihello.dzn,
	test/all/blocking_system4/ihello_reply_bool.dzn,
	test/all/blocking_system4/ihello_world.dzn: New symlinks.
	test/all/hello_block_reply_bool_requires2/hello_block_reply_bool_requires.dzn:
	New symlinks.
	* test/all/blocking_system4/blocking_system4.dzn: Use them; Canonicalize.
	* test/all/blocking_system4/trace: Update accordingly.

	test: Add hello_block_reply_bool_requires2.
	* test/all/hello_block_reply_bool_requires2: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add hello_block_reply_bool_requires.
	* test/all/hello_block_reply_bool_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: blocking_system3: Canonicalize.
	* test/all/blocking_system3/hello_block_requires.dzn,
	test/all/blocking_system3/ihello.dzn,
	test/all/blocking_system3/ihello_world.dzn: New symlinks.
	* test/all/blocking_system3/blocking_system3.dzn: Use them; Canonicalize.
	* test/all/blocking_system3/trace: Update accordingly.

2024-05-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: system_hello_choice_reply: Rename from system_nondet_reply.
	* test/all/system_nondet_reply: Rename to...
	* test/all/system_hello_choice_reply: ...this.  Use
	hello_choice_reply.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: system_hello_choice_requires: Rename from system_nondet_out.
	* test/all/system_nondet_out: Rename to...
	* test/all/system_hello_choice_requires: ...this.  Use
	hello_choice_requires.
	* test/all/local.mk (REGRESSION_TESTS): Move to...
	(SEMANTIC_TESTS): ...here, and rename.

	test: Add hello_choice_requires.
	* test/all/hello_choice_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: hello_choice3: Rename from interface_nondet2.
	* test/all/interface_nondet2: Rename to...
	* test/all/hello_choice3: ..this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: updates.sh: Cater fon non-strict? #t in META.
	* test/bin/update.sh: Only use --strict if there's no non-strict? #t in
	META.

	test: hello_choice_reply: Use ihello_reply_bool.
	* test/all/ihello_reply_bool/ihello_reply_bool.dzn: New symlink.
	* test/all/hello_choice_reply/hello_choice_reply.dzn: Use it.
	(ihello): Remove.

2024-05-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Remove hello_nondet_reply.
	This is a copy of hello_choice_reply.

	* test/all/hello_nondet_reply: Remove test.
	* test/all/local.mk (FEATURE_TESTS): Remove it.

2024-05-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: constraint_choice2: Rename from constraint_nondet2.
	* test/all/constraint_nondet2: Rename to...
	* test/all/constraint_choice2: ..this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

2024-05-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: blocking_system2: Canonicalize.
	* test/all/hello_block_requires/hello_block_requires.dzn,
	test/all/hello/ihello.dzn,
	test/all/blocking_system/ihello_world.dzn: New symlinks.
	* test/all/blocking_system2/blocking_system2.dzn: Use them; Canonicalize.
	* test/all/blocking_system2/trace: Update accordingly.
	* test/all/blocking_system2/baseline/simulate.out: Update accordingly.

2024-05-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: shared_choice: Rename from shared_nondet.
	* test/all/shared_nondet: Rename to...
	* test/all/shared_choice: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: livelock_choice: Rename from livelock_nondet.
	* test/all/livelock_nondet: Rename to...
	* test/all/livelock_choice: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: ihello_optional_choice2: Rename from hello_optional_nondet.
	* test/all/hello_optional_nondet: Rename to...
	* test/all/ihello_optional_choice2: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: hello_multiple_choice: Rename from hello_multiple_nondet.
	* test/all/hello_multiple_nondet: Rename to...
	* test/all/hello_multiple_choice: ...this.

	test: Add hello_choice.
	* test/all/hello_choice/hello_choice.dzn: New file.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: ihello_optional_choice: Rename from hello_modeling_nondet.
	* test/all/hello_modeling_nondet: Rename to...
	* test/all/ihello_optional_choice: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Move it to...
	(SEMANTIC_TESTS): ...here.

	test: constraint_choice: Rename from constraint_nondet.

	test: constraint_modeling_choice: Rename from constraint_modeling_nondet.
	* test/all/constraint_modeling_nondet: Rename to...
	* test/all/constraint_modeling_choice: ..this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: blocking_choice: Rename from blocking_nondet.

	test: hello_choice2: Rename from hello_nondet.
	* test/all/hello_nondet: Rename to...
	* test/all/hello_choice2: ...this.

	test: ihello_choice: Rename from interface_nondet.
	* test/all/interface_nondet: Rename to...
	* test/all/ihello_choice: ...this.
	* test/all/local.mk (FEATURE_TESTS): Move it to...
	(SEMANTIC_TESTS): ...here.

2024-05-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: blocking_system: Canonicalize.
	* test/all/blocking_system/i_world.dzn,
	test/all/blocking_system/ihello.dzn
	test/all/blocking_system/ihello_world.dzn: New symlinks.
	* test/all/blocking_system/blocking_system.dzn: Use them; Canonicalize.
	* test/all/local.mk (REGRESSION_TESTS): Move to...
	(SEMANTIC_TESTS): ...here.

2024-05-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add i_world.
	* test/all/i_world: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-05-01  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_block_requires.
	* test/all/hello_block_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add hello_block.
	* test/all/hello_block: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: hello_cruel_block: Rename from hello_block.
	* test/all/hello_block: Rename to...
	* test/all/hello_cruel_block: ...this.

2024-04-30  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: livelock_hello: Rename from livelock_component.
	* test/all/livelock_component: Rename to...
	* test/all/livelock_hello: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Move it to...
	(SEMANTIC_ERROR_TESTS): ...here.

	test: livelock_ihello: Rename from livelock_interface0.
	* test/all/livelock_interface0: Rename to...
	* test/all/livelock_ihello: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Move it to..
	(SEMANTIC_ERROR_TESTS): ...here.

2024-04-29  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add determinism_hello_world_external.
	* test/all/determinism_hello_world_external: New test.
	* test/all/local.mk (SEMANTIC_ERROR_TESTS): Add it.

2024-04-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: hello_locations: Use --strict and --trail=TRAIL.
	* test/all/hello_locations/run: Use --strict and --trail=TRAIL.
	* test/all/hello_locations/trace: Add missing events.

	test: deadlock_hellohello: Rename from deadlock_component1.
	* test/all/deadlock_component1: Rename to...
	* test/all/deadlock_hellohello: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Move it to...
	(SEMANTIC_ERROR_TESTS): ...here.

	test: deadlock_ihellohello: Rename from deadlock_interface1.
	* test/all/deadlock_interface1: Rename to...
	* test/all/deadlock_ihellohello: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Move it to...
	(SEMANTIC_ERROR_TESTS): ...here.

	test: deadlock_hello: Rename from deadlock_component0.
	* test/all/deadlock_component0: Rename to...
	* test/all/deadlock_hello: ...this.
	* test/all/local.mk (FEATURE_TESTS): Move it to...
	(SEMANTIC_ERROR_TESTS): ...here.

	test: deadlock_ihello: Rename from deadlock_interface0.
	* test/all/deadlock_interface0: Rename to...
	* test/all/deadlock_ihello: ...this.
	* test/all/local.mk (HELLO_TESTS): Move it to...
	(SEMANTIC_ERROR_TESTS): ...here.

	test: system_helloworld_reply_true: Rename from hello_system_reply.
	* test/all/hello_system_reply: Rename to...
	* test/all/system_helloworld_reply_true: ...this.
	* test/all/local.mk (FEATURE_TESTS): Move it to...
	(SEMANTIC_TESTS): ...here.

	test: Add helloworld_reply_true_requires.
	* test/all/helloworld_reply_true_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add helloworld_reply_true.
	* test/all/helloworld_reply_true: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add ihelloworld_reply_true.
	* test/all/ihelloworld_reply_true: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add system_hello_cruelworld_requires.
	* test/all/system_hello_cruelworld_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-04-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add hello_cruelworld_requires.
	* test/all/hello_cruelworld_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add ihello_cruelworld.
	* test/all/ihello_cruelworld: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-05-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add system_hello_world_requires.
	* test/all/system_hello_world_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add system_helloworld_requires.
	* test/all/system_helloworld_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-05-08  Rutger van Beusekom  <rutger@dezyne.org>

	test: Remove system_hello_world.
	This is (now) a duplicate of system_helloworld_requires.

	* test/all/system_hello_world: Remove.
	* test/all/local.mk (REGRESSION_TESTS): Remove it.

2024-05-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add hello_world_external2.
	* test/all/hello_world_external2/hello_world_external2.dzn: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add illegal_external.
	* test/all/illegal_external: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-04-17  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add helloworld_external2.
	* test/all/helloworld_external2: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-04-12  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add system_hello_requires.
	* test/all/system_hello_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add hello_world_external.
	* test/all/hello_world_external: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-05-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add helloworld_external.
	* test/all/helloworld_external: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-05-08  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add compliance_hello_world.
	* test/all/compliance_hello_world: New test.
	* test/all/local.mk (SEMANTIC_ERROR_TESTS): Add it.

	test: Add ihello_cruel__world.
	* test/all/ihello_cruel__world: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add compliance_helloworld.
	* test/all/compliance_helloworld: New test.
	* test/all/local.mk (SEMANTIC_ERROR_TESTS): Add it to new variable.
	(FULL_TESTS): Add it.

	test: Add ihellocruel__world.
	* test/all/ihellocruel__world: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add compliance_reply_false.
	* test/all/compliance_reply_false: New test.
	* test/all/local.mk (SMOKE_TESTS): Add it.  Move
	compliance_provides_bool to...
	(REGRESSION_TESTS): ...here.

	test: Add ihello_reply_true.
	* test/all/ihello_reply_true: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-05-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add hello_reply_bool_requires.
	* test/all/hello_reply_bool_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add hello_reply_bool.
	* test/all/hello_reply_bool: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add ihello_reply_bool.
	* test/all/ihello_reply_bool: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-04-09  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_world_requires.
	* test/all/hello_world_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-04-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add hello_world.
	* test/all/hello_world: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add ihello_world.
	* test/all/ihello_world: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

2024-04-08  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add helloworld_requires.
	* test/all/helloworld_requires: New test.
	* test/all/local.mk (SEMANTIC_TESTS): Add it.

	test: Add hello_requires.

	test: Add ihello.
	* test/all/hello/ihello.dzn: New file.
	* test/all/hello/ihello.dzn: New symlink.
	* test/all/hello/hello.dzn: Import it.

	test: helloworld: Reuse ihelloworld.dzn.
	* test/all/helloworld/ihelloworld.dzn: New symlink.
	* test/all/helloworld/helloworld.dzn: Import it.
	(ihello): Remove.
	(helloworld): Update accordingly.
	* test/all/local.mk (HELLO_TESTS): Move it to ...
	(SEMANTIC_TESTS): ...here.

	test: ihelloworld: Rename from hello_interface.
	* test/all/hello_interface: Rename to...
	* test/all/ihelloworld: ...this.
	* test/all/parse-flags: Update accordingly.
	* test/all/local.mk (HELLO_TESTS): Move from here...
	(SEMANTIC_TESTS): ...to this new variable.
	(FULL_TESTS): Add it.
	(SEMANTICS_TESTS): Rename to...
	(DOC_SEMANTICS_TESTS): ...this.
	(HELLO_TESTS): Rename to...
	(FEATURE_TESTS): ...this.
	(HELLO_TESTS): New variable.

2024-03-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: bin/update.sh: Respect model for simulate.
	* test/bin/update.sh: Also use --model=model for simulate if set in
	META.

2024-03-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Remove --model from verify by default.
	* test/dzn/dzn.scm (component?): Do not use use model? fall-back when
	component is explicitly unset.
	(run-verify): Only add --model when component or model is set (and
	component is not explicitly unset).
	* test/bin/update.sh: Update accordingly.
	* test/all/parse_import_self/META: New file.
	* test/all/parse_import_both/baseline/verify.err: Remove baseline.
	test/all/parse_import_twice/baseline/verify.err: Update baseline.

2024-03-26  Paul Hoogendijk  <paul@dezyne.org>

	test: inevitable_performance: Timeout on cpu time.
	Having 'inevitable_performance' timeout on wall clock time fails under
	heavy load.

	* test/all/inevitable_performance/run: Use cpu-timeout.

2024-03-26  Paul Hoogendijk  <paul@dezyne.org>

	test: add cpu-timeout.
	Using CPU time avoids timeout problems under heavy load.

	* test/bin/cpu-timeout: New file.
	* Makefile.am (EXTRA_DIST): Register it.

2024-03-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Use long options.
	* test/dzn/dzn.scm: Use long options throughout.

2025-01-13  Paul Hoogendijk  <paul@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>
	    Rutger van Beusekom  <rutger@dezyne.org>

	test: Make test pipeline more robust.
	* test/dzn/dzn.scm (observe): Ignore exceptions on closing stdin-output
	port.

2025-02-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	wfc: Fix defer/blocking typo.
	This is a follow-up to commit
	    fd6d85c257a1f7f517fdb8eab159a2c484b50188
	    wfc: Check for language features block, defer, shared.

2025-02-18  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add function_shadow_event.
	* test/all/function_shadow_event: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	doc: Update savannah git URLs.
	* doc/dezyne.texi (Getting Started): Fix/update URL.
	(A Camera Example): Likewise.
	(The Lego Ball Sorter): Liwewise.

2025-02-13  Rutger van Beusekom  <rutger@dezyne.org>

	test: parse_import_both: Add comment after import.
	* test/all/parse_import_both/parse_import_both.dzn: Add comments.

2025-02-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: parse_import_both: Avoid 'No such model'.
	* test/all/parse_import_both/META: New file.
	* test/all/parse_import_both/baseline/verify.err: Update baseline.

2025-01-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	makreel: Fix indentation.
	* dzn/code/scmackerel/makreel.scm (ast->process): Fix indentation.

2025-01-06  Rutger van Beusekom  <rutger@dezyne.org>

	cs: Add '\n' to dollar statements.
	* dzn/code/scmackerel/cs.scm (root->statements): Here.

	test: LegoBallSorter: Verification fixes.
	* test/all/LegoBallSorter/ITransfer.dzn (ITransfer): Move assignments
	after communication to fix non-determinism.
	* test/all/LegoBallSorter/Brick3.dzn: Add missing include.
	* test/all/LegoBallSorter/Conveyor.dzn (Conveyor): Remove
	sensor.released trigger to fix unreachable code error.

2024-12-16  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add dollar_import.
	* test/all/dollar_import: Noew test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	peg: Ignore anything between dollars.
	* dzn/parse/peg.scm (peg:imports): Comment, add dollars parsing and
	refactor.

2024-12-09  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add defer_data_no_state.
	* test/all/defer_data_no_state/defer_data_no_state.dzn,
	* test/all/local.mk: Add it.

	code: Fix defer_data_no_state.
	* dzn/code.scm (code:defer-condition): Filter out data members.

2024-11-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add complex_arguments6.
	* test/all/complex_arguments6: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

	normalize: Handle calls with more than two arguments.
	* dzn/ast/normalize.scm: (add-temporary?): Select the first expression
	argument to be replaced.

2024-11-05  Rutger van Beusekom  <rutger@dezyne.org>

	test: unreachable_multiple_triggers: Add in-event.
	* test/all/unreachable_multiple_triggers/unreachable_multiple_triggers.dzn (ihello):
	Add bye to report unreachable, add never to remove unreachable
	distraction from interface.
	* test/all/unreachable_multiple_triggers/baseline/verify.err: Update accordingly.

	makreel: Support list of on triggers in unreachable check.
	* dzn/code/language/makreel.scm: Add tags after splitting triggers.
	* dzn/ast/normalize.scm (tag-imperative-blocks): Make
	<declarative-compound> aware.

2024-10-30  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_function_shared.
	* test/all/hello_function_shared: New test.
	* test/all/local.mk (HELLO_TESTS): Add it.

	makreel: Fix shared state deadlock using interface function.
	* dzn/code/language/makreel.scm (makreel:add-state-placeholder): Add
	<state> placeholder normalization for out events in functions.

2022-03-07  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add collateral_cancel_guarantee.
	* test/all/collateral_cancel_guarantee: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2022-02-15  Paul Hoogendijk  <paul@dezyne.org>

	test: Add collateral_blocking_out.
	* test/all/collateral_blocking_out: New test.
	* test/all/local.mk (REGRESSION_TESTS): Register it.

2024-10-14  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Check for collateral blocking to update port with <flush>.
	*
	dzn/code/scmackerel/c++.scm (component-model->sm:statements-unmemoized):
	Symmetrically initialize port meta pointers by default to the port being
	instantiated; this removes the nullptr convention in the generated main.
	* runtime/c++/dzn/pump.hh (struct pump): Rename blocked_p to
	port_blocked_p; add blocked_p to check pending collateral blocking.
	* runtime/c++/dzn/runtime.hh (=): Extend port_update condition to
	incorporate broken_cancel_guarantee.
	* runtime/c++/pump.cc (blocked_p): Forward new function ...
	(pump::blocked_p): ... implement in pump.

	test: blocking_system_diamond: Remove redundant blocking.
	* test/all/blocking_system_diamond/blocking_system_diamond.dzn (block):
	Replace with...
	(proxy): ...this new component.
	(resource, blocking_system_diamond): Update accordingly.

2024-10-11  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Exchange port_update in both directions.
	* dzn/code/scmackerel/c++.scm (interface->sm:statements-unmemoized):
	Initialize provides other_port_update with requires port_update and vice
	versa.

2025-08-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: parse_void_variable: Register.
	This is a follow-up to commit
	    b007c8a35dfdbbb59b3f138363ff976d3676183f
	    test: Add parse_void_variable.

	* test/all/local.mk (PARSER_TESTS): Register parse_void_variable.

2025-08-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: parse_void_parameter: Register.
	This is a follow-up to commit
	    beef59ba7eeaa8d4af24986988a8d0138bfaedd8
	    test: Add parse_void_parameter.

	* test/all/local.mk (PARSER_TESTS): Register parse_void_parameter.

2024-09-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Whitespace fixes.
	* doc/dezyne.texi (Integrating C++ Code): Align braces, Use space before
	paretheses.
	(Thread-safe Shell): Likewise.

2024-09-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: Bump to f977cb2b609f7122db2cf026cac5ab9d6d44a206.
	* guix.scm: Update to f977cb2b609f7122db2cf026cac5ab9d6d44a206.
	* guix/pack/dezyne.scm (dezyne)[arguments]: Use
	%default-gnu-imported-modules instead of %gnu-build-system-modules.

2024-09-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: Remove patch clutter.
	This is a follow-up to commit
	    41bb92634e1404172dbeac34f3800af04963cc9d
	    guix: Cater for rc tarballs.

	* guix/pack/dezyne.scm.orig: Remove.

2024-09-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Resurrect build.
	This avoids test failures:
	     +guile: warning: failed to install locale

	* gnu/packages/dezyne.scm (dezyne)[inputs]: Add libc-utf8-locales-for-target.

	Change-Id: I2da63e128e8f990a409b36ffaa38e56029740292

2025-07-16  Ludovic Courtès  <ludo@gnu.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>.

	doc: Describe policies.
	Sane policies formalized, and kindly taken from GNU Guix.

	* doc/dezyne.texi: (Making Decisions, Commit Access, Managing Patches
	and Branches, Reviewing the Work of Others): New sections.

2025-07-16  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Add MAINTAINERS.
	* MAINTAINERS: New file.

2024-09-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Update to 2.18.3.
	* guix/pack/dezyne.scm (dezyne): Update to 2.18.3.

2024-05-31  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `NEWS'.
	* NEWS (Changes in 2.18.3 since 2.18.2): New section.

2024-09-03  Rutger van Beusekom  <rutger@dezyne.org>

	test: collateral_blocking_bridges: Simplify.
	* test/all/collateral_blocking_bridges/collateral_blocking_bridges.dzn
	(blocking_top,blocking_middle,blocking_bottom): Remove redundant
	blocking port annotation.
	(top_proxy): Remove redundant component.
	(blocker): Remove redundant blocking and defer.
	* test/all/collateral_blocking_bridges/main.cc: (main): Replace initial
	sleep with a barrier like promise/future.  Remove <defer>s and sleeps.
	* test/all/collateral_blocking_bridges/main.cs (Main): Likewise.
	* test/all/collateral_blocking_bridges/trace,
	test/all/collateral_blocking_bridges/trace.1,
	test/all/collateral_blocking_bridges/trace.2: Remove <defer>s.

2024-09-03  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Wait longer in C# hanwritten mains.
	This gives better chances (yuck) of passing under load.

	* test/all/collateral_blocking_reorder_parallel/main.cs (Main): Double
	wait times.
	* test/all/collateral_blocking_bridges/main.cs (class main): Likewise.
	* test/all/collateral_blocking_bridges/META (timeout): New field,
	doubling the timeout.
	* test/all/collateral_blocking_reorder_parallel/META (timeout): Likewise.

2024-08-29  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Fix assert for certain compilers.
	Reported by Perry van Wesel <perry.van.wesel@thermofisher.com>.

	* runtime/c++/thread-pool.cc (pool): Replace == nullptr with false &&;

2024-08-21  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add shared_defer2.
	* test/all/shared_defer2: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-08-20  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Fix shared variable scoping for defer.
	* dzn/code/scmackerel/makreel.scm (ast->process): Decouple communication
	of shared state, defer and flush.

2024-08-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: blocking_defer: Disable C, C++, C#, and Scheme.
	blocking_defer fails verification and is set to XFAIL_VERIFY and used
	pass in C, C++, and Scheme.  Traces have changed and now C, C++ and
	Scheme also fail.

	* test/all/blocking_defer/META: New file.

2024-08-20  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Replace foreign by not native.
	* dzn/code/scmackerel/c++.scm (component-model->sm:statements-unmemoized):
	Make generated components be native leading to everything else becoming not
	native.
	* runtime/c++/dzn/runtime.hh (struct state, struct runtime, =),
	* runtime/c++/runtime.cc (runtime::native): Rename foreign to native.

2024-08-16  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Support typed (out) parameters for valued events.

2024-08-14  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add foreign_trivial_proxied.
	* test/all/foreign_trivial_proxied: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	runtime: c++: Fix foreign_trivial_{integration,proxied}.
	* runtime/c++/dzn/runtime.hh (struct event::operator =): Move flush
	condition...
	* runtime/c++/runtime.cc (runtime::flush): ...here.

2024-08-16  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: foreign_optional: Disable C++.
	This tests now falls outside of the new shared state semantics.

	* test/all/foreign_optional/META: Add "c++" to skip.

2024-08-15  Rutger van Beusekom  <rutger@dezyne.org>

	test: [system_]foreign_only_flush: Prepare for proxied fix.
	* test/all/foreign_only_flush/foreign.hh (foreign::port_hello): Cater
	for proxied fix.
	* test/all/foreign_only_flush/main.cc (event_map): Set require.component
	to nullptr.
	* test/all/foreign_only_flush/trace: Update accordingly.
	* test/all/system_foreign_only_flush/trace: Remove.
	* test/all/foreign_only_flush/trace: New symlink.

2024-08-13  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add foreign_trivial_integration.
	* test/all/foreign_trivial_integration: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	runtime: c++: Fix trivial foreign integration.
	* runtime/c++/dzn/runtime.hh (struct event::operator =): Make trigger
	flush conditional on the originating activity or defer.

	test: Add compliance_fork_lookup.
	* test/all/compliance_fork_lookup: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	ast: Make ast:modeling? robust against name lookup failure.
	* dzn/ast.scm (ast:modeling?): Handle .event returning #f.

2024-08-12  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add defer_foreign.
	* test/all/defer_foreign: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	runtime: c++: Fix foreign defer.
	* runtime/c++/dzn/runtime.hh (struct event::=): Strengthen foreign flush
	condition with not handling.

2023-11-15  Rutger van Beusekom  <rutger@dezyne.org>

	test: hello_constraint: Extend with an out event.
	* test/all/hello_constraint/hello_constraint.dzn (ihello,
	hello_constraint): Add world.

2024-08-07  Rutger van Beusekom  <rutger@dezyne.org>

	simulate: Avoid extra state printing for <defer> with --state.
	* dzn/vm/report.scm (display-trace): Ignore defer as arrow for reporting
	state.

2024-08-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add determinism_deadlock.
	* test/all/determinism_deadlock: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	test: deadlock_interface_determinism: Rename from determinism_deadlock.
	* test/all/determinism_deadlock: Rename to...
	* test/all/deadlock_interface_determinism: ..this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

2024-08-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update SCMackerel requirement.
	* README (Requirements): Bump scmackerel to 0.5.3.
	* doc/dezyne.texi (Requirements): Likewise.

	guix: dezyne: Move propagated packages to inputs.
	* guix/pack/dezyne.scm (dezyne)[propagated]: Move into...
	[inputs]: ...this.

	guix: scmackerel: Use version from upstream.
	* guix/pack/scmackerel.scm (scmackerel): Remove; export (gnu packages
	scmackerel) instead.

	guix: Bump to 918b7d102c2051c3d6c6ba54c8d265affec5282c.
	* guix.scm: Bump to 918b7d102c2051c3d6c6ba54c8d265affec5282c.

2024-07-31  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: huge_constraint: Set timeout=600.
	* test/all/huge_constraint/META: New file.

	test: Support overriding --timeout in META.
	* test/bin/run.in (meta-timeout): New procedure.
	(main): Use it to override timeout from META.

	test: Refactor get-meta.
	* test/dzn/dzn.scm (get-meta-option): New procedure.
	(get-meta-flag, queue-size queue-size-defer, queue-size-external,
	code-options, component?, model?, trace-format,
	non-strict?, simulate-flags): Use it.
	(get-meta-entry): New procedure.
	(component-unset?): Use it.

2024-07-03  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add ihello_optional_choice4.
	Suggested by logocp via IRC Joran Jessurun <joran@ajmail.nl>.

	* test/all/ihello_optional_choice4: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-07-03  Janneke Nieuwenhuizen  <janneke@gnu.org>

	simulate: Avoid interface non-determinism when trails differ.
	* dzn/vm/run.scm (run-to-completion-unmemoized): Filter traces by trail
	while cdr'ing through all traces.

2024-06-28  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add shared_requires_guard.
	* test/all/shared_requires_guard: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-06-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add determinism_shared2.
	* test/all/determinism_shared2: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-06-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	simulate: Find interface non-determinism short of choice point.
	This also fixes the case where the first two clauses/traces are
	deterministic.

	* dzn/vm/run.scm (run-to-completion-unmemoized)
	[interface-non-deterministic?]: Check all traces and split-off
	posponed-match variant to...  [interface-postponed-non-deterministic?]:
	...this new inner define.  Use them to also check non-determinism in
	the absence of postponed-match?
	* dzn/vm/run.scm (run-interface): Do not prune <determinism-error>s.
	* dzn/simulate.scm (end-report): Run deadlock check when
	<determinism-error>, to let <deadlock> error prevail.
	(check-deadlock): Overwrite AST for
	<determinism-error>.
	* test/all/determinism_interface/baseline/simulate.err,
	test/all/determinism_interface/baseline/simulate.out,
	test/all/determinism_shared/baseline/simulate.err,
	test/all/determinism_shared/baseline/simulate.out: Update baselines.

2024-05-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: determinism_shared: Rename from shared_determinism.
	* test/all/shared_determinism: Rename to...
	* test/all/determinism_shared: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

2024-06-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add ihello_optional_choice3.
	Suggested by logocp via IRC Joran Jessurun <joran@ajmail.nl>.

	* test/all/ihello_optional_choice3: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-06-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	simulate: Avoid interface non-determinism when trails differ.
	* dzn/vm/run.scm (run-to-completion-unmemoized): Fix typo/thinko:
	Restrict to matching set of trails.  This will miss non-determinism with
	more than two traces, though.

2024-07-05  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add shared_guarded_trailing_assign.
	* test/all/shared_guarded_trailing_assign: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-06-20  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add shared_defer_trailing_assign.
	* test/all/shared_defer_trailing_assign: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	test: Add shared_trailing_assign.
	* test/all/shared_trailing_assign: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-06-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Cater for multiple provides out events with state updates.
	* dzn/vm/compliance.scm (update-shared-state): Use RTC-PC for
	port-trace; when defer use TRACE's initial PC.

	vm: Fix rtc-pc.
	* dzn/vm/util.scm (rtc-pc): Fix typo in apparently unused procedure.

2024-08-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	c++: runtime: Use scoped_handling.
	* runtime/c++/dzn/runtime.hh (scoped_handling): New struct.
	(struct event::=): Use it.

2024-08-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add system_foreign_only.
	* test/all/system_foreign_only: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-08-02  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add foreign_only.
	* test/all/foreign_only: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	test: [system_]foreign_only_flush: Rename from [system_]foreign_only.
	* test/all/foreign_only: Rename to...
	* test/all/foreign_only_flush: ..this.
	* test/all/system_foreign_only: Rename to ...
	* test/all/system_foreign_only_flush: ..this.
	* test/all/system_foreign_only_flush/META,
	* test/all/system_foreign_only_flush/foreign.hh,
	test/all/system_foreign_only_flush/trace: Update symlink.
	* test/all/system_foreign_only_flush/foreign_only.dzn: Remove.  Replace by
	* test/all/system_foreign_only_flush/foreign_only_flush.dzn: ...this new
	symlink.

2024-07-25  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	Support shared state trailing assign on flush.
	* dzn/verify/pipeline.scm (in-out:aut->aut-weak-trace,
	in-out:lts-hide-internal-labels): Remove redundant flush hiding.
	* dzn/verify/constraint.scm (lts->makreel): Ignore flush as compliant
	event in constraint LTS.
	* dzn/code/scmackerel/makreel.scm (ast->process <bevahior>): Pass
	interface state to behavior process after defer_qout.
	(interface-reorder-processes): Remove flush hiding.
	(semantics-async): Communicate trailing assignment after flush.
	(provides-constraint-processes, constraint-processes): Comm, allow,
	rename flush between component process and provides contraint process.
	* dzn/code/language/makreel.scm (makreel:add-state-placeholder): Remove
	modelling trigger exception.
	* dzn/code.scm (flush-regexp, code:shared): Recognize flush labels when
	communicating shared state.

	* dzn/ast/equal.scm (ast:port-eq?): New method.
	* dzn/code/goops.scm (ast:equal?): New method.
	* dzn/code.scm (trigger->port-pairs): New method, factor-out from...
	(code:return-values): ...here.
	(code:blocking-return-values),
	code:requires-in-void-returns): New methods.
	* dzn/code/scmackerel/c++.scm (interface->sm:statements-unmemoized):
	Exchange port update functors.
	(component-model->sm:statements-unmemoized): Remove setting
	performs_flush in component constructor (also see runtime.hh performs_flush
	declaration).

	* runtime/c++/dzn/runtime.hh (struct runtime)[defer, port_update,
	coroutine_id2activity]: New members.
	(runtime::activity, runtime::deferred_flush): New method.
	(runtime::flush): Add sync_p parameter.
	(runtime::queue_p, runtime::enqueue): Move to operator =.
	(struct scoped_activity): New struct.
	(defer, operator =): Use it; coordinate execution, queueing,
	flushing and updating ports using <flush> label (formerly queue_p and
	enqueue).
	* runtime/c++/dzn/container.hh (container): Update accordingly.
	* runtime/c++/runtime.cc (runtime::performs_flush): Remove.
	(runtime::queue_p): Update accordingly.
	* runtime/c++/pump.cc (pump::block): Add sync_p value to flush.

	* test/all/foreign_only/foreign.hh (foreign::foreign): Set runtime.flush.
	* test/all/foreign_only/main.cc (event_map): Add flush parameter.  Use
	it to set runtime.flush for container and nullptr.
	(main): Update accordingly.
	* test/all/compliance_fork_blocking_bypass/META,
	test/all/compliance_fork_provides/META,
	test/all/compliance_fork_requires/META: Skip lts (postpone simulator to
	2.19).
	* test/all/constraint_modeling_nondet/META,
	test/all/external_multiple_out2/META,
	test/all/external_multiple_out2/trace,
	test/all/external_multiple_out3/META,
	test/all/external_multiple_out3/trace:
	test/all/foreign_only/META,
	test/all/foreign_only/foreign.hh,
	test/all/foreign_only/main.cc: Add flush external.

2024-08-02  Janneke Nieuwenhuizen  <janneke@gnu.org>

	dzn: templates: Cleanup unused macros.
	* dzn/templates/code.scm (main-event-map-out,
	main-event-map-void-provides-in, main-event-map-typed-provides-in,
	main-event-map-void-requires-in, main-event-map-typed-in,
	main-event-map-match-return): Remove.

2024-08-01  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Refactor and format.
	* runtime/c++/dzn/runtime.hh (component_to_string): Format to 80
	columns.
	(hash): Rename parameters meaningfully; Add debug trace.
	(event::operator =): Format.

2024-07-25  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Redesign container without blocking.
	Remove the use of port_block from the generated main actions, except for
	"blocking" ports.  Instead interleave action call [, callback] and
	return by reading from STDIN and executing each label.

	* runtime/c++/dzn/container.hh (container): Remove thread primitives;
	formatting,
	(perform): Move reading from STDIN ...
	(operator ()): ... to here and make asynchronous by pushing it onto the
	pump,
	(trail_expect): Remove redundant method,
	(match): Handle additional error case.
	* dzn/code/scmackerel/c++.scm (main-event-map): Remove port_block and
	port_release ...
	(main-connect-ports): ... replace with synchronous perform invocations
	to meet match expectation.
	* test/all/foreign_only/main.cc (connect_ports): Add perform to
	"handwritten" main.

2024-06-21  Rutger van Beusekom  <rutger@dezyne.org>

	test: multiple_provides: Refactor.
	* test/all/multiple_provides/multiple_provides.dzn
	(multiple_provides): Remove redundant direction, use guards instead of
	`if'.

2024-06-20  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Document the thread pool destructor pre-condition.
	* runtime/c++/thread-pool.cc (pool): Add an assert with explanation.

2024-06-24  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add cxx_enum_to_string.
	* test/all/cxx_enum_to_string: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	c++: Generate to_string and to_enum for component private enums.
	* dzn/code/scmackerel/c++.scm (model->header-statements,
	model->statements): Add c++:enum->statements for enums from the
	component behavior.

2024-06-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	makreel: Sort lists of events.
	This is a follow-up to commit
	    ec6c94b92192863319cedbc2ebf747f499a37c54
	    verify: Replace constraint_any with non_compliance action.

	* dzn/code/scmackerel/makreel.scm (component-assembly-processes): Sort
	events lists.

2024-06-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add defer_poll.
	* test/all/defer_poll: New test.

	ast: Disregard function <call>s in <defer> for recursion.
	* dzn/ast.scm (ast:function* <function>): Only include calls that are
	not deferred.

2024-06-03  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add parse_void_variable.
	* test/all/parse_void_variable: New test.

	test: Add parse_void_parameter.
	* test/all/parse_void_parameter: New test.

2024-06-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	wfc: Add check for parameter and variable to be of non-<void> type.
	* dzn/ast/wfc.scm (wfc <variable>): Remove dead, outdated copy.
	(check-non-void): New procedure.
	(wfc <formal>, wfc <variable>): Use it.

	ast: Handle default-vailue for <void> type.
	* dzn/ast.scm (ast:values <variable>): Change to...
	* dzn/ast.scm (ast:values <variable> <top>): ...this.
	(ast:values <variable>): New specialization.
	(ast:default-value): Use it to support <void>.
	* dzn/code/scmackerel/makreel.scm (makreel:type->string): Handle <void>.

2024-05-31  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add end_of_trail_int.
	* test/all/end_of_trail_int: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-05-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	simulate: Cater for integer choice labels.

2024-05-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add parse_return_void_expression.
	Suggested by Michaël van de Ven <michael.van.de.ven@thermofisher.com>
	via IRC.

	* test/all/parse_return_void_expression: New test.
	* test/all/local.mk (PARSER_TESTS): Add it.

2024-05-30  Janneke Nieuwenhuizen  <janneke@gnu.org>

	wfc: Add check for return void-expressions to be literal.
	* dzn/ast/wfc.scm (wfc <return>): Check that a void return expression is
	a literal.

2024-05-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Use only positive matching in .gitignore.
	* .gitignore: Remove /build-aux/* rule; add specific file-names to
	ignore.  Use ** matching for some test log output.

2024-05-07  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add parse_reply_void_expression.
	* test/all/parse_reply_void_expression: New test.
	* test/all/local.mk (PARSER_TESTS): Add it.

	wfc: Add check for reply void-expressions to be literal.
	* dzn/ast/wfc.scm (wfc <reply>): Check that a void reply expression is
	a literal.

2024-05-21  Rutger van Beusekom  <rutger@dezyne.org>

	misc: Add (bi-)conditional statement = (bi-)implication.
	* dzn/misc.scm (->): Add implication.
	(<->): Add bi-implication.

2024-08-02  Janneke Nieuwenhuizen  <janneke@gnu.org>

	cs: Resurrect defer.
	This is a follow-up to commit
	    2dfe3025b0ecd0abe18a2cc007d19b717ad83390
	    c++: Avoid shadowing in nested defer c++11 capture workaround.

	* dzn/code.scm (code:capture-name): Restore interface.
	* dzn/code/language/c++.scm (c++:capture-name): New method; use it for
	enhanced name.
	* dzn/code/scmackerel/c++.scm (ast->code <defer>): Update accordingly.

2024-07-23  Paul Hoogendijk  <paul@dezyne.org>

	test: system_bool_enum: Avoid shared state.
	* test/all/system_bool_enum/system_bool_enum.dzn: Use local enum.
	* test/all/semantics/baseline/semantics.org: Update baseline.

2024-05-31  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: hello_void: Comment-out unspported non-literal void reply expressions.
	This is a follow-up to commit
	    8af19ccd478dc32de95444172b3046c59f695c5c
	    test: Add hello_void.

	* test/all/hello_void/hello_void.dzn (ihello)[hello4, hello5]:
	Comment-out.
	* test/all/hello_void/hello_void.dzn (hello_void)[h.hello4, h.hello5]:
	Likewise.

2024-05-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	ast: Fix tree-find.
	This is a follow-up to commit
	    5ae1aa4295c9844a95b98b38e370c0149f565a10
	    Change shared-state semantics to update after provides out event.

	* dzn/ast/util.scm (tree-find): Search all children, instead of only
	<string>, <number>, and <boolean>.

2024-09-03  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: shell_injected: Skip c.
	This is a follow-up to commit
	    49cd4ada05f8eb43b51992a4f84d9ada004c67ab
	    test: shell_injected: Fix verification.

	which was an incomplete rewrite, breaking support for other languages.

	* test/all/shell_injected/META (skip): Add "c" to "skip".

2024-07-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: ihello_mock: Skip non-c++ languages.
	This is a follow-up to commit
	    280f58dd4e6c3d7adab43fbc49f21e63d3656b4a
	    test: Add ihello_mock.

	* test/all/ihello_mock/META: Skip c, cs, javascript, scheme.

2024-07-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: code-json: Require bash.
	This is a follow-up to commit
	    1662803a0434e98ff751af52e85f0c344e1f8569
	    test: Add code-json.

	* test/all/code-json/run: Change shebang to use bash.

2024-05-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Complete .mailmap.
	* .mailmap: Add duplicate adresses for Rutger, Paul, Johri, Henk, and Maarten.

2024-04-30  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Update to 2.18.2.
	* guix/pack/dezyne.scm (dezyne): Update to 2.18.2.

2024-03-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `NEWS'.
	* NEWS (Changes in 2.18.2 since 2.18.1): New section.

2024-03-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `HACKING'.
	* HACKING (Regression test): Add meme to check all external tests.

2024-03-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `ROADMAP'.
	(Release 2.19): Mention wip-sequential, wip-serialize, wip-return, and
	sm:tag problem.

2024-04-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Revert "Generate 'version.texi' reproducibly."
	Using `build-aux/mdate-from-git.scm' makes this no longer necessary.

	This reverts commit 7d875813fffe1da9226c2cdb0dfc96a1ce81a5ac.

2024-04-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Update reproducible tarball with insights from Guix.
	* Makefile.am (auto-clean): Also remove INSTALL and '.am*'.
	(GZIP_ENV): Add --best and use `override.'
	(am__tar): Use `override'.
	(DIST_CONFIGURE_FLAGS): New variable.
	auto-clean: Use it on ./configure.
	Add a toplevel check to ensure that Autotools cache is up to date.

2024-04-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Support running `make dist' from tarball.
	* configure.ac (AM_INIT_AUTOMAKE): Avoid some portability warnings.
	(in_git_p): New conditional.
	* Makefile.am (dist): Only depend on auto-clean when true.
	(dist-hook): Use it to only depend on gen-ChangeLog,
	gen-tarball-manifest when true.
	(gen-tarball-version, gen-tarball-manifest): Split-off
	from...
	(gen-ChangeLog): ...this.

2024-04-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Generate doc/version.texi using `mdate-from-git.scm'.
	This replaces Automake's `build-aux/mdate-sh' with our own
	`build-aux/mdate-from-git.scm' to use reproducible timestamps from Git
	instead.

	* build-aux/mdate-from-git.scm: New script.
	* autogen.sh: Use it to replace build-aux/mdate-sh.

2024-04-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Remove gnulib-generated `INSTALL' from Git.
	Note: This requires running

	    ./autogen.sh

	* INSTALL: Remove.
	* .gitignore: Add it.
	* Makefile.am (auto-clean): Remove it.

2024-04-25  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Remove needless override warnings.
	* Makefile.am ($(srcdir)/doc/version.texi, $(srcdir)/doc/stamp-vti):
	Remove override target, `override' only works with variables.

2024-04-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add code-json.
	* test/all/code-json: New test.
	* test/all/local.mk (PARSER_TESTS): Add it.

2024-04-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	wfc: Allow json for all language features.
	* dzn/ast/wfc.scm (feature-supported?): Never generate an error for
	JSON.

2024-04-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Fix memoization bug in run-to-completion.

2024-04-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	explore: Enable blocked compliance check for systems too.
	* dzn/explore.scm (pc->rtc-lts): Remove system-exception for blocked
	compliance check.

2024-03-14  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add collateral_blocking_shared_reply.
	* test/all/collateral_blocking_shared_reply/collateral_blocking_shared_reply.dzn:
	New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-03-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: compliance_determinism_optional: Rename from determinism_optional.
	* test/all/determinism_optional: Rename to...
	* test/all/compliance_determinism_optional: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

2024-03-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Revert "graph: Implicit interface constraints."
	With the dropping of constraint_any there's no use for this anymore.

	This reverts commit 5508158e963d5cb4a6c1d717f096462d74dba404.

2024-03-15  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>.

	verify: Replace constraint_any with non_compliance action.
	The introduction of constraint_any to support behavior out side of its
	provides interface(s) compliance has lead to adverse verification
	performance for certain models.

	* dzn/explore.scm (lts): Remove disabling of %compliance-check?.

	* dzn/code/scmackerel/makreel.scm (%compliant-action): Add compliance
	event with port parameter.
	(component-processes): New processes:
	component-compliant, component-compliant-parallel,
	component-compliant-comm, component-compliant-allow,
	component-compliant-rename to constrain undesirable interleaving
	with the compliance and non_compliance actions.
	(interface-constraint-processes):
	Remove constraint_any process ...
	* dzn/verify/constraint.scm (lts->makreel): ... and replace with
	Non_Compliance to preserve the ltsconvert compliance check,
	(print-tree): Add parameter trigger-p?
	(lts->makreel): Use parameter to conditionally add compliance
	synchronization.

	* test/all/compliance_blocking_out/baseline/verify.err,
	test/all/compliance_reply_illegal/baseline/verify.err,
	test/all/compliance_reply_illegal/baseline/verify.out,
	test/all/deadlock_blocking_compliance/baseline/verify.err,
	test/all/deadlock_blocking_compliance/baseline/verify.out,
	test/all/determinism_optional/baseline/verify.err,
	test/all/determinism_optional/baseline/verify.out: Update baselines
	correspondingly.
	* test/all/local.mk (XFAIL_LTS): New variable.
	(XFAIL_TESTS): Add it.

2024-04-11  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Rename component-* processes by adding "assembly".
	* dzn/code/scmackerel/makreel.scm (component-processes): Rename to
	component-assembly-processes.

2024-03-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	Remove -D,--no-non-compliance option.
	This option becomes obsolete with the constraint_any rewrite.

	* dzn/commands/code.scm (parse-opts): Remove -D,--no-non-compliance.
	* dzn/commands/traces.scm (parse-opts): Likewise.
	* dzn/commands/verify.scm (parse-opts): Likewise.
	* dzn/verify/constraint.scm (lts->makreel): Remove it.
	* doc/dezyne.texi (Invoking dzn code): Remove it.
	(Invoking dzn traces): Likewise.
	(Invoking dzn verify): Likewise.

2024-03-27  Rutger van Beusekom  <rutger@dezyne.org>

	vm: Omit fork compliance for explore.
	* dzn/vm/compliance.scm (check-provides-compliance)
	[check-provides-fork-and-zip]: Add not %explorinng? guards.

2024-04-02  Janneke Nieuwenhuizen  <janneke@gnu.org>

	explore: Add memoizing to follow-blocked.
	* dzn/explore.scm (pc->rtc-lts)[follow-blocked-unmemoized]: Factored-out
	from...
	[blocked-prefix]: ...here.
	[follow-blocked]: New memoizing variant.

2024-03-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	explore: Use compliance result trace for blocking.
	* dzn/explore.scm (pc->rtc-lts)[blocked-prefix]: Rewrite to follow trace
	from the LTS.
	[check-compliance-blocked]: Instead of adding a new PC on top of a
	compliance trace, drop blocking prefix from the compliance trace.
	[run-label]: Also use blocked compliance check when original pc is
	blocked.

2024-03-31  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Do not update port state after trigger-only trace.
	* test/all/illegal_blocking_race/baseline/simulate.out,
	test/all/match_blocking_race/baseline/simulate.out: Update baseline.

2024-04-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	explore: Cleanups.
	* dzn/explore.scm (pc->rtc-lts)[run-label]: Use explicit names.

2024-03-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Show full port trails with their state with --debug.
	* dzn/vm/compliance.scm (check-provides-compliance): Update port trail
	debugging.

	vm: Add marker for ext-q in pc->string.
	* dzn/vm/util.scm (pc->string): Add "ext-q" prefix.

2024-04-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	explore: Use "<defer>" rather than 'defer in trail.
	* dzn/explore.scm (run-to-completion**): Run "<defer>" intead of 'defer
	event.

	vm: Fix typos.
	* dzn/vm/run.scm (block-on-port): Fix typos.

	vm: Remove code duplication in rtc?
	* dzn/vm/goops.scm (rtc? <list>): Use rtc? on <program-counter> instead
	of duplicating the implementation.

	makreel: Remove redundant optargs.
	* dzn/code/language/makreel.scm (makreel:add-action-reply): Remove `*'.
	[add-action-reply]: Likewise on inner define.

	code: Remove duplication from <action-reply>.
	* dzn/code/goops.scm (<action-reply>)[port.name,event.name]: Remove
	fields.
	(.port <action-reply>, .event <action-reply>): Update accordingly.
	(.port.name <action-reply>, (.event.name <action-reply>): New
	specializations.

2024-03-31  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Display command-line usable commands for ltscompare.
	* test/dzn/dzn.scm (run-lts): Upon failure, give a somewhat helpful
	instruction.

2024-03-30  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Remove compliance_system_hello_world.
	The trace was wrong, but this is a compliant model.

	* test/all/compliance_system_hello_world: Remove test.
	* test/all/local.mk (REGRESSION_TESTS): Remove it.

2024-03-30  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Truncate blocked port-traces for state update.

2024-03-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	explore: Avoid running defer, external unnecessarily.
	* dzn/explore.scm (pc->rtc-lts): Only add synthetic events `defer' and
	`external' when the feature is present in the model.

2024-03-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	explore: Introduce synthesic flush event.
	This fixes the blocking_annotation_defer LTS.

	* dzn/explore.scm (pc->rtc-lts): Add `flush' event
	(run-to-completion**): Handle it.
	* test/all/blocking-local-state-diagram/baseline/default.dot,
	test/all/state-diagram/baseline/default.dot: Update baseline.

2024-03-27  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add compliance_fork_requires2.
	* test/all/compliance_fork_requires2: New test
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-03-28  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Fix non-compliance case for multiple provides.
	* dzn/code/scmackerel/makreel.scm (constraint-processes): Allow the
	non-compliance action to the parallel composition of the provides ports
	constraining processes.

2024-03-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Truncate non-compliant trace at offending event.
	* dzn/vm/compliance.scm (check-provides-compliance)
	[truncate-to-observable]: New inner define.  Use it to truncate the sut trail.
	* test/all/compliance_blocking_function/baseline/simulate.out,
	test/all/compliance_failures_blocking_race/baseline/simulate.out,
	test/all/compliance_nonsynchronous_sync/baseline/simulate.out,
	test/all/compliance_provides_out/baseline/simulate.out,
	test/all/compliance_single_to_multiple/baseline/simulate.out,
	test/all/compliance_sync_action/baseline/simulate.out: Update baselines;
	remove component return.

2024-03-27  Rutger van Beusekom  <rutger@dezyne.org>

	vm: Prioritize illegal over non-compliance.

2024-03-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add unstable tests to TESTS, and skip executing them.
	Adding, but skipping, unstable tests makes the clumsy

	    grep -Ev 'illegal_external_nonsynchronous|livelock_synchronous_illegal|queuefull_external_sync'

	meme redundant.

	* test/all/illegal_external_nonsynchronous/run,
	test/all/livelock_synchronous_illegal/run,
	test/all/queuefull_external_sync/run: New trivial script to skip the
	test.
	* test/all/local.mk (FULL_TESTS): Add $(UNSTABLE_TESTS).

2024-03-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: run: Allow skipping tests by returning actual exit code.
	* test/bin/run.in (main): Return status / 256 instead of "not zero".

2024-03-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Avoid update-state crash.
	* dzn/vm/run.scm (extend-trace): Do not run update-state when %sut is a
	port.

2024-03-27  Rutger van Beusekom  <rutger@dezyne.org>

	vm/util: Prioritize q-trigger over other triggers.

2024-03-25  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Avoid crash in completely handwritten components.
	* runtime/c++/runtime.cc (runtime::skip_block,
	runtime::reset_skip_block): Replace .at with operator [].

2024-03-25  Janneke Nieuwenhuizen  <janneke@gnu.org>

	simulate: Allow `;' as event separator.
	The mCRL2 tools use `;' to separate events, so accepting that is convenient.

	* dzn/vm/util.scm (string->trail): Also cater for `;'-separated trail.

2024-03-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Run ltscompare from toplevel.
	Now that -eweak-trace does not produce a CounterExample.txt anymore in
	the CWD, we can run ltscompare at toplevel so that the command by run
	is easier to cut and paste.

	* test/dzn/dzn.scm (run-lts): Remove with-directory-excursion.

2024-03-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: report: Do not modify ASTs.
	* dzn/vm/report.scm (pc->event <trigger-return>): Do not modify ast.
	(pc->component-event <trigger-return>): Likewise.
	(pc->arrow <trigger-return>): Likewise.

2024-03-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: c++: Use -Wshadow for code.
	* test/lib/build.c++.make (WARN_FLAGS): Add -Wshadow.

2024-03-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: hello_namespace_foreign: Avoid shadowing in handwritten code.
	* test/all/hello_namespace_foreign/c++/library_foreign.cc (foreign::foreign):
	Rename parameter `dzn_locator' to `locator'.

	test: foreign_handwritten: Avoid shadowing in handwritten code.
	* test/all/foreign_handwritten/c++/Foreign.cc (Foreign::Foreign): Rename
	parameter `dzn_locator' to `locator'.

	test: blocking_shell: Avoid shadowing in handwritten code.
	* test/all/blocking_shell/c++/main.cc (main): Remove obsolete lock.

2024-03-20  Rutger van Beusekom  <rutger@dezyne.org>

	test: Remove -Wshadow from c++ build for alpha and shadow.
	* test/dzn/dzn.scm (run-build): New shadow? condition to override
	WARN_FLAGS for c++ when building models named *alpha* or *shadow*.

	test: resolve_formal_shadow: Rename from resolve_formal.
	* test/all/resolve_formal: Rename to...
	* test/all/resolve_formal_shadow: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.
	resolve_formal_shadow.

	c++: Avoid shadowing in nested defer c++11 capture workaround.
	* dzn/code.scm (code:capture-name): Add defer object to and use its
	location offset to make temporary variable name unique.
	* dzn/code/scmackerel/c++.scm (ast->code <defer>): Pass defer object to
	code:member-name along with variable.

	test: blocking_shell: Fix shadow warning.
	* test/all/blocking_shell/blocking_shell.dzn: Rename Int i to Int i_.

2024-03-20  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Move declarations, some renames to avoid shadowing.
	Although shadowing (lexical scoping) is a useful language feature,
	e.g. to avoid unreadably or unnecessarily long names, it is preferrable
	to avoid any possible shadowing warning in header files, so that a user
	can use any shadowing warning flag they like for their own code.

	* runtime/c++/dzn/coroutine.hh (coroutine::coroutine,
	coroutine::yield_to, coroutine::call, coroutine::release): Move
	definitions...
	* runtime/c++/coroutine.cc: ...to this new file.
	* runtime/local.mk (dist_runtime_cxx_DATA): Add it.
	(%C%_libdzn_c___la_SOURCES): Add it.
	* runtime/c++/dzn/pump.hh (pump::deadline::t): Rename to...
	(pump::deadline::time): ...this.  Update methods.
	pump::deadline::deadline): Move definition...
	* runtime/c++/pump.cc (pump::deadline::deadline):
	(pump::operator ()): Update
	* runtime/c++/dzn/runtime.hh (event<R (Args...)> e): Rename to `f' to
	avoid shadowing.  Update users throughout.

2024-03-20  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: json: Fix crash on behavior with function.
	* dzn/code/language/json.scm (json:value): Use simple-format.  Support
	booleans, export *unspecified* as `null' (was "undefined").

	test: Add undefined/interface/call_in_function.
	* test/all/undefined/interface/call_in_function: New test.

	ast: Fix crash in ast:recursive for non well-formed AST.
	* dzn/ast.scm (ast:recursive?)[clean-function*]: New inner define.  Use
	it to avoid calling ast:function* on an <event> and crashing.

2024-03-15  Paul Hoogendijk  <paul@dezyne.org>
	    Rutger van Beusekom  <rutger@dezyne.org>

	test: Add collateral_illegal.
	* test/all/collateral_illegal: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-03-18  Rutger van Beusekom  <rutger@dezyne.org>

	makreel: Add semantics_blocking_switch_context.
	* dzn/code/scmackerel/makreel.scm (semantics-unblocked): Rename
	switch-context-actions+switch=p to
	unblocked-switch-context-actions+switch=p.
	(unblocked-semantics-modeling+switch-context): Rename
	semantics-modeling+switch-context to
	unblocked-semantics-modeling+switch-context.
	(blocking-semantics-modeling+switch-context): Add
	blocking-semantics-modeling+switch-context.
	(semantics-blocking): Add blocking-switch-context-actions+switch=p add
	to semantics_blocking to cater for switch_context.

2024-03-14  Rutger van Beusekom  <rutger@dezyne.org>

	simulate: Refactor.
	* dzn/vm/compliance.scm (check-provides-compliance): Maintain original
	list of port-traces instead of recreating it with append.

2024-03-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	simulate: Skip compliance check for return-triggers unless defer.
	* dzn/vm/compliance.scm (check-provides-compliance+): Unless there's a
	defer-q, skip compliance for return-triggers.

	vm: compliance: Remove dead code.
	* dzn/vm/compliance.scm (zip): Remove port-start.

	test: Add blocking_shared_reply.
	* test/all/blocking_shared_reply/blocking_shared_reply.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.
	(XFAIL_SIMULATE): Add it.

	test: Add shared_reply.

2024-03-13  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add blocking_optional.
	* test/all/blocking_optional/blocking_optional.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-03-14  Janneke Nieuwenhuizen  <janneke@gnu.org>

	simulate: Skip compliance check for requires-trigger while blocked.
	* dzn/vm/compliance.scm (check-provides-compliance+): Also skip
	compliance check for requires-trigger in blocking context.

2023-11-16  Paul Hoogendijk  <paul@dezyne.org>

	command-line: Fix dzn:verbosity.
	* dzn/command-line.scm (dzn:verbosity): Re-implement.

2024-03-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: compliance: Avoid instance cross-talk.
	* dzn/vm/compliance.scm (run-provides-port): Reset instance on ipc.

2024-03-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: system_foreign_only: Add to REGRESSION_TESTS.
	This is a follow-up to commit
	    f72c256a4f2ac5afc5bc7fd05fa05d6a17060a67
	    test: Add system_foreign_only.

	* test/all/local.mk (REGRESSION_TESTS): Add system_foreign_only.

2024-03-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: illegal_optional: Re-add to REGRESSION_TESTS.
	This is a follow-up to commit
	    3312f6178a647422ef9d282fa64d847504a12317
	    Remove silence feature.

	* test/all/local.mk (REGRESSION_TESTS): Add illegal_optional.
	* test/all/illegal_optional/baseline/simulate.err,
	test/all/illegal_optional/baseline/simulate.out,
	test/all/illegal_optional/baseline/verify.err: Update baseline.

2024-03-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: blocking_defer: Add to REGRESSION_TESTS.
	This is a follow-up to commit
	    53b6d98f60de66570a936169acc6e632d4e046de
	    test: Add blocking_defer.

	* test/all/local.mk (REGRESSION_TESTS): Add blocking_defer.

2024-03-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Print deferred and handling for PC's instance state.
	* dzn/vm/goops.scm (write <state>): Print deferred and handling.

	explore: Fix collateral release.
	* dzn/explore.scm (pc->rtc-lts): Consider
	blocked-on-boundary-collateral-release.

2024-03-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Fix LTS of collateral_blocking.
	This fixes the LTS of

	    test/all/collateral_blocking
	    test/all/collateral_blocking_multiple_provides2

	* dzn/vm/util.scm (state->string <state>): Also consider handling.

2024-03-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	graph: Remove magic constants from help.
	* dzn/commands/graph.scm (parse-opts): Use %queue-size,
	%queue-size-defer, %queue-size-external.

2024-04-12  Rutger van Beusekom  <rutger@dezyne.org>

	vm: Refactor debugging.

2024-03-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: More verbose assign debugging.
	* dzn/vm/step.scm (step <assign>): Also print variable and expression.

2024-03-13  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Add programming-error for step with port-trigger on component.
	* dzn/vm/step.scm (begin-step <runtime:component>): Throw
	programming-error for a trigger without a port.

2024-04-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Throw programming-error when statement lacks an implementation.
	* dzn/vm/step.scm (step <statement>): Throw 'programming-error instead
	of returning nil.

2024-03-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	verify: Also produce --queue-size options in debug output.
	* dzn/config.scm.in (%default-queue-size, %default-queue-size-defer,
	%default-queue-size-external): New variables.
	* dzn/verify/pipeline.scm (pretty-verify-pipeline): Use them to produce
	--queue-size flags for debug output.

2024-03-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: Respect --queue-size-external option.
	This helps debuging using dzn -d verify ...

	* dzn/commands/code.scm (main): Fix typo.

2024-03-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	step: Cleanup.
	* dzn/vm/step.scm (step): Use if instead of trivial cond.

2024-03-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	makreel: Add dummy %tag-action process to compensate for sm:tag.
	This is a follow-up to commit
	    6567623f8c704c3ec4199495b72517290b4a2323
	    verify: Improve performance of unreachable code check.

	The sm:tag has no semantics and "just prints" tag (x,y) a stealth
	action; that doesn't (always) work with mCRL2, as every action needs to
	be declared.

	Code that generates such a stealth tag (x, y) and also uses %tag-action
	"happens" to work; code that only generates a stealth tag (x, y) and
	doesn't use %tag-action anywhere, breaks.

	* dzn/code/scmackerel/makreel.scm (dummy-tag-process): New variable.
	(root->scmackerel): Use it.

2024-03-07  Rutger van Beusekom  <rutger@dezyne.org>

	pipe: Kill pipeline processes on SIGINT, SIGALRM.
	* dzn/pipe.scm (pipeline->string, pipeline->port): Install SIGINT and
	SIGALRM (if available) signal handler that calls kill <SIGNAL> on all
	pipeline pids.

2024-03-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	verify: Refactor --no-interfaces.
	* dzn/verify/pipeline.scm (mcrl2:verify-interface-asserts): Remove skip
	by looking at command-line hackery.
	(verification:verify): Add #:no-interfaces? parameter.  Use it to remove
	interfaces from models to verify.
	* dzn/commands/verify.scm (main): Pass it.
	* doc/dezyne.texi (Invoking dzn verify): Fix documentiation.

2024-03-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Update to 2.18.1.
	* guix/pack/dezyne.scm (dezyne): Update to 2.18.1.

2024-01-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `NEWS'.
	* NEWS (Changes in 2.18.1 since 2.18.0): New section.

2024-03-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add blocking_nondet.
	* test/all/blocking_nondet/blocking_nondet.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-03-01  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Oops, do not drop alternative port states.
	Reported by logocp via IRC.

	* dzn/vm/compliance.scm (check-provides-compliance): Do not include
	`traces' in map; it's always a singleton list and would thus drop port
	alternative states.

2024-02-16  Rutger van Beusekom  <rutger@dezyne.org>

	code: c++: Refactor/optimize.
	* dzn/code/goops.scm (<shared-transition>): Remove redundant rtc?.
	* dzn/code.scm (code:shared): Rename event-regexp to enum-regexp.
	Rename markeel->event to markeel->enum. Remove redundant string?
	application. Remove redundant <shared-transition> and <shared-value>,
	use <edge> instead.
	* dzn/code/scmackerel/c++.scm (interface->sm:statements-unmemoized):
	Update for <edge> instead of <shared-transition> and <shared-value>.

2024-02-18  Rutger van Beusekom  <rutger@dezyne.org>

	timing: Export *let*.

2024-02-16  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Reduce dzn_update_state code generation overhead.
	* dzn/code/scmackerel/c++.scm (interface->sm:statements-unmemoized):
	Replace delete-duplicates with sort and delete-adjacent-duplicates.

	misc: Add delete-adjacent-duplicates.
	* dzn/misc.scm (delete-adjacent-duplicates): New procedure.

	code: Use precompiled regexp to reduce overhead.
	* dzn/code.scm (code:shared): Replace string-match with regexp-exec and
	inline regex literals with define'd compiled regexes.

2024-02-13  Rutger van Beusekom  <rutger@dezyne.org>

	c++ pump: Remove infinite 0 delay timout loops.
	Service all timeouts that have expired at a single point in time instead
	of moving the point in time forward after executing the timeout side
	effect.

	* runtime/c++/dzn/pump.hh (deadline::expired, pump::timer_expired): Add
	now parameter.
	* runtime/c++/pump.cc (pump::operator ()): Determine now before entering
	the loop.
	* runtime/c++/pump.cc (pump::create_context): Update call location.

2024-02-13  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add defer_async.
	* test/all/defer_async/defer_async.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2024-01-30  Rutger van Beusekom  <rutger@dezyne.org>

	simulate: Merge state and hide redundant port instances.
	* dzn/vm/util.scm (serialize-header): Remove internal port instances.
	(serialize): Merge port state into corresponding component state, using
	a .name + "." prefix for the variables.
	(merge-port-state): New procedure.
	* test/all/blocking_system2/baseline/simulate.out,
	test/all/compliance_system_hello_world/baseline/simulate.out,
	test/all/compliance_system_provides_bool/baseline/simulate.out,
	test/all/hello_system_reply/baseline/simulate.out,
	test/all/illegal_system_requires/baseline/simulate.out,
	test/all/semantics/baseline/semantics.org,
	test/all/state_deadlock/baseline/simulate.out,
	test/all/system_shared/baseline/simulate.out: Update baselines.

2024-01-09  Rutger van Beusekom  <rutger@dezyne.org>

	pipeline: Verify each (interface) model only once.
	* dzn/verify/pipeline.scm (mcrl2:verify-component): Remove implicit
	interface verification.
	(verification:verify): Verify interfaces explicitly.

	* test/all/compliance_failures_blocking_race/baseline/verify.err,
	test/all/compliance_failures_multiple_provides/baseline/verify.err,
	test/all/compliance_fork_blocking_bypass/baseline/verify.err,
	test/all/deadlock_asynchronous_sync_reply/baseline/verify.err,
	test/all/hello_two/baseline/verify.err,
	test/all/match_blocking_race/baseline/verify.err: Update baseline.

	* test/all/blocking_double_release/baseline/verify.err,
	test/all/blocking_double_release/baseline/verify.out,
	test/all/blocking_multiple_provides0/baseline/verify.err,
	test/all/blocking_multiple_provides0/baseline/verify.out,
	test/all/compliance_system_provides_bool/baseline/verify.err,
	test/all/compliance_system_provides_bool/baseline/verify.out,
	test/all/illegal_system_requires/baseline/verify.err,
	test/all/illegal_system_requires/baseline/verify.out: Add baseline.

2024-02-10  Rutger van Beusekom  <rutger@dezyne.org>

	test: Fix models that are not currently verified.
	* test/all/foreign_import_system/hello_foreign.dzn,
	test/all/foreign_import_system/iworld.dzn,
	test/all/system_bool_enum/system_bool_enum.dzn,
	test/all/system_shared/system_shared.dzn,

2024-02-09  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add compliance_reply_illegal.
	* test/all/compliance_reply_illegal/compliance_reply_illegal.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.
	* test/all/compliance_reply_illegal/trace: Add error trace.
	* test/all/compliance_reply_illegal/baseline/simulate.err,
	test/all/compliance_reply_illegal/baseline/simulate.out,
	test/all/compliance_reply_illegal/baseline/verify.err,
	test/all/compliance_reply_illegal/baseline/verify.out: Add corresponding
	baselines.

	verify: Also mark non-compliant replies as <non-compliance>.
	* dzn/verify/constraint.scm (lts->makreel): Split action+replies and map
	replies filtered  to Non_Compliance instead of constraint_any.
	* dzn/code/scmackerel/makreel.scm (%non-compliant-action): Add
	"non_compliance" action.
	(illegal-processes): Add Non_Compliant process.
	(component-processes, constraint-processes): Allow non_compliance action.
	* dzn/lts.scm (parse-label): Add non_compliance action to illegal rule.
	* test/all/deadlock_blocking_compliance/baseline/verify.out: Update
	baseline.

2024-02-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	pipeline: Use cute instead of cut.
	* dzn/verify/pipeline.scm: Throughout.

2024-02-10  Janneke Nieuwenhuizen  <janneke@gnu.org>

	makreel: Cleanup.
	* dzn/code/language/makreel.scm (makreel:add-state-placeholder): Break
	long lines.

	normalize: Cleanup.
	* dzn/ast/normalize.scm (triples:mark-the-end): Use ast:modeling?
	primitive, fix line break.

2024-02-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Fix all-go target after clean.
	* Makefile.am (%.go): Depend on .scm built sources.

	parse: Remove quadratic line offsets calculation.
	* dzn/ast/parse.scm (parse-tree->ast)[text->lines-offsets]: New inner
	define.  Use it to set `newlines'.:

2024-01-22  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add parse_space_duplicate_definition.
	Reported via IRC by logocp52.

	* test/all/parse_space_duplicate_definition: New test.
	* test/all/local.mk (PARSER_TESTS): Add it.

2024-02-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	wfc: Also check for toplevel definitions in namespace.
	* dzn/ast/wfc.scm (previous-definition-unshadowed): Also consider scope
	when looking-up previous definition.
	(re-definition-error): Use full name in report.

	doc: Clarify licensing of generated code.
	* doc/dezyne.texi (Conditions for Using Dezyne): Make explicit to which
	"its" refers in line three.

2024-01-26  Janneke Nieuwenhuizen  <janneke@gnu.org>

	script: Typo.
	* dzn/script.scm (parse-opts): Add space.

2024-01-23  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Silence warnings when git is missing.
	* Makefile.am: Send git errors to /dev/null.

2024-01-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Support release-git.
	* Makefile.am (update-git-hash, (release-git): New targets.

2024-01-09  Rutger van Beusekom  <rutger@dezyne.org>

	pipeline: Refactor.
	* dzn/verify/pipeline.scm (mcrl2:verify-interface-asserts): Move procedure.

	makreel: Refactor.
	* dzn/code/scmackerel/makreel.scm (assign->sum): Use sum-state-action.

2023-12-21  Rutger van Beusekom  <rutger@dezyne.org>

	code: Instantly assert illegal on triggers.
	* dzn/code.scm (code:shared): Remove the trigger return edges to an
	illegal node from the constraining LTS used for code generation.

	c++: Add dzn::check_bindings to handwritten main.
	* test/all/blocking_binding/main.cc,
	test/all/blocking_double_release/main.cc,
	test/all/blocking_multiple_provides2/main.cc,
	test/all/blocking_multiple_provides3/main.cc,
	test/all/blocking_release/main.cc,
	test/all/blocking_shell/c++/main.cc,
	test/all/blocking_system_diamond/main.cc,
	test/all/calling_context/main.cc,
	test/all/collateral_blocking_backdoor/main.cc,
	test/all/collateral_blocking_bridges/main.cc,
	test/all/collateral_blocking_double_release/main.cc,
	test/all/collateral_blocking_multiple_provides/main.cc,
	test/all/collateral_blocking_multiple_provides0/main.cc,
	test/all/collateral_blocking_release/main.cc,
	test/all/collateral_blocking_reorder/main.cc,
	test/all/collateral_blocking_reorder_parallel/main.cc,
	test/all/collateral_blocking_shell/main.cc,
	test/all/collateral_blocking_shell2/main.cc,
	test/all/collateral_double_blocked/main.cc,
	test/all/defer_data/main.cc,
	test/all/double_collateral_blocking_shell/main.cc,
	test/all/foreign_only/main.cc,
	test/all/foreign_optional/c++/main.cc,
	test/all/foreign_requires/c++/main.cc,
	test/all/hello_mock/main.cc,
	test/all/ihello_mock/main.cc,
	test/all/pump_twice/main.cc,
	test/all/shared_glue/main.cc,
	test/all/shell_injected/c++/main.cc,
	test/all/sync_out_reply_binding/main.cc: Add call to
	dzn::check_bindings (sut).

	c++: Fix dzn::check_bindings for foreign components.
	* runtime/c++/dzn/runtime.hh (check_bindings <Foreign>): Add
	specialization.

2024-01-09  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add inner_guard_shared_state_deadlock.
	* test/all/inner_guard_shared_state_deadlock: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	makreel: Prevent deadlock caused by inner guards.
	* dzn/code/language/makreel.scm (makreel:normalize): Move application of
	makreel:add-state-placeholder after normalize:state+illegals.

2024-01-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add defer_local_field_test.
	* test/all/defer_local_field_test/defer_local_field_test.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	code: Also find local for defer when used in a field test.
	* dzn/code.scm (code:capture-local): Also consider <field-test>.

2023-12-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Also append version to properly installed headers.
	This is a follow-up to commit
	    4de2a4b88f8decb43f9f7bff667b1c0548c374f1
	    build: Build and install C and C++ headers and libraries.

	* Makefile.am (install-data-hook): Also append version comment to
	headers in $(includedir).

2023-12-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add interface_nondet2.
	Suggested by logocp vi IRC.

	* test/all/interface_nondet2/interface_nondet2.dzn: New file.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2023-12-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	simulate: Allow non-deterministism in interfaces.
	This is a follow-up to commit
	    8c0a037f41531a960716a1024f1698db9e742cd8
	    simulate: Fix determinism_optional.

	* dzn/vm/run.scm (non-deterministic?): Filter-out interface-nondeterminism.

2023-12-13  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Set shared state strictness via event::set.
	* runtime/c++/dzn/runtime.hh (in::event<R (Args...)>,
	in::event<void (Args...)>, out::event<void (Args...)>): Rename
	dzn_shell_p to dzn_strict_p,
	(out::event::operator = (event const&): Add asserts.
	* dzn/code/scmackerel/c++.scm (shell-system->sm:statements-unmemoized):
	Remove explicit dzn_shell_p assignment and rely on relaxed default
	setting of dzn_strict_p.

2024-02-16  Janneke Nieuwenhuizen  <janneke@gnu.org>

	runtime: c++: Use left-associative const.
	* runtime/c++/dzn/pump.hh,
	runtime/c++/pump.cc: Use left-associative const.

2023-12-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	runtime: c++: Use GNU-style function type/name layout.
	This is a follow-up to commit
	    697cbab3fb7a1e49c62d920a101072328b56d8a3
	    Use GNU style indentation for C++.

	* runtime/c++/dzn/runtime.hh,
	runtime/c++/pump.cc,
	runtime/c++/runtime.cc,
	runtime/c++/std-async.cc,
	runtime/c++/thread-pool.cc: Place return type on its own line so that
	git grep ^<function-name> and tags find their definition.

2023-12-12  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Post-release update.
	* doc/announce/ANNOUNCE-2.18.0: Update checksums.

	guix: dezyne: Update to 2.18.0.
	* guix/pack/dezyne.scm (dezyne): Update to 2.18.0.

2023-09-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `ANNOUNCE-2.18.0'.
	* doc/announce/ANNOUNCE-2.18.0 (NEWS): Update from NEWS.

2023-09-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `NEWS'.
	* NEWS (Changes in 2.18.0 since 2.17.3): Mention tail-recursive
	false-positives, well-formedness check for thread-safe shell systems'
	outer requires ports to have the external qualificier, the -o,--output
	option for json and makreel, multiple usage of -s,--shell, removal of
	the -j,-jitty option.

2023-12-12  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add stateful_injected.
	* test/all/stateful_injected: New test.
	* test/all/local.mk (HELLO_TESTS): Add it.

	c++: Prevent resetting injected port state.
	* dzn/code/scmackerel/c++.scm (port->injected-require-override):
	Only overwrite dzn_meta, not port state.

2023-12-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Compile c++ runtime with WARN_FLAGS too.
	* runtime/local.mk (WARN_FLAGS): New variable.
	(%C%_libdzn_c___la_CPPFLAGS): Use it.

2023-12-11  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Avoid some shadowing.
	This apparently works around two bugs in the MicroSoft C++ compiler.

	* runtime/c++/dzn/runtime.hh: Use this-> throughout.

2023-12-11  Rutger van Beusekom  <rutger@dezyne.org>

	test: Fix foreign_optional for dzn::in|out::event use.
	* test/all/foreign_optional/c++/main.cc (main): Call foreign
	implementation including runtime.

2023-12-08  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add ihello_mock.
	* test/all/ihello_mock: New test.
	* test/all/local.mk (HELLO_TESTS): Add it.

2023-12-11  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Add interface template constructor to initialize events.
	* dzn/code/scmackerel/c++.scm (interface->sm:statements-unmemoized:
	constructor): Here,
	(provides->member, requires->member): Use here,
	(event-set): Remove.

2023-12-08  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_mock.
	* test/all/hello_mock/hello_mock.dzn,
	test/all/hello_mock/main.cc: New test.
	* test/all/local.mk (HELLO_TESTS): Add it.

	c++: Cater for not flushing boundary synchronous out events.
	* runtime/c++/dzn/runtime.hh (operator =): Replace skip_queue with
	!dzn_port_meta->require.component.
	* dzn/code/scmackerel/c++.scm (main-connect-ports),
	runtime/c++/dzn/runtime.hh (event<void (Args...)>),
	(event): Remove skip_queue.
	* dzn/code/scmackerel/c++.scm (main-event-map): Initialize
	require.component to a nullptr.

2023-12-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add shared_determinism.
	* test/all/shared_determinism/shared_determinism.dzn: New file.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2023-12-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	simulate: Report new unobservably non-deterministic variant.
	* dzn/vm/run.scm (run-to-completion-unmemoized)
	[interface-non-deterministic, interface-mark-determinism-error]: New
	inner defines.  Use them to report the new unobservably
	non-deterministic variant.

2023-12-07  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Remove dead code.
	* runtime/c++/dzn/runtime.hh (dzn_share_p): Remove.
	(in::event<R (Args...)>, in::event<void (Args...)>,
	out::event<void (Args...)>): Remove in favor of interface dzn_share_p
	encapsulated by port_update.

2023-12-07  Janneke Nieuwenhuizen  <janneke@gnu.org>

	c++: Remove experimental exception wrappers.
	* configure.ac: Remove check for --enable-c++-exception-wrappers.
	* runtime/examples/exception_context.hh: Remove.
	* Makefile.am (install-data-hook)[have_cxx_exception_wrappers]: Do not
	package it.
	* dzn/code/language/c++-exception-wrappers.scm: Remove.
	* dzn/code/language/local.mk (dist_%C%_scm_DATA): Remove it.
	* dzn/templates/README: Remove reference to c++-exception-wrappers.
	* dzn/templates/c++-exception-wrappers.scm: Remove.
	* dzn/templates/c++-exception-wrappers/: Remove.
	* test/all/exception_wrappers: Remove.
	* dzn/templates/local.mk (dist_nocompile_%C%_scm_DATA, EXTRA_DIST):
	Remove them.
	* test/all/local.mk (REGRESSION_TESTS, EXTRA_DIST): Remove it.

2023-12-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Honor configure --without-boost.
	* configure.ac: Make $want_boost a prerequisite for
	have_boost_coroutine.

2023-12-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	json: Do not implicitly remove behavior.
	To get the old result, without behavior, use the generic
	"--transform=remove-behavior" on dzn.

	* dzn/code/language/json.scm (system-diagram): Remove remove-behavior.

2023-12-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: Remove obsolete -B,--no-blocking from help.
	This is a follow-up to commit
	    a4fc3937f98a90ac790d89dbd591afc900775a79
	    code: Remove -B,--no-blocking option.

	* dzn/commands/code.scm (parse-opts): Remove -B,--no-blocking.

2023-12-05  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	Change shared-state semantics to update after provides out event.
	This enables trivial integration in C++ using operator = ().

	* runtime/c++/dzn/runtime.hh (in::event, out::event): New structs
	replacing std::function in interfaces, encapsulating all other runtime
	interaction.
	(connect): Replace by generated version.
	(queue_p): Rename from async.
	(handle): Remove.
	(share_trace_wrapper,runtime_wrapper, call_in, call_out): Remove.
	(hash): Replace list of char const* with char const*.
	* runtime/c++/pump.cc (port_block, port_release, collateral_block): Add
	debug tracing.
	* runtime/c++/runtime.cc (trace_in): Rename from trace.
	(runtime::queue_p): Rename from async ...
	(runtime::enqueue): ... update usage here.
	* dzn/code.scm (code:shared-lts-unmemoized): Replace the rtc-lts with a
	regular lts.
	(code:shared, code:shared-state): Cater for state (Void) in regexp.
	(code:shared-state): Use `from' instead of `to' to include assignments
	in dzn_update_state case block.
	* dzn/code/scmackerel/c++.scm (interface->sm:statements-unmemoized):
	Replace dzn_prefix with dzn_label.
	(ast->code): Remove call_in and call_out
	(synchronize->member, non-rtc-transitions): Remove.
	(event-set): New procedure.
	* dzn/code/scmackerel/makreel.scm (ast->process): Communicate state
	after provides out events.
	* dzn/lts.scm (display-lts): Display a single label string.
	* dzn/vm/compliance.scm (run-provides-modeling, run-provides-port,
	port-acceptance-equal?, compliance-first-non-match,
	update-shared-state): New procedures to support updating state after
	provides out actions during compliance.
	* dzn/vm/run.scm (extend-trace): Update shared state.
	* dzn/vm/evaluate.scm (eval-expression): Cater for void action.
	(step): Allow explicit void reply.
	* dzn/vm/util.scm (instance-rtc-trigger): New procedure.
	* test/all/hello_multiple_nondet/hello_multiple_nondet.dzn: Remove
	interface non-determinism.
	* test/all/foreign_handwritten/c++/Foreign.cc,
	test/all/foreign_handwritten/c++/Foreign.hh,
	test/all/hello_namespace_foreign/c++/library_foreign.cc,
	test/all/hello_namespace_foreign/c++/library_foreign.hh: Apply trivial
	integration.
	* test/all/deadlock_reply/baseline/simulate.out: Update baseline.
	* dzn/ast/util.scm (tree-find): New procedure.
	* dzn/code/goops.scm (<state>): New ast type.
	* dzn/code/language/makreel.scm (makreel:add-state-placeholder): New
	procedure ...
	* dzn/code/scmackerel/makreel.scm (ast->process): Extract from here ...
	(makreel:normalize): Use here.
	* test/all/shared_async_provides/shared_async_provides.dzn,
	test/all/shared_out_sync_provides/shared_out_sync_provides.dzn: Cater
	for state communication with the occurrence of out events.

2023-12-05  Rutger van Beusekom  <rutger@dezyne.org>

	test: second_reply_sync: Fix non compliance.
	* test/all/second_reply_sync/second_reply_sync.dzn: Add h.world () on
	w.world ().
	* test/all/second_reply_sync/baseline/verify.out,
	test/all/second_reply_sync/baseline/simulate.err,
	* test/all/second_reply_sync/baseline/simulate.out: Update baseline.

	test: blocking_shell: Refactor main.
	* test/all/blocking_shell/c++/main.cc (main): Refactor.

	peg: Expect instance name and not a keyword for instance.
	* dzn/parse/peg.scm (peg:parse): Add a `#' to instance <-- ... name and
	reverse binding and instance order.

2023-11-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add determinism_optional.
	* test/all/determinism_optional/determinism_optional.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	simulate: Fix determinism_optional.
	* dzn/vm/run.scm (non-deterministic?): Catch determinism errors also for
	<postponed-match> where there is no choice point.
	(run-to-completion-unmemoized): Call it early.

2023-11-16  Janneke Nieuwenhuizen  <janneke@gnu.org>

	json: Honor -o,--output directory.
	* dzn/code/language/json.scm (ast->): Use code:dump to write to file
	by default.
	* dzn/commands/graph.scm (main): Call code with #:dir "-" to compensate
	for that.

	makreel: Honor -o,--output directory.
	* dzn/code/language/makreel.scm (ast->): Use code:dump to write to file
	by default.
	* dzn/verify/pipeline.scm (pretty-verify-pipeline): Add `-o-' to debug
	command output.

	code: Remove unused parameter from  code:dump.
	* dzn/code/util.scm (code:dump): Remove root parameter.
	* dzn/code/language/c++-exception-wrappers.scm (ast->): Update caller.
	* dzn/code/language/c++.scm (ast->): Likewise.
	* dzn/code/language/c.scm (ast->): Likewise.
	* dzn/code/language/cs.scm (ast->): Likewise.
	* dzn/code/language/dzn.scm (ast->): Likewise.
	* dzn/code/language/javascript.scm (ast->): Likewise.
	* dzn/code/language/scheme.scm (ast->): Likewise.

	code: Honor multiple uses of --shell.
	* dzn/commands/code.scm (main): Use multi-opt for shell, pass list for
	%shell.
	* dzn/ast/wfc.scm (wfc-external): Cater for %shell being a list.
	* dzn/code.scm (code:annotate-shells): Likewise.
	* doc/dezyne.texi (Invoking dzn code): Document it.

2023-11-13  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hello_void.
	* test/all/hello_void/hello_void.dzn: New test.
	* test/all/local.mk (HELLO_TESTS): Add it.

2023-11-10  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Rename dzn::async to dzn::std_async.
	* runtime/c++/std-async.cc (dzn::async): Rename to...
	(dzn::std_async): ...this.
	* runtime/c++/dzn/async.hh: Rename to...
	* runtime/c++/dzn/std-async.hh): ...this, and update accordingly.
	* runtime/c++/thread-pool.cc (dzn::async): Rename to...
	(dzn::std_async): ...this.
	* runtime/c++/dzn/context.hh (context): Update caller.
	* runtime/c++/pump.cc (pump::pump): Update caller.

2023-11-11  Janneke Nieuwenhuizen  <janneke@gnu.org>

	json: Support output without any model.
	Reported by MikeFTR via IRC.

	* dzn/code/language/json.scm (system-diagram): Only filter-model when
	there's a model.

2023-11-10  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: scmackerel: Uptate to 0.5.3.
	* guix/pack/scmackerel.scm (scmackerel): Update to 0.5.3.

2023-08-15  Paul Hoogendijk  <paul@dezyne.org>

	verify: Improve performance of unreachable code check.
	Improve performance of unreachable code check by modelling tags
	as normale transitions and remove tags from the makreel source code
	of interfaces when they are included for makreel code of component.

	* dzn/ast/normalize.scm (tag-imperative-blocks): Simplify and unify
	with e.g. add-defer-end.
	* dzn/lts.scm (remove-tag-loops): Remove...
	(assert-livelock): ...remove call to it.
	(deadlock-nodes): ...remove call to it.
	* dzn/code.scm (%no-tags-interface?): Add new parameter.
	* dzn/code/scmackerel/makreel.scm <sm:tag>: New sm:node for tagging
	statements.
	(print-sm:tag): New function for displaying sm:tag node, don't
	display tag if tag is part of an interface and in the context of a
	component.
	(ast->process <model>): Use sm:tag for tagging.
	(port-processes): Remove blocking of tags.
	* dzn/code/language/makreel.scm (root-> o): Set parameter
	%no-tags-interface? to true when top model is a component.

	* test/all/*: Change error traces to current reported error traces.

2023-11-09  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add hash_collision2.
	* test/all/hash_collision2/trace: Add a trivial trace to reduce the
	running time.
	* test/all/hash_collision2/hash_collision.dzn2: New test.
	* test/all/local.mk: Add it.

	c++: Prevent further hash collision.
	* runtime/c++/dzn/runtime.hh (hash): Prevent further hash collision by
	using the string representation of node index for the hash calculation.
	* dzn/code/scmackerel/c++.scm (dzn:hash): Likewise.

	test: Add hash_collision.
	* test/all/hash_collision/hash_collision.dzn: New test.
	* test/all/local.mk: Add it.

	c++: Update pow after initial use to prevent hash collision.
	* runtime/c++/dzn/runtime.hh (hash): Move updating pow before next use.
	dzn/code/scmackerel/c++.scm (dzn:hash): Likewise.

2023-11-07  Rutger van Beusekom  <rutger@dezyne.org>

	test: foreign_only: Extend for multiple out events.
	* test/all/foreign_only/foreign_only.dzn (foreign_only.cruel): Change to
	out-event.  Use it to output multiple events.
	* test/all/foreign_only/foreign.hh (struct foreign),
	* test/all/foreign_only/main.cc (connect_ports),
	test/all/system_foreign_only/system_foreign_only.dzn (proxy),
	accordingly.
	test/all/foreign_only/trace: Update accordingly.

2023-11-02  Paul Hoogendijk  <paul@dezyne.org>

	wfc: Add check for statement after return.
	* dzn/ast/wfc.scm (wfc <return>): Check that return is last statement of
	block.
	* test/all/unreachable_return: Add tests for it.
	* test/all/wf_functionReturnValue,
	test/all/wf_functionTailRecursion,
	test/all/wf_functionTailRecursion: Update baselines.

2023-11-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add space.foreign.
	* test/all/space.foreign: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2023-11-06  Rutger van Beusekom  <rutger@dezyne.org>

	test: foreign_only: Add asynchronous out event.
	* test/all/foreign_only/foreign_only.dzn (foreign_only.cruel): Add
	event.  Also use inevitable.
	* test/all/foreign_only/foreign.hh,
	test/all/foreign_only/main.cc,
	test/all/foreign_only/trace: Update accordingly.

	c++: Fix foreign_only asynchronous out event.
	* dzn/code/scmackerel/c++.scm
	(component-model->sm:statements-unmemoized): Add dzn_update to call_out.

2023-11-04  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add parse_imperative_guard.
	* test/all/parse_imperative_guard/parse_imperative_guard.dzn,
	* test/all/parse_imperative_guard/baseline/verify.err,
	* test/all/local.mk (PARSER_TESTS): Add it.

	wfc: Add check for guards within imperative contexts.
	* dzn/ast/wfc.scm (wfc <guard>): Check for non-imperative parent.

2023-11-02  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Support c++20, removal of std::result_of<Callable>.
	* runtime/c++/dzn/pump.hh (shell)[__cplusplus > 201402L],
	runtime/c++/dzn/runtime.hh (struct runtime)[__cplusplus > 201402L]:
	Replace std::result_of with std::invoke_result.

2023-10-30  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add blocking_defer.

2023-10-12  Rutger van Beusekom  <rutger@dezyne.org>

	doc: Fix typo.

2023-10-08  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: thread-pool: Reorder pool members.
	* runtime/c++/thread-pool.cc (class pool): Initialize task vector last,
	to destroy it first and before other resources like the mutex.

2023-10-03  Rutger van Beusekom  <rutger@dezyne.org>

	test: LegoBallSorter black box pattern.
	Avoid redundant imports and as result wellformedness checking time.

	* test/all/LegoBallSorter/LegoBallSorter.dzn: Move Brick* ...
	test/all/LegoBallSorter/Brick1.dzn,
	test/all/LegoBallSorter/Brick2.dzn,
	test/all/LegoBallSorter/Brick3.dzn,
	test/all/LegoBallSorter/Brick4.dzn: ... here.
	test/all/LegoBallSorter/blackboxBallSorter.dzn,
	test/all/LegoBallSorter/blackboxBrick1.dzn,
	test/all/LegoBallSorter/blackboxBrick2.dzn,
	test/all/LegoBallSorter/blackboxBrick3.dzn,
	test/all/LegoBallSorter/blackboxBrick4.dzn: Create black box (foreign)
	versions.
	* test/all/LegoBallSorter/blackboxLegoBallSorter.dzn: Copy from
	LegoBallSorter importing black box (foreign) version.
	* test/all/LegoBallSorter/MaterialHandler.dzn: Move IHandleRobust ...
	* test/all/LegoBallSorter/IHandle.dzn: ... here.
	* test/all/LegoBallSorter/LightSensor.dzn: Move ILightSense ...
	* test/all/LegoBallSorter/ILightSense.dzn: ... here.
	* test/all/LegoBallSorter/Motor.dzn: Move IMove ...
	* test/all/LegoBallSorter/IMove.dzn: ... here.
	* test/all/LegoBallSorter/TouchSensor.dzn: Move ITouchSense ...
	* test/all/LegoBallSorter/ITouchSense.dzn: ... here.

2023-10-05  Paul Hoogendijk  <paul@dezyne.org>

	test: Add no_unreachable:
	* test/dzn/dzn.scm (no-unreachable?): New procedure.
	(run-verify): Use it to switch --no-unreachable.
	* test/all/no_unreachable: Test it in new test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2023-10-05  Paul Hoogendijk  <paul@dezyne.org>

	verify: fix option --no-unreachable.
	Reported by MikeFTR via IRC.

	* dzn/verify/pipeline.scm (get-tags): Cater for --no-unreachable; Instead
	of throwing, return #false when no tags are available.

2023-10-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: interface_nondet: Remove --no-interface-determinism.
	* test/all/interface_nondet/META: Remove --no-interface-determinism.

2023-09-29  Janneke Nieuwenhuizen  <janneke@gnu.org>

	verify: Remove hardcoded --tags from pipeline.
	This is a follow-up to commit
	    5604cccf8044515e713a9defadec3024cb0826f5
	    verify: Move unreachable tags from command-line to pipeline.

	* dzn/verify/pipeline.scm (in-out:aut->verify-interface,
	in-out:aut->verify-component): Remove hardcoded tags.

2023-10-30  Rutger van Beusekom  <rutger@dezyne.org>

	shell_injected: Remove shared state.
	* test/all/shell_injected/META (skip): Re-enable cs.
	* test/all/shell_injected/cs/main.cs (class main): Add handwritten main.
	* test/all/shell_injected/cs/Watchdog.cs: Implement Watchdog.
	* test/all/shell_injected/shell_injected.dzn: Replace w.idle with
	boolean watchdog.

2023-09-28  Rutger van Beusekom  <rutger@dezyne.org>

	test: shell_injected: Fix verification.
	* test/all/shell_injected/META: Enable verification; disable cs,
	scheme, lts.
	* test/all/shell_injected/shell_injected.dzn: Add a watchdog to armor
	against delayed refusal.
	* test/all/shell_injected/trace: Add watchdog events.
	* test/all/shell_injected/c++/Watchdog.hh,
	test/all/shell_injected/c++/main.cc: New files.

2023-09-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	runtime: scheme: Remove ranking for async.
	This is a follow-up to commit
	    b6cfb5af76aab7764b0a069c6c4e450e5f059090
	    scheme: Remove async feature.

	* runtime/scheme/dzn/pump.scm (dzn:handle): Remove rank parameter.

2023-09-28  Janneke Nieuwenhuizen  <janneke@gnu.org>

	runtime: cs: Remove ranking for async.
	This is a follow-up to commit
	    595533e53ca2cef6d511b9b1aeced37e578d812e
	    cs: Remove async.

	* runtime/cs/dzn/pump.cs (Deadline.rank): Remove.
	(Deadline.Deadline): Remove rank parameter.
	(Deadline.CompareTo, pump.handle): Update accordingly.

2023-09-28  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Clone the correct locator object.

2023-09-28  Rutger van Beusekom  <rutger@dezyne.org>

	c++: runtime: Remove ranking for async.
	This is a follow-up to commit
	    31de4b3cc81375370dd7749f38cd470ac8cae6bf
	    c++: Remove async.

	* runtime/c++/dzn/pump.hh (pump::rank_less, pump::time_less): Remove.
	(pump::deadline, pump::handle): Remove rank parameter.
	* runtime/c++/pump.cc (pump::handle): Likewise.

2023-09-21  Rutger van Beusekom  <rutger@dezyne.org>

	wfc: Require shell requires ports to be declared external.
	* dzn/ast/wfc.scm (wfc-external): New method,
	(wfc-skeleton): Used it to check that requires ports for shells are
	external.
	* test/all/double_hello_block/META: Remove META with unused tss option.
	* test/all/shell_injected/shell_injected.dzn,
	test/all/blocking_multiple_provides2/blocking_multiple_provides2.dzn,
	test/all/blocking_multiple_provides3/blocking_multiple_provides3.dzn,
	test/all/blocking_shell/blocking_shell.dzn,
	test/all/blocking_system_diamond/blocking_system_diamond.dzn,
	test/all/collateral_blocking_backdoor/collateral_blocking_backdoor.dzn,
	test/all/collateral_blocking_multiple_provides/collateral_blocking_multiple_provides.dzn,
	test/all/collateral_blocking_multiple_provides0/collateral_blocking_multiple_provides0.dzn,
	test/all/collateral_blocking_shell/collateral_blocking_shell.dzn,
	test/all/collateral_blocking_shell2/collateral_blocking_shell2.dzn:
	Declare outer shell requires port as external; update models to deal
	with this change.
	* test/all/blocking_shell/blocking_shell.dzn: Make requires outer shell
	ports external.
	* test/all/double_collateral_blocking_shell/double_collateral_blocking_shell.dzn:
	Make requires outer shell ports external; canonicalize.
	* test/all/double_collateral_blocking_shell/main.cc,
	test/all/double_collateral_blocking_shell/main.cs,
	test/all/double_collateral_blocking_shell/trace: Canonicalize.
	* test/all/collateral_blocking_reorder/collateral_blocking_reorder.dzn:
	Make requires outer shell ports external; insert external adapters to
	maintain the collateral blocking notion.
	* test/all/collateral_blocking_bridges/collateral_blocking_bridges.dzn:
	Make requires outer shell ports external; insert external adapters to
	maintain the collateral blocking notion.
	* test/all/collateral_blocking_bridges/main.cc,
	test/all/collateral_blocking_bridges/main.cs: Hmm, fudging the outcome
	using sleeps.
	* test/all/collateral_blocking_reorder_parallel/collateral_blocking_reorder_parallel.dzn:
	Make requires outer shell ports external; insert external adapters to
	maintain the collateral blocking notion.
	* test/all/collateral_blocking_reorder_parallel/main.cc,
	test/all/collateral_blocking_reorder_parallel/main.cs: Hmm, fudging
	the outcome using sleeps.
	* test/all/blocking_multiple_provides3/blocking_multiple_provides3.dzn:
	Make requires outer shell ports external; insert external adapters to
	maintain the collateral blocking notion.
	* test/all/collateral_blocking_reorder_parallel/main.cc,
	test/all/collateral_blocking_reorder_parallel/main.cs: Remove
	extraneous pump and replace sut.mp.r.out.world by sut.r.out.world.
	* test/all/blocking_multiple_provides3/trace: Change trace
	correspondingly.
	* test/all/blocking_multiple_provides2/main.cc,
	test/all/blocking_multiple_provides2/main.cs: Hmm, fudging the outcome
	using sleeps.

2023-09-22  Rutger van Beusekom  <rutger@dezyne.org>

	test: collateral_blocking_bridges: Reorder models.
	* test/all/collateral_blocking_bridges/collateral_blocking_bridges.dzn:
	Reorder the models in the call hierarchy.

2023-09-25  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Run external <q-out> events through component queue.
	This removes long standing shortcut for executing external events.

	* dzn/vm/util.scm (label->string): Handle <q-out>.
	(trigger-in-q?): New procedure.
	* dzn/vm/report.scm (pc-event? <runtime:port> <q-in>,
	pc-event? <runtime:component> <q-in>,
	pc->event <runtime:component> <q-in>,
	pc->arrow <runtime:port> <q-in>): New methods.
	(pc-event? <runtime:component> <q-out>): Make unobservable for external port .
	(pc-arrow? <runtime:component> <q-in>): Remove.
	(complete-split-arrows-pcs): Also complete q-in event.
	* dzn/vm/run.scm (run-external-modeling)[event-executed]: New inner
	function.  Use it to filter traces.
	(run-external-q): Instead of running <q-out> trigger from external-q
	directly on component, create <q-in> and enqueue it in component.
	(run-requires-flush): New method, factored-out from...
	(run-requires): ...here.
	(run-to-completion*): Use it to flush <q-in> in component queue.
	* dzn/vm/compliance.scm (check-provides-compliance): Cater for trigger
	in system.
	* dzn/vm/step.scm (begin-step): Cater for blocked rtc pc without instance.
	* dzn/explore.scm (process-external): Likewise.
	* test/all/compliance_external_inevitable/baseline/simulate.out:
	test/all/illegal_external_inevitable/baseline/simulate.out:
	test/all/illegal_external_requires_twice/baseline/simulate.out:
	test/all/illegal_external_requires_twice2/baseline/simulate.out:
	test/all/illegal_pessimism_external/baseline/simulate.out:
	test/all/semantics/baseline/semantics.org: Update baseline.

	Co-authored-byy: Rutger van Beusekom <rutger@dezyne.org>.

2023-09-27  Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Whitespace fixes.
	* dzn/vm/run.scm (run-to-completion*): Add newline before straddling <>.
	Throughout, remove inline extra space.

2023-09-21  Rutger van Beusekom  <rutger@dezyne.org>

	c++: Initialize meta name defaults for port and component.
	* dzn/code/scmackerel/c++.scm
	(component-model->sm:statements-unmemoized,
	system->sm:statements-unmemoized,
	shell-system->sm:statements-unmemoized): Replace "" with name.
	* test/all/LegoBallSorter/main.cc,
	test/all/blocking_binding/main.cc,
	test/all/blocking_double_release/main.cc,
	test/all/blocking_multiple_provides2/main.cc,
	test/all/blocking_multiple_provides3/main.cc,
	test/all/blocking_release/main.cc,
	test/all/blocking_shell/c++/main.cc,
	test/all/blocking_system_diamond/main.cc,
	test/all/calling_context/main.cc,
	test/all/collateral_blocking_backdoor/main.cc,
	test/all/collateral_blocking_bridges/main.cc,
	test/all/collateral_blocking_double_release/main.cc,
	test/all/collateral_blocking_multiple_provides/main.cc,
	test/all/collateral_blocking_multiple_provides0/main.cc,
	test/all/collateral_blocking_release/main.cc,
	test/all/collateral_blocking_reorder/main.cc,
	test/all/collateral_blocking_reorder_parallel/main.cc,
	test/all/collateral_blocking_shell/main.cc,
	test/all/collateral_blocking_shell2/main.cc,
	test/all/collateral_double_blocked/main.cc,
	test/all/data_full/main.cc,
	test/all/defer_data/main.cc,
	test/all/double_collateral_blocking_shell/main.cc,
	test/all/exception_wrappers/c++/main.cc,
	test/all/foreign_optional/c++/main.cc,
	test/all/foreign_requires/c++/main.cc,
	test/all/hello_check_bindings/main.cc,
	test/all/pump_twice/main.cc,
	test/all/shared_glue/main.cc,
	test/all/space.wostream/main.cc,
	test/all/sync_out_reply_binding/main.cc,
	test/all/system_check_bindings/main.cc,
	test/all/wostream/main.cc: Replace explicit meta names by default meta
	names.

2023-09-21  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Add closed_system_foreigns.
	* test/all/closed_system_foreigns/closed_system_foreigns.dzn: New test.
	* test/all/closed_system_foreigns/world.hh,
	test/all/foreign_only/foreign.hh: Foreign implementations for C++.
	* test/all/closed_system_foreigns/META: New file.
	* test/all/local.mk (REGRESSION_TESTS): Add test.

	c++: Cater for closed system with foreigns.
	* dzn/code/scmackerel/c++.scm (system->sm:statements-unmemoized): Skip
	generate instance assignments for instances only bound to an interal
	requires port.

2023-09-21  Rutger van Beusekom  <rutger@dezyne.org>

	test: Use name defaults for shared_glue system and ports.
	* test/all/shared_glue/main.cc (main): Remove explicit name string
	assignements.

	c++: Use component type as default for the instance name.
	* dzn/code/scmackerel/c++.scm
	(component-model->sm:statements-unmemoized,
	system->sm:statements-unmemoized,
	shell-system->sm:statements-unmemoized): Replace "" with name.

	c++: Remove overwriting event slots, fixes check_bindings.
	* dzn/code/scmackerel/c++.scm (system->sm:statements-unmemoized): Remove
	trigger->event-slot and its usage.

	test: Add queuefull_constraint_defer.
	* test/all/queuefull_constraint_defer: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	vm: Fix interface-constrained defer with queue-full.
	* dzn/vm/compliance.scm (zip): Prioritize constraining illegals over
	defer queue full.

2023-09-20  Rutger van Beusekom  <rutger@dezyne.org>
	    Janneke Nieuwenhuizen  <janneke@gnu.org>

	vm: Flush after defer.
	* dzn/vm/run.scm (run-defer-event): Run flush unless collateral'ly-blocked.

2023-09-18  Janneke Nieuwenhuizen  <janneke@gnu.org>

	verify: Switch to perfect-funcq for memoization.
	* dzn/verify/pipeline.scm (root+model->makreel): Use perfect-funcq
	instead of pure-funcq.
	(memoizing-verify-pipeline): Likewise.

2023-09-20  Paul Hoogendijk  <paul@dezyne.org>

	Switch to perfect-funcq for memoization.
	* dzn/ast/lookup.scm (ast:perfect-funcq): Bump hash table to 1024.
	Throughout, use ast:perfect-funcq.

	lookup: Cater for DAG instead of tree in variable lookup.
	* dzn/ast/lookup.scm: (ast:lookup-variable) Add local funcion path->key
	and replace root of node by its path.

2023-08-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	goops: Have clone always return a fresh object.
	* dzn/ast/util.scm (clone-base): Always return a fresh object.

2023-09-20  Paul Hoogendijk  <paul@dezyne.org>

	Add test reuse_body.
	* test/all/reuse_body/reuse_body.dzn: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

2023-09-19  Rutger van Beusekom  <rutger@dezyne.org>

	test: blocking_shell: Fix instability.
	* test/all/blocking_shell/c++/main.cc (main): Add missing mutex, fixes
	error under load.

	test: Add shared_type_lookup.
	* test/all/shared_type_lookup/shared_type_lookup.dzn,
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	lookup: Fix .type lookup for <shared-field-test>.
	* dzn/ast/lookup.scm (.type): Remove searching for shared state variable
	type in the component behavior.

	test: Add shared_state_defer.
	* test/all/shared_state_defer/shared_state_defer.dzn,
	* test/all/local.mk (REGRESSION_TESTS): Add it.
	* test/all/shared_state_defer/trace: Add trace.

	test: Add shared_glue.
	* test/all/shared_glue/shared_glue.dzn,
	* test/all/local.mk (REGRESSION_TESTS): Add it.
	* test/all/shared_glue/trace: Add trace.
	* test/all/shared_glue/main.cc: Add handwritten main.

	test: Add system_shared_glue.
	* test/all/system_shared_defer/system_shared_defer.dzn,
	* test/all/local.mk (REGRESSION_TESTS): Add it.
	* test/all/system_shared_defer/trace: Add trace.

2023-09-18  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Fix updating unbound provides port.
	* runtime/c++/dzn/runtime.hh (wrap_out): Move component->dzn right after
	enqueued out event execution, instead of after enqueueing but before
	execution.

2023-09-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	c++: Add another missing this->.
	This is a follow-up to commit
	    7eb00448d008be3766c4ba617c7b9fa79259cc67
	    c++: Introduce foreign skeleton helper method for out events.

	* dzn/code/scmackerel/c++.scm
	(component-model->sm:statements-unmemoized): Add
	missing (%member-prefix).  Also use code:event-name and
	code:event-slot-name instead of inline name assembly.

2023-09-15  Paul Hoogendijk  <paul@dezyne.org>

	test: wf_functionTailRecursion: Add check for non-tail recursive call.
	* test/all/wf_functionTailRecursion/wf_functionTailRecursion.dzn
	(Intf11): Check that non-recursive, non-tail call does not produce
	error.
	* test/all/wf_functionTailRecursion/baseline/verify.err: Update baseline
	because of extra copyright line in header.

	wfc: In recursive function, allow statement after non-recursive call.
	* dzn/ast/wfc.scm (tail-recursion): Also check that called function is
	recursive.

2023-09-15  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: wf_functionTailRecursion: Two more checks for statement after return.
	* test/all/wf_functionTailRecursion/wf_functionTailRecursion.dzn: Check
	for void return after tail recursive call, and for statement after that.
	* test/all/wf_functionTailRecursion/baseline/verify.err: Update baseline.

	wfc: Allow void return after retursive tail call.
	* dzn/ast/wfc.scm (tail-recursion): Do not warn if last continuation
	statement is a return, and has no continuation itself.

2023-09-15  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add parse_defer_shared.
	* test/all/parse_defer_shared/parse_defer_shared.dzn: Add model.
	* test/all/parse_defer_shared/baseline/verify.err: Add error baseline.
	* test/all/local.mk (PARSER_TESTS): Add test.

	wfc: Add well-formedness check for defer capture of shared state.
	* dzn/ast/wfc.scm (wfc-defer-argument): Add <shared> cond case.

2023-09-12  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add unreachable_multiple_provides.
	* test/all/local.mk (REGRESSION_TESTS): Add it.
	* test/all/unreachable_multiple_provides/unreachable_multiple_provides.dzn:
	Add it.
	* test/all/unreachable_multiple_provides/baseline/verify.err,
	test/all/unreachable_multiple_provides/baseline/verify.out: Add baseline.

	verify: Do not skip compliance check if only unreachable error.
	* dzn/verify/pipeline.scm (report-fail): Let report-fail return #f if
	unreachable?

2023-09-19  Janneke Nieuwenhuizen  <janneke@gnu.org>

	runtime :c++: Whitespace fixes.
	* runtime/c++/dzn/runtime.hh (runtime_wrapper): Remove gratuitous braces.
	(call_out): Remove extra space.

2023-09-11  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Require all tasks to be idle at thread pool destruction.
	* runtime/c++/thread-pool.cc (pool::~pool): Add destructor; abort upon error.
	(task::tastk~): Once more, join instead of detach.

2023-09-09  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Help help2man generate reproducible man-pages.
	* Makefile.am (SOURCE_DATE_EPOCH): New variable.

2023-09-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	guix: dezyne: Update to 2.18.0.rc6.
	* guix/pack/dezyne.scm (dezyne): Update to 2.18.0.rc6.

2023-09-03  Janneke Nieuwenhuizen  <janneke@gnu.org>

	doc: Update `ANNOUNCE-2.18.0'.
	* doc/announce/ANNOUNCE-2.18.0: Update from NEWS.

	doc: Update `NEWS'.
	* NEWS (Changes in 2.18.0 since 2.17.3): Mention installation of headers
	and libdzn, libdnz-c++ libraries and std:async.cc, thread-pool.  Remove
	delayed parser refactoring.

2023-09-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Ensure generated file reproducibility for dist.
	* Makefile.am (override $(srcdir)/doc/stamp-vti): New target override.
	(man-clean): New target.
	(auto-clean): Depend on it in new target.
	(dist-hook): Depend on it.

2023-09-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	code: When uninstalled, use .scm from %load-path for languages list.
	This fixes source tarball reproducibility of doc/dzn-code.1.

	* dzn/commands/code.scm (list-languages): Look at .scm files instead of
	.go files when DZN_UNINSTALLED.

2023-09-08  Janneke Nieuwenhuizen  <janneke@gnu.org>

	dzn: When uninstalled, use .scm from %load-path for commands list.
	This fixes source tarball reproducibility of doc/dzn.1.

	* dzn/script.scm (parse-opts)[list-commands]: Look at .scm files instead
	of .go files when DZN_UNINSTALLED.

2023-09-06  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Update .mailmap
	* .mailmap: Add duplicated addresses.

2023-09-07  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Detach living threads at pool destruction.
	* runtime/c++/thread-pool.cc (pool::tasks_): Replace shared_ptr with
	unique_ptr.
	(pool::con_): Remove.
	(pool::~pool): Remove.
	(pool::async): Replace push_back with emplace_back.
	(pool::capacity): Rename to...
	(pool::size) ...this.
	(dzn::thread_pool_size): Use it in new function to retrieve the thread
	pool size.
	(pool::idle): Remove condition_variable notify.
	(task::~task): Detach instead of join.
	(task::self): Make private.
	(task::worker): Likewise.  Move lock.lock() before moving the task into #
	the idle queue and resolving the promise.
	(dzn::thread_pool): New function that extracts the creation and access
	to the singleton thread pool.
	(dzn::async): Use it in new function.

2023-09-06  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Make thread-pool usage link-time switchable.
	Move dzn::thread::defer definition into a source file.

	* build-aux/config.make.in (DZN_THREAD_POOL): Remove.
	* runtime/c++/dzn/config.hh.in: Likewise.
	* configure.ac: Do not substitute it.
	* runtime/c++/dzn/context.hh (dzn::thread::defer): Move to ...
	* runtime/c++/dzn/async.hh: ...this new file, and...
	* runtime/c++/std-async.cc: ...this new file.
	* runtime/c++/thread_pool.cc: Rename to...
	* runtime/c++/thread-pool.cc: ...this.
	* runtime/local.mk (dist_runtime_cxx_DATA): Update accordingly.
	(%C%_libdzn_c___la_SOURCES): Use either std-async.cc or thread-pool.cc,
	depending on dzn_thread_pool conditional.
	(dist_runtime_cxx_dzn_DATA): Add dzn/async.hh.

2023-09-06  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: c++: Use dzn::thread::defer in pump.
	It has been observed that std::async has arbitrary limits on some
	microsoft systems.  The dzn::thread::pool has no arbitrary limits,
	except for being limited by the available system resources.

	* runtime/c++/pump.cc (pump::pump): Replace std::async with
	dzn::thread::defer indirection that allows switching between std::async
	and the dzn::thread::pool.

2023-09-05  Rutger van Beusekom  <rutger@dezyne.org>

	test: Add system_foreign_only.

	test: Add foreign_only.
	* test/all/foreign_only: New test.
	* test/all/local.mk (REGRESSION_TESTS): Add it.

	c++: Introduce foreign skeleton helper method for out events.
	* dzn/code/scmackerel/c++.scm (component-model->sm:statements-unmemoized)
	[out->method]: New procedure to generate foreign skeleton helper
	methods.

2023-09-05  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Check for std::mutex.
	* configure.ac: Check for <mutex> and std::mutex.
	* runtime/local.mk: Only build library when we have mutex.

2023-09-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: Do not remove meta-events from component ouput trail for C++.
	* dzn/commands/trace.scm (parse-opts): Add -m,--meta.
	(main): Pass it as #:meta? to...
	* dzn/trace.scm (trace:format-trace): ...here.  Add new keyword
	parameter #:meta? and pass it to...
	(steps->trail): ...here.  Likewise, add new keyword parameter #:meta?
	and keep any meta-event when set.
	* test/dzn/dzn.scm (run-execute): Use it to keep meta-events.  Do not
	remove flush from the input trail.
	* doc/dezyne.texi (Invoking dzn trace): Document it.

	c++: Reformat <illegal> handler message.
	* runtime/c++/dzn/locator.hh (illegal): Rename msg parameter to
	location.  Output location first.
	* runtime/c++/dzn/container.hh (container): Likewise, also add dummy
	zero column.

	build: Install `hello' and `cruise-control' as examples.
	* test/all/local.mk (dzn_exampledir, nodist_dzn_example_DATA): New
	variables.

	test: cruise-control: Rename from cruise_control.
	* test/all/cruise_control: Rename to...
	* test/all/cruise-control: ...this.
	* test/all/local.mk (REGRESSION_TESTS): Update accordingly.

	test: Support using `-' in test name.
	* test/dzn/dzn.scm (file->model): New procedure to translate "-" to "_".
	(run-verify, run-code, run-traces, run-constrained-component,
	run-constrained-no-compliance, run-simulate-trace, run-lts): Use it.

2023-09-04  Rutger van Beusekom  <rutger@dezyne.org>

	runtime: Relax the type strictness on dzn::connect.
	* runtime/c++/dzn/runtime.hh (connect): Rename template parameter Port
	to P for provides and add and use template parameter R for requires.

	c++: Move provides port update, fixes shared_async_provides.
	* runtime/c++/dzn/runtime.hh (call_out): Move port.dzn_update_state ...
	(wrap_out): ...to here as component->dzn_update ...
	* dzn/code/scmackerel/c++.scm (component-model->sm:statements-unmemoized):
	Add dzn_update to component.
	* dzn/code/scmackerel/c++.scm (interface->sm:statements-unmemoized):
	Ignore dzn_state_update in port for empty prefixes.

2023-09-03  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Add --disable-c++-thread-pool to configure.
	* configure.ac: Add --disable-c++-thread-pool option.
	* build-aux/config.make.in (DZN_THREAD_POOL): New variable.
	runtime/c++/dzn/config.hh.in (DZN_THREAD_POOL): Substitute it.
	* doc/dezyne.texi (Hello World!): Remove -I runtime/c++, replace
	runtime/c++/pump.cc runtime/c++/runtime.cc with -ldzn-c++.

	guix: dezyne: Add boost.
	* guix/pack/dezyne.scm (dezyne)[inputs]: Add boost.

	doc: Mention boost as optional dependency.
	* README (Requirements): Mention boost.
	* doc/dezyne.texi (Requirements): Likewise.
	:

	build: Check for boost-coroutine.
	* build-aux/ax_pthread.m4: New file.
	* runtime/c++/dzn/config.hh.in: New file.
	* runtime/local.mk (dist_noinst_DATA): Add it.
	* configure.ac: Substitute it to config.hh.  Check for boost-coroutine
	and poix threads.
	* runtime/local.mk (dist_noinst_DATA): Add it.
	* runtime/c++/dzn/container.hh,
	runtime/c++/dzn/context.hh,
	runtime/c++/dzn/coroutine.hh,
	runtime/c++/dzn/meta.hh.in,
	runtime/c++/dzn/locator.hh,
	runtime/c++/dzn/meta.hh.in,
	runtime/c++/dzn/pump.hh,
	runtime/c++/dzn/runtime.hh: Include it.
	* build-aux/config.make.in (HAVE_BOOST_COROUTINE, LIBBOOST_COROUTINE,
	PTHREAD_CFLAGS): New variables.
	* test/lib/build.c++.make (LIBPTHREAD): Remove.
	(TEST_CXXFLAGS): Add $(PTHREAD_CFLAGS).
	(DEFINES): Remove.
	(LDFLAGS): Add $(LIBBOOST_COROUTINE).

2023-09-04  Janneke Nieuwenhuizen  <janneke@gnu.org>

	build: Silence configure warnings from setting C*FLAGS defaults.
	* configure.ac: Prefix CFLAGS, CXXFLAGS default with `:'.

2023-09-03  Janneke Nieuwenhuizen  <janneke@gnu.org>

	test: blocking_system_diamond: Avoid conflict with standard library.
	* test/all/blocking_system_diamond/blocking_system_diamond.dzn (fork):
	Rename to ...
	(fork_event): ...this.

	doc: Mention libtool dependency.
	* README (Requirements): Mention libtool.
	* doc/dezyne.texi (Building from Git): Likewise.

	build: Build and install C and C++ headers and libraries.
	TODO
	  * pkg-config files for libdzn, libdzn-c++?
	  * remove installation in share/dezyne/runtime/?

